/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2016 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
/**
@license
mersenne-twister.js - https://gist.github.com/banksean/300494

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote
        products derived from this software without specific prior written
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

!function(){define("Core/defined",[],function(){"use strict";function e(e){return void 0!==e&&null!==e}return e}),define("Core/freezeObject",["./defined"],function(e){"use strict";var r=Object.freeze;return e(r)||(r=function(e){return e}),r}),define("Core/defaultValue",["./freezeObject"],function(e){"use strict";function r(e,r){return void 0!==e?e:r}return r.EMPTY_OBJECT=e({}),r}),define("Core/DeveloperError",["./defined"],function(e){"use strict";function r(e){this.name="DeveloperError",this.message=e;var r;try{throw new Error}catch(e){r=e.stack}this.stack=r}return e(Object.create)&&(r.prototype=Object.create(Error.prototype),r.prototype.constructor=r),r.prototype.toString=function(){var r=this.name+": "+this.message;return e(this.stack)&&(r+="\n"+this.stack.toString()),r},r.throwInstantiationError=function(){throw new r("This function defines an interface and should not be called directly.")},r}),define("ThirdParty/mersenne-twister",[],function(){var e=function(e){void 0==e&&(e=(new Date).getTime()),this.N=624,this.M=397,this.MATRIX_A=2567483615,this.UPPER_MASK=2147483648,this.LOWER_MASK=2147483647,this.mt=new Array(this.N),this.mti=this.N+1,this.init_genrand(e)};return e.prototype.init_genrand=function(e){for(this.mt[0]=e>>>0,this.mti=1;this.mti<this.N;this.mti++){var e=this.mt[this.mti-1]^this.mt[this.mti-1]>>>30;this.mt[this.mti]=(1812433253*((4294901760&e)>>>16)<<16)+1812433253*(65535&e)+this.mti,this.mt[this.mti]>>>=0}},e.prototype.genrand_int32=function(){var e,r=new Array(0,this.MATRIX_A);if(this.mti>=this.N){var t;for(this.mti==this.N+1&&this.init_genrand(5489),t=0;t<this.N-this.M;t++)e=this.mt[t]&this.UPPER_MASK|this.mt[t+1]&this.LOWER_MASK,this.mt[t]=this.mt[t+this.M]^e>>>1^r[1&e];for(;t<this.N-1;t++)e=this.mt[t]&this.UPPER_MASK|this.mt[t+1]&this.LOWER_MASK,this.mt[t]=this.mt[t+(this.M-this.N)]^e>>>1^r[1&e];e=this.mt[this.N-1]&this.UPPER_MASK|this.mt[0]&this.LOWER_MASK,this.mt[this.N-1]=this.mt[this.M-1]^e>>>1^r[1&e],this.mti=0}return e=this.mt[this.mti++],e^=e>>>11,e^=e<<7&2636928640,e^=e<<15&4022730752,e^=e>>>18,e>>>0},e.prototype.random=function(){return this.genrand_int32()*(1/4294967296)},e}),define("Core/Math",["../ThirdParty/mersenne-twister","./defaultValue","./defined","./DeveloperError"],function(e,r,t,n){"use strict";var o={};o.EPSILON1=.1,o.EPSILON2=.01,o.EPSILON3=.001,o.EPSILON4=1e-4,o.EPSILON5=1e-5,o.EPSILON6=1e-6,o.EPSILON7=1e-7,o.EPSILON8=1e-8,o.EPSILON9=1e-9,o.EPSILON10=1e-10,o.EPSILON11=1e-11,o.EPSILON12=1e-12,o.EPSILON13=1e-13,o.EPSILON14=1e-14,o.EPSILON15=1e-15,o.EPSILON16=1e-16,o.EPSILON17=1e-17,o.EPSILON18=1e-18,o.EPSILON19=1e-19,o.EPSILON20=1e-20,o.GRAVITATIONALPARAMETER=3986004418e5,o.SOLAR_RADIUS=6955e5,o.LUNAR_RADIUS=1737400,o.SIXTY_FOUR_KILOBYTES=65536,o.sign=function(e){return e>0?1:e<0?-1:0},o.signNotZero=function(e){return e<0?-1:1},o.toSNorm=function(e,t){return t=r(t,255),Math.round((.5*o.clamp(e,-1,1)+.5)*t)},o.fromSNorm=function(e,t){return t=r(t,255),o.clamp(e,0,t)/t*2-1},o.sinh=function(e){var r=Math.pow(Math.E,e),t=Math.pow(Math.E,-1*e);return.5*(r-t)},o.cosh=function(e){var r=Math.pow(Math.E,e),t=Math.pow(Math.E,-1*e);return.5*(r+t)},o.lerp=function(e,r,t){return(1-t)*e+t*r},o.PI=Math.PI,o.ONE_OVER_PI=1/Math.PI,o.PI_OVER_TWO=.5*Math.PI,o.PI_OVER_THREE=Math.PI/3,o.PI_OVER_FOUR=Math.PI/4,o.PI_OVER_SIX=Math.PI/6,o.THREE_PI_OVER_TWO=3*Math.PI*.5,o.TWO_PI=2*Math.PI,o.ONE_OVER_TWO_PI=1/(2*Math.PI),o.RADIANS_PER_DEGREE=Math.PI/180,o.DEGREES_PER_RADIAN=180/Math.PI,o.RADIANS_PER_ARCSECOND=o.RADIANS_PER_DEGREE/3600,o.toRadians=function(e){return e*o.RADIANS_PER_DEGREE},o.toDegrees=function(e){return e*o.DEGREES_PER_RADIAN},o.convertLongitudeRange=function(e){var r=o.TWO_PI,t=e-Math.floor(e/r)*r;return t<-Math.PI?t+r:t>=Math.PI?t-r:t},o.clampToLatitudeRange=function(e){return o.clamp(e,-1*o.PI_OVER_TWO,o.PI_OVER_TWO)},o.negativePiToPi=function(e){return o.zeroToTwoPi(e+o.PI)-o.PI},o.zeroToTwoPi=function(e){var r=o.mod(e,o.TWO_PI);return Math.abs(r)<o.EPSILON14&&Math.abs(e)>o.EPSILON14?o.TWO_PI:r},o.mod=function(e,r){return(e%r+r)%r},o.equalsEpsilon=function(e,t,n,o){o=r(o,n);var a=Math.abs(e-t);return a<=o||a<=n*Math.max(Math.abs(e),Math.abs(t))};var a=[1];o.factorial=function(e){var r=a.length;if(e>=r)for(var t=a[r-1],n=r;n<=e;n++)a.push(t*n);return a[e]},o.incrementWrap=function(e,t,n){return n=r(n,0),++e,e>t&&(e=n),e},o.isPowerOfTwo=function(e){return 0!==e&&0===(e&e-1)},o.nextPowerOfTwo=function(e){return--e,e|=e>>1,e|=e>>2,e|=e>>4,e|=e>>8,e|=e>>16,++e,e},o.clamp=function(e,r,t){return e<r?r:e>t?t:e};var i=new e;return o.setRandomNumberSeed=function(r){i=new e(r)},o.nextRandomNumber=function(){return i.random()},o.acosClamped=function(e){return Math.acos(o.clamp(e,-1,1))},o.asinClamped=function(e){return Math.asin(o.clamp(e,-1,1))},o.chordLength=function(e,r){return 2*r*Math.sin(.5*e)},o.logBase=function(e,r){return Math.log(e)/Math.log(r)},o.fog=function(e,r){var t=e*r;return 1-Math.exp(-(t*t))},o}),define("Core/Cartesian3",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,r,t,n,o){"use strict";function a(r,t,n){this.x=e(r,0),this.y=e(t,0),this.z=e(n,0)}a.fromSpherical=function(t,n){r(n)||(n=new a);var o=t.clock,i=t.cone,u=e(t.magnitude,1),s=u*Math.sin(i);return n.x=s*Math.cos(o),n.y=s*Math.sin(o),n.z=u*Math.cos(i),n},a.fromElements=function(e,t,n,o){return r(o)?(o.x=e,o.y=t,o.z=n,o):new a(e,t,n)},a.clone=function(e,t){if(r(e))return r(t)?(t.x=e.x,t.y=e.y,t.z=e.z,t):new a(e.x,e.y,e.z)},a.fromCartesian4=a.clone,a.packedLength=3,a.pack=function(r,t,n){return n=e(n,0),t[n++]=r.x,t[n++]=r.y,t[n]=r.z,t},a.unpack=function(t,n,o){return n=e(n,0),r(o)||(o=new a),o.x=t[n++],o.y=t[n++],o.z=t[n],o},a.packArray=function(e,t){var n=e.length;r(t)?t.length=3*n:t=new Array(3*n);for(var o=0;o<n;++o)a.pack(e[o],t,3*o);return t},a.unpackArray=function(e,t){var n=e.length;r(t)?t.length=n/3:t=new Array(n/3);for(var o=0;o<n;o+=3){var i=o/3;t[i]=a.unpack(e,o,t[i])}return t},a.fromArray=a.unpack,a.maximumComponent=function(e){return Math.max(e.x,e.y,e.z)},a.minimumComponent=function(e){return Math.min(e.x,e.y,e.z)},a.minimumByComponent=function(e,r,t){return t.x=Math.min(e.x,r.x),t.y=Math.min(e.y,r.y),t.z=Math.min(e.z,r.z),t},a.maximumByComponent=function(e,r,t){return t.x=Math.max(e.x,r.x),t.y=Math.max(e.y,r.y),t.z=Math.max(e.z,r.z),t},a.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z},a.magnitude=function(e){return Math.sqrt(a.magnitudeSquared(e))};var i=new a;a.distance=function(e,r){return a.subtract(e,r,i),a.magnitude(i)},a.distanceSquared=function(e,r){return a.subtract(e,r,i),a.magnitudeSquared(i)},a.normalize=function(e,r){var t=a.magnitude(e);return r.x=e.x/t,r.y=e.y/t,r.z=e.z/t,r},a.dot=function(e,r){return e.x*r.x+e.y*r.y+e.z*r.z},a.multiplyComponents=function(e,r,t){return t.x=e.x*r.x,t.y=e.y*r.y,t.z=e.z*r.z,t},a.add=function(e,r,t){return t.x=e.x+r.x,t.y=e.y+r.y,t.z=e.z+r.z,t},a.subtract=function(e,r,t){return t.x=e.x-r.x,t.y=e.y-r.y,t.z=e.z-r.z,t},a.multiplyByScalar=function(e,r,t){return t.x=e.x*r,t.y=e.y*r,t.z=e.z*r,t},a.divideByScalar=function(e,r,t){return t.x=e.x/r,t.y=e.y/r,t.z=e.z/r,t},a.negate=function(e,r){return r.x=-e.x,r.y=-e.y,r.z=-e.z,r},a.abs=function(e,r){return r.x=Math.abs(e.x),r.y=Math.abs(e.y),r.z=Math.abs(e.z),r};var u=new a;a.lerp=function(e,r,t,n){return a.multiplyByScalar(r,t,u),n=a.multiplyByScalar(e,1-t,n),a.add(u,n,n)};var s=new a,c=new a;a.angleBetween=function(e,r){a.normalize(e,s),a.normalize(r,c);var t=a.dot(s,c),n=a.magnitude(a.cross(s,c,s));return Math.atan2(n,t)};var l=new a;a.mostOrthogonalAxis=function(e,r){var t=a.normalize(e,l);return a.abs(t,t),r=t.x<=t.y?t.x<=t.z?a.clone(a.UNIT_X,r):a.clone(a.UNIT_Z,r):t.y<=t.z?a.clone(a.UNIT_Y,r):a.clone(a.UNIT_Z,r)},a.equals=function(e,t){return e===t||r(e)&&r(t)&&e.x===t.x&&e.y===t.y&&e.z===t.z},a.equalsArray=function(e,r,t){return e.x===r[t]&&e.y===r[t+1]&&e.z===r[t+2]},a.equalsEpsilon=function(e,t,n,a){return e===t||r(e)&&r(t)&&o.equalsEpsilon(e.x,t.x,n,a)&&o.equalsEpsilon(e.y,t.y,n,a)&&o.equalsEpsilon(e.z,t.z,n,a)},a.cross=function(e,r,t){var n=e.x,o=e.y,a=e.z,i=r.x,u=r.y,s=r.z,c=o*s-a*u,l=a*i-n*s,E=n*u-o*i;return t.x=c,t.y=l,t.z=E,t},a.fromDegrees=function(e,r,t,n,i){return e=o.toRadians(e),r=o.toRadians(r),a.fromRadians(e,r,t,n,i)};var E=new a,f=new a,m=new a(40680631590769,40680631590769,40408299984661.445);return a.fromRadians=function(t,n,o,i,u){o=e(o,0);var s=r(i)?i.radiiSquared:m,c=Math.cos(n);E.x=c*Math.cos(t),E.y=c*Math.sin(t),E.z=Math.sin(n),E=a.normalize(E,E),a.multiplyComponents(s,E,f);var l=Math.sqrt(a.dot(E,f));return f=a.divideByScalar(f,l,f),E=a.multiplyByScalar(E,o,E),r(u)||(u=new a),a.add(f,E,u)},a.fromDegreesArray=function(e,t,n){var o=e.length;r(n)?n.length=o/2:n=new Array(o/2);for(var i=0;i<o;i+=2){var u=e[i],s=e[i+1],c=i/2;n[c]=a.fromDegrees(u,s,0,t,n[c])}return n},a.fromRadiansArray=function(e,t,n){var o=e.length;r(n)?n.length=o/2:n=new Array(o/2);for(var i=0;i<o;i+=2){var u=e[i],s=e[i+1],c=i/2;n[c]=a.fromRadians(u,s,0,t,n[c])}return n},a.fromDegreesArrayHeights=function(e,t,n){var o=e.length;r(n)?n.length=o/3:n=new Array(o/3);for(var i=0;i<o;i+=3){var u=e[i],s=e[i+1],c=e[i+2],l=i/3;n[l]=a.fromDegrees(u,s,c,t,n[l])}return n},a.fromRadiansArrayHeights=function(e,t,n){var o=e.length;r(n)?n.length=o/3:n=new Array(o/3);for(var i=0;i<o;i+=3){var u=e[i],s=e[i+1],c=e[i+2],l=i/3;n[l]=a.fromRadians(u,s,c,t,n[l])}return n},a.ZERO=n(new a(0,0,0)),a.UNIT_X=n(new a(1,0,0)),a.UNIT_Y=n(new a(0,1,0)),a.UNIT_Z=n(new a(0,0,1)),a.prototype.clone=function(e){return a.clone(this,e)},a.prototype.equals=function(e){return a.equals(this,e)},a.prototype.equalsEpsilon=function(e,r,t){return a.equalsEpsilon(this,e,r,t)},a.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+")"},a}),define("Core/scaleToGeodeticSurface",["./Cartesian3","./defined","./DeveloperError","./Math"],function(e,r,t,n){"use strict";function o(t,o,u,s,c){var l=t.x,E=t.y,f=t.z,m=o.x,h=o.y,d=o.z,p=l*l*m*m,T=E*E*h*h,R=f*f*d*d,A=p+T+R,_=Math.sqrt(1/A),y=e.multiplyByScalar(t,_,a);if(A<s)return isFinite(_)?e.clone(y,c):void 0;var S=u.x,N=u.y,C=u.z,v=i;v.x=y.x*S*2,v.y=y.y*N*2,v.z=y.z*C*2;var g,I,M,O,L,F,P,w,D,x,U,b=(1-_)*e.magnitude(t)/(.5*e.magnitude(v)),B=0;do{b-=B,M=1/(1+b*S),O=1/(1+b*N),L=1/(1+b*C),F=M*M,P=O*O,w=L*L,D=F*M,x=P*O,U=w*L,g=p*F+T*P+R*w-1,I=p*D*S+T*x*N+R*U*C;var G=-2*I;B=g/G}while(Math.abs(g)>n.EPSILON12);return r(c)?(c.x=l*M,c.y=E*O,c.z=f*L,c):new e(l*M,E*O,f*L)}var a=new e,i=new e;return o}),define("Core/Cartographic",["./Cartesian3","./defaultValue","./defined","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(e,r,t,n,o,a,i){"use strict";function u(e,t,n){this.longitude=r(e,0),this.latitude=r(t,0),this.height=r(n,0)}u.fromRadians=function(e,n,o,a){return o=r(o,0),t(a)?(a.longitude=e,a.latitude=n,a.height=o,a):new u(e,n,o)},u.fromDegrees=function(e,r,t,n){return e=a.toRadians(e),r=a.toRadians(r),u.fromRadians(e,r,t,n)};var s=new e,c=new e,l=new e,E=new e(1/6378137,1/6378137,1/6356752.314245179),f=new e(1/40680631590769,1/40680631590769,1/40408299984661.445),m=a.EPSILON1;return u.fromCartesian=function(r,n,o){var h=t(n)?n.oneOverRadii:E,d=t(n)?n.oneOverRadiiSquared:f,p=t(n)?n._centerToleranceSquared:m,T=i(r,h,d,p,c);if(t(T)){var R=e.multiplyComponents(r,d,s);R=e.normalize(R,R);var A=e.subtract(r,T,l),_=Math.atan2(R.y,R.x),y=Math.asin(R.z),S=a.sign(e.dot(A,r))*e.magnitude(A);return t(o)?(o.longitude=_,o.latitude=y,o.height=S,o):new u(_,y,S)}},u.clone=function(e,r){if(t(e))return t(r)?(r.longitude=e.longitude,r.latitude=e.latitude,r.height=e.height,r):new u(e.longitude,e.latitude,e.height)},u.equals=function(e,r){return e===r||t(e)&&t(r)&&e.longitude===r.longitude&&e.latitude===r.latitude&&e.height===r.height},u.equalsEpsilon=function(e,r,n){return e===r||t(e)&&t(r)&&Math.abs(e.longitude-r.longitude)<=n&&Math.abs(e.latitude-r.latitude)<=n&&Math.abs(e.height-r.height)<=n},u.ZERO=o(new u(0,0,0)),u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.prototype.equalsEpsilon=function(e,r){return u.equalsEpsilon(this,e,r)},u.prototype.toString=function(){return"("+this.longitude+", "+this.latitude+", "+this.height+")"},u}),define("Core/defineProperties",["./defined"],function(e){"use strict";var r=function(){try{return"x"in Object.defineProperty({},"x",{})}catch(e){return!1}}(),t=Object.defineProperties;return r&&e(t)||(t=function(e){return e}),t}),define("Core/Ellipsoid",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(e,r,t,n,o,a,i,u,s){"use strict";function c(r,n,o,a){n=t(n,0),o=t(o,0),a=t(a,0),r._radii=new e(n,o,a),r._radiiSquared=new e(n*n,o*o,a*a),r._radiiToTheFourth=new e(n*n*n*n,o*o*o*o,a*a*a*a),r._oneOverRadii=new e(0===n?0:1/n,0===o?0:1/o,0===a?0:1/a),r._oneOverRadiiSquared=new e(0===n?0:1/(n*n),0===o?0:1/(o*o),0===a?0:1/(a*a)),r._minimumRadius=Math.min(n,o,a),r._maximumRadius=Math.max(n,o,a),r._centerToleranceSquared=u.EPSILON1}function l(e,r,t){this._radii=void 0,this._radiiSquared=void 0,this._radiiToTheFourth=void 0,this._oneOverRadii=void 0,this._oneOverRadiiSquared=void 0,this._minimumRadius=void 0,this._maximumRadius=void 0,this._centerToleranceSquared=void 0,c(this,e,r,t)}o(l.prototype,{radii:{get:function(){return this._radii}},radiiSquared:{get:function(){return this._radiiSquared}},radiiToTheFourth:{get:function(){return this._radiiToTheFourth}},oneOverRadii:{get:function(){return this._oneOverRadii}},oneOverRadiiSquared:{get:function(){return this._oneOverRadiiSquared}},minimumRadius:{get:function(){return this._minimumRadius}},maximumRadius:{get:function(){return this._maximumRadius}}}),l.clone=function(r,t){if(n(r)){var o=r._radii;return n(t)?(e.clone(o,t._radii),e.clone(r._radiiSquared,t._radiiSquared),e.clone(r._radiiToTheFourth,t._radiiToTheFourth),e.clone(r._oneOverRadii,t._oneOverRadii),e.clone(r._oneOverRadiiSquared,t._oneOverRadiiSquared),t._minimumRadius=r._minimumRadius,t._maximumRadius=r._maximumRadius,t._centerToleranceSquared=r._centerToleranceSquared,t):new l(o.x,o.y,o.z)}},l.fromCartesian3=function(e,r){return n(r)||(r=new l),n(e)?(c(r,e.x,e.y,e.z),r):r},l.WGS84=i(new l(6378137,6378137,6356752.314245179)),l.UNIT_SPHERE=i(new l(1,1,1)),l.MOON=i(new l(u.LUNAR_RADIUS,u.LUNAR_RADIUS,u.LUNAR_RADIUS)),l.prototype.clone=function(e){return l.clone(this,e)},l.packedLength=e.packedLength,l.pack=function(r,n,o){return o=t(o,0),e.pack(r._radii,n,o),n},l.unpack=function(r,n,o){n=t(n,0);var a=e.unpack(r,n);return l.fromCartesian3(a,o)},l.prototype.geocentricSurfaceNormal=e.normalize,l.prototype.geodeticSurfaceNormalCartographic=function(r,t){var o=r.longitude,a=r.latitude,i=Math.cos(a),u=i*Math.cos(o),s=i*Math.sin(o),c=Math.sin(a);return n(t)||(t=new e),t.x=u,t.y=s,t.z=c,e.normalize(t,t)},l.prototype.geodeticSurfaceNormal=function(r,t){return n(t)||(t=new e),t=e.multiplyComponents(r,this._oneOverRadiiSquared,t),e.normalize(t,t)};var E=new e,f=new e;l.prototype.cartographicToCartesian=function(r,t){var o=E,a=f;this.geodeticSurfaceNormalCartographic(r,o),e.multiplyComponents(this._radiiSquared,o,a);var i=Math.sqrt(e.dot(o,a));return e.divideByScalar(a,i,a),e.multiplyByScalar(o,r.height,o),n(t)||(t=new e),e.add(a,o,t)},l.prototype.cartographicArrayToCartesianArray=function(e,r){var t=e.length;n(r)?r.length=t:r=new Array(t);for(var o=0;o<t;o++)r[o]=this.cartographicToCartesian(e[o],r[o]);return r};var m=new e,h=new e,d=new e;return l.prototype.cartesianToCartographic=function(t,o){var a=this.scaleToGeodeticSurface(t,h);if(n(a)){var i=this.geodeticSurfaceNormal(a,m),s=e.subtract(t,a,d),c=Math.atan2(i.y,i.x),l=Math.asin(i.z),E=u.sign(e.dot(s,t))*e.magnitude(s);return n(o)?(o.longitude=c,o.latitude=l,o.height=E,o):new r(c,l,E)}},l.prototype.cartesianArrayToCartographicArray=function(e,r){var t=e.length;n(r)?r.length=t:r=new Array(t);for(var o=0;o<t;++o)r[o]=this.cartesianToCartographic(e[o],r[o]);return r},l.prototype.scaleToGeodeticSurface=function(e,r){return s(e,this._oneOverRadii,this._oneOverRadiiSquared,this._centerToleranceSquared,r)},l.prototype.scaleToGeocentricSurface=function(r,t){n(t)||(t=new e);var o=r.x,a=r.y,i=r.z,u=this._oneOverRadiiSquared,s=1/Math.sqrt(o*o*u.x+a*a*u.y+i*i*u.z);return e.multiplyByScalar(r,s,t)},l.prototype.transformPositionToScaledSpace=function(r,t){return n(t)||(t=new e),e.multiplyComponents(r,this._oneOverRadii,t)},l.prototype.transformPositionFromScaledSpace=function(r,t){return n(t)||(t=new e),e.multiplyComponents(r,this._radii,t)},l.prototype.equals=function(r){return this===r||n(r)&&e.equals(this._radii,r._radii)},l.prototype.toString=function(){return this._radii.toString()},l}),define("Core/GeographicProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid"],function(e,r,t,n,o,a,i){"use strict";function u(e){this._ellipsoid=t(e,i.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}return o(u.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),u.prototype.project=function(r,t){var o=this._semimajorAxis,a=r.longitude*o,i=r.latitude*o,u=r.height;return n(t)?(t.x=a,t.y=i,t.z=u,t):new e(a,i,u)},u.prototype.unproject=function(e,t){var o=this._oneOverSemimajorAxis,a=e.x*o,i=e.y*o,u=e.z;return n(t)?(t.longitude=a,t.latitude=i,t.height=u,t):new r(a,i,u)},u}),define("Core/Intersect",["./freezeObject"],function(e){"use strict";var r={OUTSIDE:-1,INTERSECTING:0,INSIDE:1};return e(r)}),define("Core/Interval",["./defaultValue"],function(e){"use strict";function r(r,t){this.start=e(r,0),this.stop=e(t,0)}return r}),define("Core/Matrix3",["./Cartesian3","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math"],function(e,r,t,n,o,a,i){"use strict";function u(e,t,n,o,a,i,u,s,c){this[0]=r(e,0),this[1]=r(o,0),this[2]=r(u,0),this[3]=r(t,0),this[4]=r(a,0),this[5]=r(s,0),this[6]=r(n,0),this[7]=r(i,0),this[8]=r(c,0)}function s(e){for(var r=0,t=0;t<9;++t){var n=e[t];r+=n*n}return Math.sqrt(r)}function c(e){for(var r=0,t=0;t<3;++t){var n=e[u.getElementIndex(h[t],m[t])];r+=2*n*n}return Math.sqrt(r)}function l(e,r){for(var t=i.EPSILON15,n=0,o=1,a=0;a<3;++a){var s=Math.abs(e[u.getElementIndex(h[a],m[a])]);s>n&&(o=a,n=s)}var c=1,l=0,E=m[o],f=h[o];if(Math.abs(e[u.getElementIndex(f,E)])>t){var d,p=e[u.getElementIndex(f,f)],T=e[u.getElementIndex(E,E)],R=e[u.getElementIndex(f,E)],A=(p-T)/2/R;d=A<0?-1/(-A+Math.sqrt(1+A*A)):1/(A+Math.sqrt(1+A*A)),c=1/Math.sqrt(1+d*d),l=d*c}return r=u.clone(u.IDENTITY,r),r[u.getElementIndex(E,E)]=r[u.getElementIndex(f,f)]=c,r[u.getElementIndex(f,E)]=l,r[u.getElementIndex(E,f)]=-l,r}u.packedLength=9,u.pack=function(e,t,n){return n=r(n,0),t[n++]=e[0],t[n++]=e[1],t[n++]=e[2],t[n++]=e[3],t[n++]=e[4],t[n++]=e[5],t[n++]=e[6],t[n++]=e[7],t[n++]=e[8],t},u.unpack=function(e,n,o){return n=r(n,0),t(o)||(o=new u),o[0]=e[n++],o[1]=e[n++],o[2]=e[n++],o[3]=e[n++],o[4]=e[n++],o[5]=e[n++],o[6]=e[n++],o[7]=e[n++],o[8]=e[n++],o},u.clone=function(e,r){if(t(e))return t(r)?(r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r):new u(e[0],e[3],e[6],e[1],e[4],e[7],e[2],e[5],e[8])},u.fromArray=function(e,n,o){return n=r(n,0),t(o)||(o=new u),o[0]=e[n],o[1]=e[n+1],o[2]=e[n+2],o[3]=e[n+3],o[4]=e[n+4],o[5]=e[n+5],o[6]=e[n+6],o[7]=e[n+7],o[8]=e[n+8],o},u.fromColumnMajorArray=function(e,r){return u.clone(e,r)},u.fromRowMajorArray=function(e,r){return t(r)?(r[0]=e[0],r[1]=e[3],r[2]=e[6],r[3]=e[1],r[4]=e[4],r[5]=e[7],r[6]=e[2],r[7]=e[5],r[8]=e[8],r):new u(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8])},u.fromQuaternion=function(e,r){var n=e.x*e.x,o=e.x*e.y,a=e.x*e.z,i=e.x*e.w,s=e.y*e.y,c=e.y*e.z,l=e.y*e.w,E=e.z*e.z,f=e.z*e.w,m=e.w*e.w,h=n-s-E+m,d=2*(o-f),p=2*(a+l),T=2*(o+f),R=-n+s-E+m,A=2*(c-i),_=2*(a-l),y=2*(c+i),S=-n-s+E+m;return t(r)?(r[0]=h,r[1]=T,r[2]=_,r[3]=d,r[4]=R,r[5]=y,r[6]=p,r[7]=A,r[8]=S,r):new u(h,d,p,T,R,A,_,y,S)},u.fromScale=function(e,r){return t(r)?(r[0]=e.x,r[1]=0,r[2]=0,r[3]=0,r[4]=e.y,r[5]=0,r[6]=0,r[7]=0,r[8]=e.z,r):new u(e.x,0,0,0,e.y,0,0,0,e.z)},u.fromUniformScale=function(e,r){return t(r)?(r[0]=e,r[1]=0,r[2]=0,r[3]=0,r[4]=e,r[5]=0,r[6]=0,r[7]=0,r[8]=e,r):new u(e,0,0,0,e,0,0,0,e)},u.fromCrossProduct=function(e,r){return t(r)?(r[0]=0,r[1]=e.z,r[2]=-e.y,r[3]=-e.z,r[4]=0,r[5]=e.x,r[6]=e.y,r[7]=-e.x,r[8]=0,r):new u(0,-e.z,e.y,e.z,0,-e.x,-e.y,e.x,0)},u.fromRotationX=function(e,r){var n=Math.cos(e),o=Math.sin(e);return t(r)?(r[0]=1,r[1]=0,r[2]=0,r[3]=0,r[4]=n,r[5]=o,r[6]=0,r[7]=-o,r[8]=n,r):new u(1,0,0,0,n,-o,0,o,n)},u.fromRotationY=function(e,r){var n=Math.cos(e),o=Math.sin(e);return t(r)?(r[0]=n,r[1]=0,r[2]=-o,r[3]=0,r[4]=1,r[5]=0,r[6]=o,r[7]=0,r[8]=n,r):new u(n,0,o,0,1,0,-o,0,n)},u.fromRotationZ=function(e,r){var n=Math.cos(e),o=Math.sin(e);return t(r)?(r[0]=n,r[1]=o,r[2]=0,r[3]=-o,r[4]=n,r[5]=0,r[6]=0,r[7]=0,r[8]=1,r):new u(n,-o,0,o,n,0,0,0,1)},u.toArray=function(e,r){return t(r)?(r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8]]},u.getElementIndex=function(e,r){return 3*e+r},u.getColumn=function(e,r,t){var n=3*r,o=e[n],a=e[n+1],i=e[n+2];return t.x=o,t.y=a,t.z=i,t},u.setColumn=function(e,r,t,n){n=u.clone(e,n);var o=3*r;return n[o]=t.x,n[o+1]=t.y,n[o+2]=t.z,n},u.getRow=function(e,r,t){var n=e[r],o=e[r+3],a=e[r+6];return t.x=n,t.y=o,t.z=a,t},u.setRow=function(e,r,t,n){return n=u.clone(e,n),n[r]=t.x,n[r+3]=t.y,n[r+6]=t.z,n};var E=new e;u.getScale=function(r,t){return t.x=e.magnitude(e.fromElements(r[0],r[1],r[2],E)),t.y=e.magnitude(e.fromElements(r[3],r[4],r[5],E)),t.z=e.magnitude(e.fromElements(r[6],r[7],r[8],E)),t};var f=new e;u.getMaximumScale=function(r){return u.getScale(r,f),e.maximumComponent(f)},u.multiply=function(e,r,t){var n=e[0]*r[0]+e[3]*r[1]+e[6]*r[2],o=e[1]*r[0]+e[4]*r[1]+e[7]*r[2],a=e[2]*r[0]+e[5]*r[1]+e[8]*r[2],i=e[0]*r[3]+e[3]*r[4]+e[6]*r[5],u=e[1]*r[3]+e[4]*r[4]+e[7]*r[5],s=e[2]*r[3]+e[5]*r[4]+e[8]*r[5],c=e[0]*r[6]+e[3]*r[7]+e[6]*r[8],l=e[1]*r[6]+e[4]*r[7]+e[7]*r[8],E=e[2]*r[6]+e[5]*r[7]+e[8]*r[8];return t[0]=n,t[1]=o,t[2]=a,t[3]=i,t[4]=u,t[5]=s,t[6]=c,t[7]=l,t[8]=E,t},u.add=function(e,r,t){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t[6]=e[6]+r[6],t[7]=e[7]+r[7],t[8]=e[8]+r[8],t},u.subtract=function(e,r,t){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t[6]=e[6]-r[6],t[7]=e[7]-r[7],t[8]=e[8]-r[8],t},u.multiplyByVector=function(e,r,t){var n=r.x,o=r.y,a=r.z,i=e[0]*n+e[3]*o+e[6]*a,u=e[1]*n+e[4]*o+e[7]*a,s=e[2]*n+e[5]*o+e[8]*a;return t.x=i,t.y=u,t.z=s,t},u.multiplyByScalar=function(e,r,t){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t[6]=e[6]*r,t[7]=e[7]*r,t[8]=e[8]*r,t},u.multiplyByScale=function(e,r,t){return t[0]=e[0]*r.x,t[1]=e[1]*r.x,t[2]=e[2]*r.x,t[3]=e[3]*r.y,t[4]=e[4]*r.y,t[5]=e[5]*r.y,t[6]=e[6]*r.z,t[7]=e[7]*r.z,t[8]=e[8]*r.z,t},u.negate=function(e,r){return r[0]=-e[0],r[1]=-e[1],r[2]=-e[2],r[3]=-e[3],r[4]=-e[4],r[5]=-e[5],r[6]=-e[6],r[7]=-e[7],r[8]=-e[8],r},u.transpose=function(e,r){var t=e[0],n=e[3],o=e[6],a=e[1],i=e[4],u=e[7],s=e[2],c=e[5],l=e[8];return r[0]=t,r[1]=n,r[2]=o,r[3]=a,r[4]=i,r[5]=u,r[6]=s,r[7]=c,r[8]=l,r};var m=[1,0,0],h=[2,2,1],d=new u,p=new u;return u.computeEigenDecomposition=function(e,r){var n=i.EPSILON20,o=10,a=0,E=0;t(r)||(r={});for(var f=r.unitary=u.clone(u.IDENTITY,r.unitary),m=r.diagonal=u.clone(e,r.diagonal),h=n*s(m);E<o&&c(m)>h;)l(m,d),u.transpose(d,p),u.multiply(m,d,m),u.multiply(p,m,m),u.multiply(f,d,f),++a>2&&(++E,a=0);return r},u.abs=function(e,r){return r[0]=Math.abs(e[0]),r[1]=Math.abs(e[1]),r[2]=Math.abs(e[2]),r[3]=Math.abs(e[3]),r[4]=Math.abs(e[4]),r[5]=Math.abs(e[5]),r[6]=Math.abs(e[6]),r[7]=Math.abs(e[7]),r[8]=Math.abs(e[8]),r},u.determinant=function(e){var r=e[0],t=e[3],n=e[6],o=e[1],a=e[4],i=e[7],u=e[2],s=e[5],c=e[8];return r*(a*c-s*i)+o*(s*n-t*c)+u*(t*i-a*n)},u.inverse=function(e,r){var t=e[0],n=e[1],a=e[2],s=e[3],c=e[4],l=e[5],E=e[6],f=e[7],m=e[8],h=u.determinant(e);if(Math.abs(h)<=i.EPSILON15)throw new o("matrix is not invertible");r[0]=c*m-f*l,r[1]=f*a-n*m,r[2]=n*l-c*a,r[3]=E*l-s*m,r[4]=t*m-E*a,r[5]=s*a-t*l,r[6]=s*f-E*c,r[7]=E*n-t*f,r[8]=t*c-s*n;var d=1/h;return u.multiplyByScalar(r,d,r)},u.equals=function(e,r){return e===r||t(e)&&t(r)&&e[0]===r[0]&&e[1]===r[1]&&e[2]===r[2]&&e[3]===r[3]&&e[4]===r[4]&&e[5]===r[5]&&e[6]===r[6]&&e[7]===r[7]&&e[8]===r[8]},u.equalsEpsilon=function(e,r,n){return e===r||t(e)&&t(r)&&Math.abs(e[0]-r[0])<=n&&Math.abs(e[1]-r[1])<=n&&Math.abs(e[2]-r[2])<=n&&Math.abs(e[3]-r[3])<=n&&Math.abs(e[4]-r[4])<=n&&Math.abs(e[5]-r[5])<=n&&Math.abs(e[6]-r[6])<=n&&Math.abs(e[7]-r[7])<=n&&Math.abs(e[8]-r[8])<=n},u.IDENTITY=a(new u(1,0,0,0,1,0,0,0,1)),u.ZERO=a(new u(0,0,0,0,0,0,0,0,0)),u.COLUMN0ROW0=0,u.COLUMN0ROW1=1,u.COLUMN0ROW2=2,u.COLUMN1ROW0=3,u.COLUMN1ROW1=4,u.COLUMN1ROW2=5,u.COLUMN2ROW0=6,u.COLUMN2ROW1=7,u.COLUMN2ROW2=8,n(u.prototype,{length:{get:function(){return u.packedLength}}}),u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.equalsArray=function(e,r,t){return e[0]===r[t]&&e[1]===r[t+1]&&e[2]===r[t+2]&&e[3]===r[t+3]&&e[4]===r[t+4]&&e[5]===r[t+5]&&e[6]===r[t+6]&&e[7]===r[t+7]&&e[8]===r[t+8]},u.prototype.equalsEpsilon=function(e,r){return u.equalsEpsilon(this,e,r)},u.prototype.toString=function(){return"("+this[0]+", "+this[3]+", "+this[6]+")\n("+this[1]+", "+this[4]+", "+this[7]+")\n("+this[2]+", "+this[5]+", "+this[8]+")"},u}),define("Core/Cartesian4",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,r,t,n,o){"use strict";function a(r,t,n,o){this.x=e(r,0),this.y=e(t,0),this.z=e(n,0),this.w=e(o,0)}a.fromElements=function(e,t,n,o,i){return r(i)?(i.x=e,i.y=t,i.z=n,i.w=o,i):new a(e,t,n,o)},a.fromColor=function(e,t){return r(t)?(t.x=e.red,t.y=e.green,t.z=e.blue,t.w=e.alpha,t):new a(e.red,e.green,e.blue,e.alpha)},a.clone=function(e,t){if(r(e))return r(t)?(t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t):new a(e.x,e.y,e.z,e.w)},a.packedLength=4,a.pack=function(r,t,n){return n=e(n,0),t[n++]=r.x,t[n++]=r.y,t[n++]=r.z,t[n]=r.w,t},a.unpack=function(t,n,o){return n=e(n,0),r(o)||(o=new a),o.x=t[n++],o.y=t[n++],o.z=t[n++],o.w=t[n],o},a.packArray=function(e,t){var n=e.length;r(t)?t.length=4*n:t=new Array(4*n);for(var o=0;o<n;++o)a.pack(e[o],t,4*o);return t},a.unpackArray=function(e,t){var n=e.length;r(t)?t.length=n/4:t=new Array(n/4);for(var o=0;o<n;o+=4){var i=o/4;t[i]=a.unpack(e,o,t[i])}return t},a.fromArray=a.unpack,a.maximumComponent=function(e){return Math.max(e.x,e.y,e.z,e.w)},a.minimumComponent=function(e){return Math.min(e.x,e.y,e.z,e.w)},a.minimumByComponent=function(e,r,t){return t.x=Math.min(e.x,r.x),t.y=Math.min(e.y,r.y),t.z=Math.min(e.z,r.z),t.w=Math.min(e.w,r.w),t},a.maximumByComponent=function(e,r,t){return t.x=Math.max(e.x,r.x),t.y=Math.max(e.y,r.y),t.z=Math.max(e.z,r.z),t.w=Math.max(e.w,r.w),t},a.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z+e.w*e.w},a.magnitude=function(e){return Math.sqrt(a.magnitudeSquared(e))};var i=new a;a.distance=function(e,r){return a.subtract(e,r,i),a.magnitude(i)},a.distanceSquared=function(e,r){return a.subtract(e,r,i),a.magnitudeSquared(i)},a.normalize=function(e,r){var t=a.magnitude(e);return r.x=e.x/t,r.y=e.y/t,r.z=e.z/t,r.w=e.w/t,r},a.dot=function(e,r){return e.x*r.x+e.y*r.y+e.z*r.z+e.w*r.w},a.multiplyComponents=function(e,r,t){return t.x=e.x*r.x,t.y=e.y*r.y,t.z=e.z*r.z,t.w=e.w*r.w,t},a.add=function(e,r,t){return t.x=e.x+r.x,t.y=e.y+r.y,t.z=e.z+r.z,t.w=e.w+r.w,t},a.subtract=function(e,r,t){return t.x=e.x-r.x,t.y=e.y-r.y,t.z=e.z-r.z,t.w=e.w-r.w,t},a.multiplyByScalar=function(e,r,t){return t.x=e.x*r,t.y=e.y*r,t.z=e.z*r,t.w=e.w*r,t},a.divideByScalar=function(e,r,t){return t.x=e.x/r,t.y=e.y/r,t.z=e.z/r,t.w=e.w/r,t},a.negate=function(e,r){return r.x=-e.x,r.y=-e.y,r.z=-e.z,r.w=-e.w,r},a.abs=function(e,r){return r.x=Math.abs(e.x),r.y=Math.abs(e.y),r.z=Math.abs(e.z),r.w=Math.abs(e.w),r};var u=new a;a.lerp=function(e,r,t,n){return a.multiplyByScalar(r,t,u),n=a.multiplyByScalar(e,1-t,n),a.add(u,n,n)};var s=new a;return a.mostOrthogonalAxis=function(e,r){var t=a.normalize(e,s);return a.abs(t,t),r=t.x<=t.y?t.x<=t.z?t.x<=t.w?a.clone(a.UNIT_X,r):a.clone(a.UNIT_W,r):t.z<=t.w?a.clone(a.UNIT_Z,r):a.clone(a.UNIT_W,r):t.y<=t.z?t.y<=t.w?a.clone(a.UNIT_Y,r):a.clone(a.UNIT_W,r):t.z<=t.w?a.clone(a.UNIT_Z,r):a.clone(a.UNIT_W,r)},a.equals=function(e,t){return e===t||r(e)&&r(t)&&e.x===t.x&&e.y===t.y&&e.z===t.z&&e.w===t.w},a.equalsArray=function(e,r,t){return e.x===r[t]&&e.y===r[t+1]&&e.z===r[t+2]&&e.w===r[t+3]},a.equalsEpsilon=function(e,t,n,a){return e===t||r(e)&&r(t)&&o.equalsEpsilon(e.x,t.x,n,a)&&o.equalsEpsilon(e.y,t.y,n,a)&&o.equalsEpsilon(e.z,t.z,n,a)&&o.equalsEpsilon(e.w,t.w,n,a)},a.ZERO=n(new a(0,0,0,0)),a.UNIT_X=n(new a(1,0,0,0)),a.UNIT_Y=n(new a(0,1,0,0)),a.UNIT_Z=n(new a(0,0,1,0)),a.UNIT_W=n(new a(0,0,0,1)),a.prototype.clone=function(e){return a.clone(this,e)},a.prototype.equals=function(e){return a.equals(this,e)},a.prototype.equalsEpsilon=function(e,r,t){return a.equalsEpsilon(this,e,r,t)},a.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+", "+this.w+")"},a}),define("Core/RuntimeError",["./defined"],function(e){"use strict";function r(e){this.name="RuntimeError",this.message=e;var r;try{throw new Error}catch(e){r=e.stack}this.stack=r}return e(Object.create)&&(r.prototype=Object.create(Error.prototype),r.prototype.constructor=r),r.prototype.toString=function(){var r=this.name+": "+this.message;return e(this.stack)&&(r+="\n"+this.stack.toString()),r},r}),define("Core/Matrix4",["./Cartesian3","./Cartesian4","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./Matrix3","./RuntimeError"],function(e,r,t,n,o,a,i,u,s,c){"use strict";function l(e,r,n,o,a,i,u,s,c,l,E,f,m,h,d,p){this[0]=t(e,0),this[1]=t(a,0),this[2]=t(c,0),this[3]=t(m,0),this[4]=t(r,0),this[5]=t(i,0),this[6]=t(l,0),this[7]=t(h,0),this[8]=t(n,0),this[9]=t(u,0),this[10]=t(E,0),this[11]=t(d,0),this[12]=t(o,0),this[13]=t(s,0),this[14]=t(f,0),this[15]=t(p,0)}l.packedLength=16,l.pack=function(e,r,n){return n=t(n,0),r[n++]=e[0],r[n++]=e[1],r[n++]=e[2],r[n++]=e[3],r[n++]=e[4],r[n++]=e[5],r[n++]=e[6],r[n++]=e[7],r[n++]=e[8],r[n++]=e[9],r[n++]=e[10],r[n++]=e[11],r[n++]=e[12],r[n++]=e[13],r[n++]=e[14],r[n]=e[15],r},l.unpack=function(e,r,o){return r=t(r,0),n(o)||(o=new l),o[0]=e[r++],o[1]=e[r++],o[2]=e[r++],o[3]=e[r++],o[4]=e[r++],o[5]=e[r++],o[6]=e[r++],o[7]=e[r++],o[8]=e[r++],o[9]=e[r++],o[10]=e[r++],o[11]=e[r++],o[12]=e[r++],o[13]=e[r++],o[14]=e[r++],o[15]=e[r],o},l.clone=function(e,r){if(n(e))return n(r)?(r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r[9]=e[9],r[10]=e[10],r[11]=e[11],r[12]=e[12],r[13]=e[13],r[14]=e[14],r[15]=e[15],r):new l(e[0],e[4],e[8],e[12],e[1],e[5],e[9],e[13],e[2],e[6],e[10],e[14],e[3],e[7],e[11],e[15])},l.fromArray=l.unpack,l.fromColumnMajorArray=function(e,r){return l.clone(e,r)},l.fromRowMajorArray=function(e,r){return n(r)?(r[0]=e[0],r[1]=e[4],r[2]=e[8],r[3]=e[12],r[4]=e[1],r[5]=e[5],r[6]=e[9],r[7]=e[13],r[8]=e[2],r[9]=e[6],r[10]=e[10],r[11]=e[14],r[12]=e[3],r[13]=e[7],r[14]=e[11],r[15]=e[15],r):new l(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15])},l.fromRotationTranslation=function(r,o,a){return o=t(o,e.ZERO),n(a)?(a[0]=r[0],a[1]=r[1],a[2]=r[2],a[3]=0,a[4]=r[3],a[5]=r[4],a[6]=r[5],a[7]=0,a[8]=r[6],a[9]=r[7],a[10]=r[8],a[11]=0,a[12]=o.x,a[13]=o.y,a[14]=o.z,a[15]=1,a):new l(r[0],r[3],r[6],o.x,r[1],r[4],r[7],o.y,r[2],r[5],r[8],o.z,0,0,0,1)},l.fromTranslationQuaternionRotationScale=function(e,r,t,o){n(o)||(o=new l);var a=t.x,i=t.y,u=t.z,s=r.x*r.x,c=r.x*r.y,E=r.x*r.z,f=r.x*r.w,m=r.y*r.y,h=r.y*r.z,d=r.y*r.w,p=r.z*r.z,T=r.z*r.w,R=r.w*r.w,A=s-m-p+R,_=2*(c-T),y=2*(E+d),S=2*(c+T),N=-s+m-p+R,C=2*(h-f),v=2*(E-d),g=2*(h+f),I=-s-m+p+R;return o[0]=A*a,
o[1]=S*a,o[2]=v*a,o[3]=0,o[4]=_*i,o[5]=N*i,o[6]=g*i,o[7]=0,o[8]=y*u,o[9]=C*u,o[10]=I*u,o[11]=0,o[12]=e.x,o[13]=e.y,o[14]=e.z,o[15]=1,o},l.fromTranslationRotationScale=function(e,r){return l.fromTranslationQuaternionRotationScale(e.translation,e.rotation,e.scale,r)},l.fromTranslation=function(e,r){return l.fromRotationTranslation(s.IDENTITY,e,r)},l.fromScale=function(e,r){return n(r)?(r[0]=e.x,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=e.y,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=e.z,r[11]=0,r[12]=0,r[13]=0,r[14]=0,r[15]=1,r):new l(e.x,0,0,0,0,e.y,0,0,0,0,e.z,0,0,0,0,1)},l.fromUniformScale=function(e,r){return n(r)?(r[0]=e,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=e,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=e,r[11]=0,r[12]=0,r[13]=0,r[14]=0,r[15]=1,r):new l(e,0,0,0,0,e,0,0,0,0,e,0,0,0,0,1)};var E=new e,f=new e,m=new e;l.fromCamera=function(r,t){var o=r.position,a=r.direction,i=r.up;e.normalize(a,E),e.normalize(e.cross(E,i,f),f),e.normalize(e.cross(f,E,m),m);var u=f.x,s=f.y,c=f.z,h=E.x,d=E.y,p=E.z,T=m.x,R=m.y,A=m.z,_=o.x,y=o.y,S=o.z,N=u*-_+s*-y+c*-S,C=T*-_+R*-y+A*-S,v=h*_+d*y+p*S;return n(t)?(t[0]=u,t[1]=T,t[2]=-h,t[3]=0,t[4]=s,t[5]=R,t[6]=-d,t[7]=0,t[8]=c,t[9]=A,t[10]=-p,t[11]=0,t[12]=N,t[13]=C,t[14]=v,t[15]=1,t):new l(u,s,c,N,T,R,A,C,-h,-d,-p,v,0,0,0,1)},l.computePerspectiveFieldOfView=function(e,r,t,n,o){var a=Math.tan(.5*e),i=1/a,u=i/r,s=(n+t)/(t-n),c=2*n*t/(t-n);return o[0]=u,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=i,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=s,o[11]=-1,o[12]=0,o[13]=0,o[14]=c,o[15]=0,o},l.computeOrthographicOffCenter=function(e,r,t,n,o,a,i){var u=1/(r-e),s=1/(n-t),c=1/(a-o),l=-(r+e)*u,E=-(n+t)*s,f=-(a+o)*c;return u*=2,s*=2,c*=-2,i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=0,i[9]=0,i[10]=c,i[11]=0,i[12]=l,i[13]=E,i[14]=f,i[15]=1,i},l.computePerspectiveOffCenter=function(e,r,t,n,o,a,i){var u=2*o/(r-e),s=2*o/(n-t),c=(r+e)/(r-e),l=(n+t)/(n-t),E=-(a+o)/(a-o),f=-1,m=-2*a*o/(a-o);return i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=c,i[9]=l,i[10]=E,i[11]=f,i[12]=0,i[13]=0,i[14]=m,i[15]=0,i},l.computeInfinitePerspectiveOffCenter=function(e,r,t,n,o,a){var i=2*o/(r-e),u=2*o/(n-t),s=(r+e)/(r-e),c=(n+t)/(n-t),l=-1,E=-1,f=-2*o;return a[0]=i,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=u,a[6]=0,a[7]=0,a[8]=s,a[9]=c,a[10]=l,a[11]=E,a[12]=0,a[13]=0,a[14]=f,a[15]=0,a},l.computeViewportTransformation=function(e,r,n,o){e=t(e,t.EMPTY_OBJECT);var a=t(e.x,0),i=t(e.y,0),u=t(e.width,0),s=t(e.height,0);r=t(r,0),n=t(n,1);var c=.5*u,l=.5*s,E=.5*(n-r),f=c,m=l,h=E,d=a+c,p=i+l,T=r+E,R=1;return o[0]=f,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=m,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=h,o[11]=0,o[12]=d,o[13]=p,o[14]=T,o[15]=R,o},l.computeView=function(r,t,n,o,a){return a[0]=o.x,a[1]=n.x,a[2]=-t.x,a[3]=0,a[4]=o.y,a[5]=n.y,a[6]=-t.y,a[7]=0,a[8]=o.z,a[9]=n.z,a[10]=-t.z,a[11]=0,a[12]=-e.dot(o,r),a[13]=-e.dot(n,r),a[14]=e.dot(t,r),a[15]=1,a},l.toArray=function(e,r){return n(r)?(r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r[9]=e[9],r[10]=e[10],r[11]=e[11],r[12]=e[12],r[13]=e[13],r[14]=e[14],r[15]=e[15],r):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15]]},l.getElementIndex=function(e,r){return 4*e+r},l.getColumn=function(e,r,t){var n=4*r,o=e[n],a=e[n+1],i=e[n+2],u=e[n+3];return t.x=o,t.y=a,t.z=i,t.w=u,t},l.setColumn=function(e,r,t,n){n=l.clone(e,n);var o=4*r;return n[o]=t.x,n[o+1]=t.y,n[o+2]=t.z,n[o+3]=t.w,n},l.setTranslation=function(e,r,t){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=r.x,t[13]=r.y,t[14]=r.z,t[15]=e[15],t},l.getRow=function(e,r,t){var n=e[r],o=e[r+4],a=e[r+8],i=e[r+12];return t.x=n,t.y=o,t.z=a,t.w=i,t},l.setRow=function(e,r,t,n){return n=l.clone(e,n),n[r]=t.x,n[r+4]=t.y,n[r+8]=t.z,n[r+12]=t.w,n};var h=new e;l.getScale=function(r,t){return t.x=e.magnitude(e.fromElements(r[0],r[1],r[2],h)),t.y=e.magnitude(e.fromElements(r[4],r[5],r[6],h)),t.z=e.magnitude(e.fromElements(r[8],r[9],r[10],h)),t};var d=new e;l.getMaximumScale=function(r){return l.getScale(r,d),e.maximumComponent(d)},l.multiply=function(e,r,t){var n=e[0],o=e[1],a=e[2],i=e[3],u=e[4],s=e[5],c=e[6],l=e[7],E=e[8],f=e[9],m=e[10],h=e[11],d=e[12],p=e[13],T=e[14],R=e[15],A=r[0],_=r[1],y=r[2],S=r[3],N=r[4],C=r[5],v=r[6],g=r[7],I=r[8],M=r[9],O=r[10],L=r[11],F=r[12],P=r[13],w=r[14],D=r[15],x=n*A+u*_+E*y+d*S,U=o*A+s*_+f*y+p*S,b=a*A+c*_+m*y+T*S,B=i*A+l*_+h*y+R*S,G=n*N+u*C+E*v+d*g,z=o*N+s*C+f*v+p*g,V=a*N+c*C+m*v+T*g,H=i*N+l*C+h*v+R*g,W=n*I+u*M+E*O+d*L,q=o*I+s*M+f*O+p*L,X=a*I+c*M+m*O+T*L,Y=i*I+l*M+h*O+R*L,k=n*F+u*P+E*w+d*D,K=o*F+s*P+f*w+p*D,Z=a*F+c*P+m*w+T*D,j=i*F+l*P+h*w+R*D;return t[0]=x,t[1]=U,t[2]=b,t[3]=B,t[4]=G,t[5]=z,t[6]=V,t[7]=H,t[8]=W,t[9]=q,t[10]=X,t[11]=Y,t[12]=k,t[13]=K,t[14]=Z,t[15]=j,t},l.add=function(e,r,t){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t[6]=e[6]+r[6],t[7]=e[7]+r[7],t[8]=e[8]+r[8],t[9]=e[9]+r[9],t[10]=e[10]+r[10],t[11]=e[11]+r[11],t[12]=e[12]+r[12],t[13]=e[13]+r[13],t[14]=e[14]+r[14],t[15]=e[15]+r[15],t},l.subtract=function(e,r,t){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t[6]=e[6]-r[6],t[7]=e[7]-r[7],t[8]=e[8]-r[8],t[9]=e[9]-r[9],t[10]=e[10]-r[10],t[11]=e[11]-r[11],t[12]=e[12]-r[12],t[13]=e[13]-r[13],t[14]=e[14]-r[14],t[15]=e[15]-r[15],t},l.multiplyTransformation=function(e,r,t){var n=e[0],o=e[1],a=e[2],i=e[4],u=e[5],s=e[6],c=e[8],l=e[9],E=e[10],f=e[12],m=e[13],h=e[14],d=r[0],p=r[1],T=r[2],R=r[4],A=r[5],_=r[6],y=r[8],S=r[9],N=r[10],C=r[12],v=r[13],g=r[14],I=n*d+i*p+c*T,M=o*d+u*p+l*T,O=a*d+s*p+E*T,L=n*R+i*A+c*_,F=o*R+u*A+l*_,P=a*R+s*A+E*_,w=n*y+i*S+c*N,D=o*y+u*S+l*N,x=a*y+s*S+E*N,U=n*C+i*v+c*g+f,b=o*C+u*v+l*g+m,B=a*C+s*v+E*g+h;return t[0]=I,t[1]=M,t[2]=O,t[3]=0,t[4]=L,t[5]=F,t[6]=P,t[7]=0,t[8]=w,t[9]=D,t[10]=x,t[11]=0,t[12]=U,t[13]=b,t[14]=B,t[15]=1,t},l.multiplyByMatrix3=function(e,r,t){var n=e[0],o=e[1],a=e[2],i=e[4],u=e[5],s=e[6],c=e[8],l=e[9],E=e[10],f=r[0],m=r[1],h=r[2],d=r[3],p=r[4],T=r[5],R=r[6],A=r[7],_=r[8],y=n*f+i*m+c*h,S=o*f+u*m+l*h,N=a*f+s*m+E*h,C=n*d+i*p+c*T,v=o*d+u*p+l*T,g=a*d+s*p+E*T,I=n*R+i*A+c*_,M=o*R+u*A+l*_,O=a*R+s*A+E*_;return t[0]=y,t[1]=S,t[2]=N,t[3]=0,t[4]=C,t[5]=v,t[6]=g,t[7]=0,t[8]=I,t[9]=M,t[10]=O,t[11]=0,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},l.multiplyByTranslation=function(e,r,t){var n=r.x,o=r.y,a=r.z,i=n*e[0]+o*e[4]+a*e[8]+e[12],u=n*e[1]+o*e[5]+a*e[9]+e[13],s=n*e[2]+o*e[6]+a*e[10]+e[14];return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=i,t[13]=u,t[14]=s,t[15]=e[15],t};var p=new e;l.multiplyByUniformScale=function(e,r,t){return p.x=r,p.y=r,p.z=r,l.multiplyByScale(e,p,t)},l.multiplyByScale=function(e,r,t){var n=r.x,o=r.y,a=r.z;return 1===n&&1===o&&1===a?l.clone(e,t):(t[0]=n*e[0],t[1]=n*e[1],t[2]=n*e[2],t[3]=0,t[4]=o*e[4],t[5]=o*e[5],t[6]=o*e[6],t[7]=0,t[8]=a*e[8],t[9]=a*e[9],t[10]=a*e[10],t[11]=0,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=1,t)},l.multiplyByVector=function(e,r,t){var n=r.x,o=r.y,a=r.z,i=r.w,u=e[0]*n+e[4]*o+e[8]*a+e[12]*i,s=e[1]*n+e[5]*o+e[9]*a+e[13]*i,c=e[2]*n+e[6]*o+e[10]*a+e[14]*i,l=e[3]*n+e[7]*o+e[11]*a+e[15]*i;return t.x=u,t.y=s,t.z=c,t.w=l,t},l.multiplyByPointAsVector=function(e,r,t){var n=r.x,o=r.y,a=r.z,i=e[0]*n+e[4]*o+e[8]*a,u=e[1]*n+e[5]*o+e[9]*a,s=e[2]*n+e[6]*o+e[10]*a;return t.x=i,t.y=u,t.z=s,t},l.multiplyByPoint=function(e,r,t){var n=r.x,o=r.y,a=r.z,i=e[0]*n+e[4]*o+e[8]*a+e[12],u=e[1]*n+e[5]*o+e[9]*a+e[13],s=e[2]*n+e[6]*o+e[10]*a+e[14];return t.x=i,t.y=u,t.z=s,t},l.multiplyByScalar=function(e,r,t){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t[6]=e[6]*r,t[7]=e[7]*r,t[8]=e[8]*r,t[9]=e[9]*r,t[10]=e[10]*r,t[11]=e[11]*r,t[12]=e[12]*r,t[13]=e[13]*r,t[14]=e[14]*r,t[15]=e[15]*r,t},l.negate=function(e,r){return r[0]=-e[0],r[1]=-e[1],r[2]=-e[2],r[3]=-e[3],r[4]=-e[4],r[5]=-e[5],r[6]=-e[6],r[7]=-e[7],r[8]=-e[8],r[9]=-e[9],r[10]=-e[10],r[11]=-e[11],r[12]=-e[12],r[13]=-e[13],r[14]=-e[14],r[15]=-e[15],r},l.transpose=function(e,r){var t=e[1],n=e[2],o=e[3],a=e[6],i=e[7],u=e[11];return r[0]=e[0],r[1]=e[4],r[2]=e[8],r[3]=e[12],r[4]=t,r[5]=e[5],r[6]=e[9],r[7]=e[13],r[8]=n,r[9]=a,r[10]=e[10],r[11]=e[14],r[12]=o,r[13]=i,r[14]=u,r[15]=e[15],r},l.abs=function(e,r){return r[0]=Math.abs(e[0]),r[1]=Math.abs(e[1]),r[2]=Math.abs(e[2]),r[3]=Math.abs(e[3]),r[4]=Math.abs(e[4]),r[5]=Math.abs(e[5]),r[6]=Math.abs(e[6]),r[7]=Math.abs(e[7]),r[8]=Math.abs(e[8]),r[9]=Math.abs(e[9]),r[10]=Math.abs(e[10]),r[11]=Math.abs(e[11]),r[12]=Math.abs(e[12]),r[13]=Math.abs(e[13]),r[14]=Math.abs(e[14]),r[15]=Math.abs(e[15]),r},l.equals=function(e,r){return e===r||n(e)&&n(r)&&e[12]===r[12]&&e[13]===r[13]&&e[14]===r[14]&&e[0]===r[0]&&e[1]===r[1]&&e[2]===r[2]&&e[4]===r[4]&&e[5]===r[5]&&e[6]===r[6]&&e[8]===r[8]&&e[9]===r[9]&&e[10]===r[10]&&e[3]===r[3]&&e[7]===r[7]&&e[11]===r[11]&&e[15]===r[15]},l.equalsEpsilon=function(e,r,t){return e===r||n(e)&&n(r)&&Math.abs(e[0]-r[0])<=t&&Math.abs(e[1]-r[1])<=t&&Math.abs(e[2]-r[2])<=t&&Math.abs(e[3]-r[3])<=t&&Math.abs(e[4]-r[4])<=t&&Math.abs(e[5]-r[5])<=t&&Math.abs(e[6]-r[6])<=t&&Math.abs(e[7]-r[7])<=t&&Math.abs(e[8]-r[8])<=t&&Math.abs(e[9]-r[9])<=t&&Math.abs(e[10]-r[10])<=t&&Math.abs(e[11]-r[11])<=t&&Math.abs(e[12]-r[12])<=t&&Math.abs(e[13]-r[13])<=t&&Math.abs(e[14]-r[14])<=t&&Math.abs(e[15]-r[15])<=t},l.getTranslation=function(e,r){return r.x=e[12],r.y=e[13],r.z=e[14],r},l.getRotation=function(e,r){return r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[4],r[4]=e[5],r[5]=e[6],r[6]=e[8],r[7]=e[9],r[8]=e[10],r};var T=new s,R=new s,A=new r,_=new r(0,0,0,1);return l.inverse=function(e,t){if(s.equalsEpsilon(l.getRotation(e,T),R,u.EPSILON7)&&r.equals(l.getRow(e,3,A),_))return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=0,t[11]=0,t[12]=-e[12],t[13]=-e[13],t[14]=-e[14],t[15]=1,t;var n=e[0],o=e[4],a=e[8],i=e[12],E=e[1],f=e[5],m=e[9],h=e[13],d=e[2],p=e[6],y=e[10],S=e[14],N=e[3],C=e[7],v=e[11],g=e[15],I=y*g,M=S*v,O=p*g,L=S*C,F=p*v,P=y*C,w=d*g,D=S*N,x=d*v,U=y*N,b=d*C,B=p*N,G=I*f+L*m+F*h-(M*f+O*m+P*h),z=M*E+w*m+U*h-(I*E+D*m+x*h),V=O*E+D*f+b*h-(L*E+w*f+B*h),H=P*E+x*f+B*m-(F*E+U*f+b*m),W=M*o+O*a+P*i-(I*o+L*a+F*i),q=I*n+D*a+x*i-(M*n+w*a+U*i),X=L*n+w*o+B*i-(O*n+D*o+b*i),Y=F*n+U*o+b*a-(P*n+x*o+B*a);I=a*h,M=i*m,O=o*h,L=i*f,F=o*m,P=a*f,w=n*h,D=i*E,x=n*m,U=a*E,b=n*f,B=o*E;var k=I*C+L*v+F*g-(M*C+O*v+P*g),K=M*N+w*v+U*g-(I*N+D*v+x*g),Z=O*N+D*C+b*g-(L*N+w*C+B*g),j=P*N+x*C+B*v-(F*N+U*C+b*v),Q=O*y+P*S+M*p-(F*S+I*p+L*y),J=x*S+I*d+D*y-(w*y+U*S+M*d),$=w*p+B*S+L*d-(b*S+O*d+D*p),ee=b*y+F*d+U*p-(x*p+B*y+P*d),re=n*G+o*z+a*V+i*H;if(Math.abs(re)<u.EPSILON20)throw new c("matrix is not invertible because its determinate is zero.");return re=1/re,t[0]=G*re,t[1]=z*re,t[2]=V*re,t[3]=H*re,t[4]=W*re,t[5]=q*re,t[6]=X*re,t[7]=Y*re,t[8]=k*re,t[9]=K*re,t[10]=Z*re,t[11]=j*re,t[12]=Q*re,t[13]=J*re,t[14]=$*re,t[15]=ee*re,t},l.inverseTransformation=function(e,r){var t=e[0],n=e[1],o=e[2],a=e[4],i=e[5],u=e[6],s=e[8],c=e[9],l=e[10],E=e[12],f=e[13],m=e[14],h=-t*E-n*f-o*m,d=-a*E-i*f-u*m,p=-s*E-c*f-l*m;return r[0]=t,r[1]=a,r[2]=s,r[3]=0,r[4]=n,r[5]=i,r[6]=c,r[7]=0,r[8]=o,r[9]=u,r[10]=l,r[11]=0,r[12]=h,r[13]=d,r[14]=p,r[15]=1,r},l.IDENTITY=i(new l(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)),l.ZERO=i(new l(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)),l.COLUMN0ROW0=0,l.COLUMN0ROW1=1,l.COLUMN0ROW2=2,l.COLUMN0ROW3=3,l.COLUMN1ROW0=4,l.COLUMN1ROW1=5,l.COLUMN1ROW2=6,l.COLUMN1ROW3=7,l.COLUMN2ROW0=8,l.COLUMN2ROW1=9,l.COLUMN2ROW2=10,l.COLUMN2ROW3=11,l.COLUMN3ROW0=12,l.COLUMN3ROW1=13,l.COLUMN3ROW2=14,l.COLUMN3ROW3=15,o(l.prototype,{length:{get:function(){return l.packedLength}}}),l.prototype.clone=function(e){return l.clone(this,e)},l.prototype.equals=function(e){return l.equals(this,e)},l.equalsArray=function(e,r,t){return e[0]===r[t]&&e[1]===r[t+1]&&e[2]===r[t+2]&&e[3]===r[t+3]&&e[4]===r[t+4]&&e[5]===r[t+5]&&e[6]===r[t+6]&&e[7]===r[t+7]&&e[8]===r[t+8]&&e[9]===r[t+9]&&e[10]===r[t+10]&&e[11]===r[t+11]&&e[12]===r[t+12]&&e[13]===r[t+13]&&e[14]===r[t+14]&&e[15]===r[t+15]},l.prototype.equalsEpsilon=function(e,r){return l.equalsEpsilon(this,e,r)},l.prototype.toString=function(){return"("+this[0]+", "+this[4]+", "+this[8]+", "+this[12]+")\n("+this[1]+", "+this[5]+", "+this[9]+", "+this[13]+")\n("+this[2]+", "+this[6]+", "+this[10]+", "+this[14]+")\n("+this[3]+", "+this[7]+", "+this[11]+", "+this[15]+")"},l}),define("Core/Plane",["./Cartesian3","./defined","./DeveloperError","./freezeObject"],function(e,r,t,n){"use strict";function o(r,t){this.normal=e.clone(r),this.distance=t}o.fromPointNormal=function(t,n,a){var i=-e.dot(n,t);return r(a)?(e.clone(n,a.normal),a.distance=i,a):new o(n,i)};var a=new e;return o.fromCartesian4=function(t,n){var i=e.fromCartesian4(t,a),u=t.w;return r(n)?(e.clone(i,n.normal),n.distance=u,n):new o(i,u)},o.getPointDistance=function(r,t){return e.dot(r.normal,t)+r.distance},o.ORIGIN_XY_PLANE=n(new o(e.UNIT_Z,0)),o.ORIGIN_YZ_PLANE=n(new o(e.UNIT_X,0)),o.ORIGIN_ZX_PLANE=n(new o(e.UNIT_Y,0)),o}),define("Core/Rectangle",["./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./freezeObject","./Math"],function(e,r,t,n,o,a,i,u){"use strict";function s(e,t,n,o){this.west=r(e,0),this.south=r(t,0),this.east=r(n,0),this.north=r(o,0)}n(s.prototype,{width:{get:function(){return s.computeWidth(this)}},height:{get:function(){return s.computeHeight(this)}}}),s.packedLength=4,s.pack=function(e,t,n){return n=r(n,0),t[n++]=e.west,t[n++]=e.south,t[n++]=e.east,t[n]=e.north,t},s.unpack=function(e,n,o){return n=r(n,0),t(o)||(o=new s),o.west=e[n++],o.south=e[n++],o.east=e[n++],o.north=e[n],o},s.computeWidth=function(e){var r=e.east,t=e.west;return r<t&&(r+=u.TWO_PI),r-t},s.computeHeight=function(e){return e.north-e.south},s.fromDegrees=function(e,n,o,a,i){return e=u.toRadians(r(e,0)),n=u.toRadians(r(n,0)),o=u.toRadians(r(o,0)),a=u.toRadians(r(a,0)),t(i)?(i.west=e,i.south=n,i.east=o,i.north=a,i):new s(e,n,o,a)},s.fromCartographicArray=function(e,r){for(var n=Number.MAX_VALUE,o=-Number.MAX_VALUE,a=Number.MAX_VALUE,i=-Number.MAX_VALUE,c=Number.MAX_VALUE,l=-Number.MAX_VALUE,E=0,f=e.length;E<f;E++){var m=e[E];n=Math.min(n,m.longitude),o=Math.max(o,m.longitude),c=Math.min(c,m.latitude),l=Math.max(l,m.latitude);var h=m.longitude>=0?m.longitude:m.longitude+u.TWO_PI;a=Math.min(a,h),i=Math.max(i,h)}return o-n>i-a&&(n=a,o=i,o>u.PI&&(o-=u.TWO_PI),n>u.PI&&(n-=u.TWO_PI)),t(r)?(r.west=n,r.south=c,r.east=o,r.north=l,r):new s(n,c,o,l)},s.fromCartesianArray=function(e,r,n){for(var o=Number.MAX_VALUE,a=-Number.MAX_VALUE,i=Number.MAX_VALUE,c=-Number.MAX_VALUE,l=Number.MAX_VALUE,E=-Number.MAX_VALUE,f=0,m=e.length;f<m;f++){var h=r.cartesianToCartographic(e[f]);o=Math.min(o,h.longitude),a=Math.max(a,h.longitude),l=Math.min(l,h.latitude),E=Math.max(E,h.latitude);var d=h.longitude>=0?h.longitude:h.longitude+u.TWO_PI;i=Math.min(i,d),c=Math.max(c,d)}return a-o>c-i&&(o=i,a=c,a>u.PI&&(a-=u.TWO_PI),o>u.PI&&(o-=u.TWO_PI)),t(n)?(n.west=o,n.south=l,n.east=a,n.north=E,n):new s(o,l,a,E)},s.clone=function(e,r){if(t(e))return t(r)?(r.west=e.west,r.south=e.south,r.east=e.east,r.north=e.north,r):new s(e.west,e.south,e.east,e.north)},s.prototype.clone=function(e){return s.clone(this,e)},s.prototype.equals=function(e){return s.equals(this,e)},s.equals=function(e,r){return e===r||t(e)&&t(r)&&e.west===r.west&&e.south===r.south&&e.east===r.east&&e.north===r.north},s.prototype.equalsEpsilon=function(e,r){return t(e)&&Math.abs(this.west-e.west)<=r&&Math.abs(this.south-e.south)<=r&&Math.abs(this.east-e.east)<=r&&Math.abs(this.north-e.north)<=r},s.validate=function(e){},s.southwest=function(r,n){return t(n)?(n.longitude=r.west,n.latitude=r.south,n.height=0,n):new e(r.west,r.south)},s.northwest=function(r,n){return t(n)?(n.longitude=r.west,n.latitude=r.north,n.height=0,n):new e(r.west,r.north)},s.northeast=function(r,n){return t(n)?(n.longitude=r.east,n.latitude=r.north,n.height=0,n):new e(r.east,r.north)},s.southeast=function(r,n){return t(n)?(n.longitude=r.east,n.latitude=r.south,n.height=0,n):new e(r.east,r.south)},s.center=function(r,n){var o=r.east,a=r.west;o<a&&(o+=u.TWO_PI);var i=u.negativePiToPi(.5*(a+o)),s=.5*(r.south+r.north);return t(n)?(n.longitude=i,n.latitude=s,n.height=0,n):new e(i,s)},s.intersection=function(e,r,n){var o=e.east,a=e.west,i=r.east,c=r.west;o<a&&i>0?o+=u.TWO_PI:i<c&&o>0&&(i+=u.TWO_PI),o<a&&c<0?c+=u.TWO_PI:i<c&&a<0&&(a+=u.TWO_PI);var l=u.negativePiToPi(Math.max(a,c)),E=u.negativePiToPi(Math.min(o,i));if(!((e.west<e.east||r.west<r.east)&&E<=l)){var f=Math.max(e.south,r.south),m=Math.min(e.north,r.north);if(!(f>=m))return t(n)?(n.west=l,n.south=f,n.east=E,n.north=m,n):new s(l,f,E,m)}},s.union=function(e,r,n){return t(n)||(n=new s),n.west=Math.min(e.west,r.west),n.south=Math.min(e.south,r.south),n.east=Math.max(e.east,r.east),n.north=Math.max(e.north,r.north),n},s.expand=function(e,r,n){return t(n)||(n=new s),n.west=Math.min(e.west,r.longitude),n.south=Math.min(e.south,r.latitude),n.east=Math.max(e.east,r.longitude),n.north=Math.max(e.north,r.latitude),n},s.contains=function(e,r){var t=r.longitude,n=r.latitude,o=e.west,a=e.east;return a<o&&(a+=u.TWO_PI,t<0&&(t+=u.TWO_PI)),(t>o||u.equalsEpsilon(t,o,u.EPSILON14))&&(t<a||u.equalsEpsilon(t,a,u.EPSILON14))&&n>=e.south&&n<=e.north};var c=new e;return s.subsample=function(e,n,o,i){n=r(n,a.WGS84),o=r(o,0),t(i)||(i=[]);var l=0,E=e.north,f=e.south,m=e.east,h=e.west,d=c;d.height=o,d.longitude=h,d.latitude=E,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=m,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.latitude=f,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=h,i[l]=n.cartographicToCartesian(d,i[l]),l++,E<0?d.latitude=E:f>0?d.latitude=f:d.latitude=0;for(var p=1;p<8;++p)d.longitude=-Math.PI+p*u.PI_OVER_TWO,s.contains(e,d)&&(i[l]=n.cartographicToCartesian(d,i[l]),l++);return 0===d.latitude&&(d.longitude=h,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=m,i[l]=n.cartographicToCartesian(d,i[l]),l++),i.length=l,i},s.MAX_VALUE=i(new s(-Math.PI,-u.PI_OVER_TWO,Math.PI,u.PI_OVER_TWO)),s}),define("Core/BoundingSphere",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./GeographicProjection","./Intersect","./Interval","./Matrix3","./Matrix4","./Plane","./Rectangle"],function(e,r,t,n,o,a,i,u,s,c,l,E,f){"use strict";function m(r,n){this.center=e.clone(t(r,e.ZERO)),this.radius=t(n,0)}var h=new e,d=new e,p=new e,T=new e,R=new e,A=new e,_=new e,y=new e,S=new e,N=new e,C=new e,v=new e;m.fromPoints=function(r,t){if(n(t)||(t=new m),!n(r)||0===r.length)return t.center=e.clone(e.ZERO,t.center),t.radius=0,t;for(var o=e.clone(r[0],_),a=e.clone(o,h),i=e.clone(o,d),u=e.clone(o,p),s=e.clone(o,T),c=e.clone(o,R),l=e.clone(o,A),E=r.length,f=1;f<E;f++){e.clone(r[f],o);var g=o.x,I=o.y,M=o.z;g<a.x&&e.clone(o,a),g>s.x&&e.clone(o,s),I<i.y&&e.clone(o,i),I>c.y&&e.clone(o,c),M<u.z&&e.clone(o,u),M>l.z&&e.clone(o,l)}var O=e.magnitudeSquared(e.subtract(s,a,y)),L=e.magnitudeSquared(e.subtract(c,i,y)),F=e.magnitudeSquared(e.subtract(l,u,y)),P=a,w=s,D=O;L>D&&(D=L,P=i,w=c),F>D&&(D=F,P=u,w=l);var x=S;x.x=.5*(P.x+w.x),x.y=.5*(P.y+w.y),x.z=.5*(P.z+w.z);var U=e.magnitudeSquared(e.subtract(w,x,y)),b=Math.sqrt(U),B=N;B.x=a.x,B.y=i.y,B.z=u.z;var G=C;G.x=s.x,G.y=c.y,G.z=l.z;var z=e.multiplyByScalar(e.add(B,G,y),.5,v),V=0;for(f=0;f<E;f++){e.clone(r[f],o);var H=e.magnitude(e.subtract(o,z,y));H>V&&(V=H);var W=e.magnitudeSquared(e.subtract(o,x,y));if(W>U){var q=Math.sqrt(W);b=.5*(b+q),U=b*b;var X=q-b;x.x=(b*x.x+X*o.x)/q,x.y=(b*x.y+X*o.y)/q,x.z=(b*x.z+X*o.z)/q}}return b<V?(e.clone(x,t.center),t.radius=b):(e.clone(z,t.center),t.radius=V),t};var g=new i,I=new e,M=new e,O=new r,L=new r;m.fromRectangle2D=function(e,r,t){return m.fromRectangleWithHeights2D(e,r,0,0,t)},m.fromRectangleWithHeights2D=function(r,o,a,i,u){if(n(u)||(u=new m),!n(r))return u.center=e.clone(e.ZERO,u.center),u.radius=0,u;o=t(o,g),f.southwest(r,O),O.height=a,f.northeast(r,L),L.height=i;var s=o.project(O,I),c=o.project(L,M),l=c.x-s.x,E=c.y-s.y,h=c.z-s.z;u.radius=.5*Math.sqrt(l*l+E*E+h*h);var d=u.center;return d.x=s.x+.5*l,d.y=s.y+.5*E,d.z=s.z+.5*h,u};var F=[];m.fromRectangle3D=function(e,r,o,i){r=t(r,a.WGS84),o=t(o,0);var u;return n(e)&&(u=f.subsample(e,r,o,F)),m.fromPoints(u,i)},m.fromVertices=function(r,o,a,i){if(n(i)||(i=new m),!n(r)||0===r.length)return i.center=e.clone(e.ZERO,i.center),i.radius=0,i;o=t(o,e.ZERO),a=t(a,3);var u=_;u.x=r[0]+o.x,u.y=r[1]+o.y,u.z=r[2]+o.z;for(var s=e.clone(u,h),c=e.clone(u,d),l=e.clone(u,p),E=e.clone(u,T),f=e.clone(u,R),g=e.clone(u,A),I=r.length,M=0;M<I;M+=a){var O=r[M]+o.x,L=r[M+1]+o.y,F=r[M+2]+o.z;u.x=O,u.y=L,u.z=F,O<s.x&&e.clone(u,s),O>E.x&&e.clone(u,E),L<c.y&&e.clone(u,c),L>f.y&&e.clone(u,f),F<l.z&&e.clone(u,l),F>g.z&&e.clone(u,g)}var P=e.magnitudeSquared(e.subtract(E,s,y)),w=e.magnitudeSquared(e.subtract(f,c,y)),D=e.magnitudeSquared(e.subtract(g,l,y)),x=s,U=E,b=P;w>b&&(b=w,x=c,U=f),D>b&&(b=D,x=l,U=g);var B=S;B.x=.5*(x.x+U.x),B.y=.5*(x.y+U.y),B.z=.5*(x.z+U.z);var G=e.magnitudeSquared(e.subtract(U,B,y)),z=Math.sqrt(G),V=N;V.x=s.x,V.y=c.y,V.z=l.z;var H=C;H.x=E.x,H.y=f.y,H.z=g.z;var W=e.multiplyByScalar(e.add(V,H,y),.5,v),q=0;for(M=0;M<I;M+=a){u.x=r[M]+o.x,u.y=r[M+1]+o.y,u.z=r[M+2]+o.z;var X=e.magnitude(e.subtract(u,W,y));X>q&&(q=X);var Y=e.magnitudeSquared(e.subtract(u,B,y));if(Y>G){var k=Math.sqrt(Y);z=.5*(z+k),G=z*z;var K=k-z;B.x=(z*B.x+K*u.x)/k,B.y=(z*B.y+K*u.y)/k,B.z=(z*B.z+K*u.z)/k}}return z<q?(e.clone(B,i.center),i.radius=z):(e.clone(W,i.center),i.radius=q),i},m.fromEncodedCartesianVertices=function(r,t,o){if(n(o)||(o=new m),!n(r)||!n(t)||r.length!==t.length||0===r.length)return o.center=e.clone(e.ZERO,o.center),o.radius=0,o;var a=_;a.x=r[0]+t[0],a.y=r[1]+t[1],a.z=r[2]+t[2];for(var i=e.clone(a,h),u=e.clone(a,d),s=e.clone(a,p),c=e.clone(a,T),l=e.clone(a,R),E=e.clone(a,A),f=r.length,g=0;g<f;g+=3){var I=r[g]+t[g],M=r[g+1]+t[g+1],O=r[g+2]+t[g+2];a.x=I,a.y=M,a.z=O,I<i.x&&e.clone(a,i),I>c.x&&e.clone(a,c),M<u.y&&e.clone(a,u),M>l.y&&e.clone(a,l),O<s.z&&e.clone(a,s),O>E.z&&e.clone(a,E)}var L=e.magnitudeSquared(e.subtract(c,i,y)),F=e.magnitudeSquared(e.subtract(l,u,y)),P=e.magnitudeSquared(e.subtract(E,s,y)),w=i,D=c,x=L;F>x&&(x=F,w=u,D=l),P>x&&(x=P,w=s,D=E);var U=S;U.x=.5*(w.x+D.x),U.y=.5*(w.y+D.y),U.z=.5*(w.z+D.z);var b=e.magnitudeSquared(e.subtract(D,U,y)),B=Math.sqrt(b),G=N;G.x=i.x,G.y=u.y,G.z=s.z;var z=C;z.x=c.x,z.y=l.y,z.z=E.z;var V=e.multiplyByScalar(e.add(G,z,y),.5,v),H=0;for(g=0;g<f;g+=3){a.x=r[g]+t[g],a.y=r[g+1]+t[g+1],a.z=r[g+2]+t[g+2];var W=e.magnitude(e.subtract(a,V,y));W>H&&(H=W);var q=e.magnitudeSquared(e.subtract(a,U,y));if(q>b){var X=Math.sqrt(q);B=.5*(B+X),b=B*B;var Y=X-B;U.x=(B*U.x+Y*a.x)/X,U.y=(B*U.y+Y*a.y)/X,U.z=(B*U.z+Y*a.z)/X}}return B<H?(e.clone(U,o.center),o.radius=B):(e.clone(V,o.center),o.radius=H),o},m.fromCornerPoints=function(r,t,o){n(o)||(o=new m);var a=o.center;return e.add(r,t,a),e.multiplyByScalar(a,.5,a),o.radius=e.distance(a,t),o},m.fromEllipsoid=function(r,t){return n(t)||(t=new m),e.clone(e.ZERO,t.center),t.radius=r.maximumRadius,t};var P=new e;m.fromBoundingSpheres=function(r,t){if(n(t)||(t=new m),!n(r)||0===r.length)return t.center=e.clone(e.ZERO,t.center),t.radius=0,t;var o=r.length;if(1===o)return m.clone(r[0],t);if(2===o)return m.union(r[0],r[1],t);for(var a=[],i=0;i<o;i++)a.push(r[i].center);t=m.fromPoints(a,t);var u=t.center,s=t.radius;for(i=0;i<o;i++){var c=r[i];s=Math.max(s,e.distance(u,c.center,P)+c.radius)}return t.radius=s,t};var w=new e,D=new e,x=new e;m.fromOrientedBoundingBox=function(r,t){n(t)||(t=new m);var o=r.halfAxes,a=c.getColumn(o,0,w),i=c.getColumn(o,1,D),u=c.getColumn(o,2,x),s=e.magnitude(a),l=e.magnitude(i),E=e.magnitude(u);return t.center=e.clone(r.center,t.center),t.radius=Math.max(s,l,E),t},m.clone=function(r,t){if(n(r))return n(t)?(t.center=e.clone(r.center,t.center),t.radius=r.radius,t):new m(r.center,r.radius)},m.packedLength=4,m.pack=function(e,r,n){n=t(n,0);var o=e.center;return r[n++]=o.x,r[n++]=o.y,r[n++]=o.z,r[n]=e.radius,r},m.unpack=function(e,r,o){r=t(r,0),n(o)||(o=new m);var a=o.center;return a.x=e[r++],a.y=e[r++],a.z=e[r++],o.radius=e[r],o};var U=new e,b=new e;m.union=function(r,t,o){n(o)||(o=new m);var a=r.center,i=r.radius,u=t.center,s=t.radius,c=e.subtract(u,a,U),l=e.magnitude(c);if(i>=l+s)return r.clone(o),o;if(s>=l+i)return t.clone(o),o;var E=.5*(i+l+s),f=e.multiplyByScalar(c,(-i+E)/l,b);return e.add(f,a,f),e.clone(f,o.center),o.radius=E,o};var B=new e;m.expand=function(r,t,n){n=m.clone(r,n);var o=e.magnitude(e.subtract(t,n.center,B));return o>n.radius&&(n.radius=o),n},m.intersectPlane=function(r,t){var n=r.center,o=r.radius,a=t.normal,i=e.dot(a,n)+t.distance;return i<-o?u.OUTSIDE:i<o?u.INTERSECTING:u.INSIDE},m.transform=function(e,r,t){return n(t)||(t=new m),t.center=l.multiplyByPoint(r,e.center,t.center),t.radius=l.getMaximumScale(r)*e.radius,t};var G=new e;m.distanceSquaredTo=function(r,t){var n=e.subtract(r.center,t,G);return e.magnitudeSquared(n)-r.radius*r.radius},m.transformWithoutScale=function(e,r,t){return n(t)||(t=new m),t.center=l.multiplyByPoint(r,e.center,t.center),t.radius=e.radius,t};var z=new e;m.computePlaneDistances=function(r,t,o,a){n(a)||(a=new s);var i=e.subtract(r.center,t,z),u=e.dot(o,i);return a.start=u-r.radius,a.stop=u+r.radius,a};for(var V=new e,H=new e,W=new e,q=new e,X=new e,Y=new r,k=new Array(8),K=0;K<8;++K)k[K]=new e;var Z=new i;return m.projectTo2D=function(r,n,o){n=t(n,Z);var a=n.ellipsoid,i=r.center,u=r.radius,s=a.geodeticSurfaceNormal(i,V),c=e.cross(e.UNIT_Z,s,H);e.normalize(c,c);var l=e.cross(s,c,W);e.normalize(l,l),e.multiplyByScalar(s,u,s),e.multiplyByScalar(l,u,l),e.multiplyByScalar(c,u,c);var E=e.negate(l,X),f=e.negate(c,q),h=k,d=h[0];e.add(s,l,d),e.add(d,c,d),d=h[1],e.add(s,l,d),e.add(d,f,d),d=h[2],e.add(s,E,d),e.add(d,f,d),d=h[3],e.add(s,E,d),e.add(d,c,d),e.negate(s,s),d=h[4],e.add(s,l,d),e.add(d,c,d),d=h[5],e.add(s,l,d),e.add(d,f,d),d=h[6],e.add(s,E,d),e.add(d,f,d),d=h[7],e.add(s,E,d),e.add(d,c,d);for(var p=h.length,T=0;T<p;++T){var R=h[T];e.add(i,R,R);var A=a.cartesianToCartographic(R,Y);n.project(A,R)}o=m.fromPoints(h,o),i=o.center;var _=i.x,y=i.y,S=i.z;return i.x=S,i.y=_,i.z=y,o},m.isOccluded=function(e,r){return!r.isBoundingSphereVisible(e)},m.equals=function(r,t){return r===t||n(r)&&n(t)&&e.equals(r.center,t.center)&&r.radius===t.radius},m.prototype.intersectPlane=function(e){return m.intersectPlane(this,e)},m.prototype.distanceSquaredTo=function(e){return m.distanceSquaredTo(this,e)},m.prototype.computePlaneDistances=function(e,r,t){return m.computePlaneDistances(this,e,r,t)},m.prototype.isOccluded=function(e){return m.isOccluded(this,e)},m.prototype.equals=function(e){return m.equals(this,e)},m.prototype.clone=function(e){return m.clone(this,e)},m}),define("Core/Fullscreen",["./defined","./defineProperties"],function(e,r){"use strict";var t,n={requestFullscreen:void 0,exitFullscreen:void 0,fullscreenEnabled:void 0,fullscreenElement:void 0,fullscreenchange:void 0,fullscreenerror:void 0},o={};return r(o,{element:{get:function(){if(o.supportsFullscreen())return document[n.fullscreenElement]}},changeEventName:{get:function(){if(o.supportsFullscreen())return n.fullscreenchange}},errorEventName:{get:function(){if(o.supportsFullscreen())return n.fullscreenerror}},enabled:{get:function(){if(o.supportsFullscreen())return document[n.fullscreenEnabled]}},fullscreen:{get:function(){if(o.supportsFullscreen())return null!==o.element}}}),o.supportsFullscreen=function(){if(e(t))return t;t=!1;var r=document.body;if("function"==typeof r.requestFullscreen)return n.requestFullscreen="requestFullscreen",n.exitFullscreen="exitFullscreen",n.fullscreenEnabled="fullscreenEnabled",n.fullscreenElement="fullscreenElement",n.fullscreenchange="fullscreenchange",n.fullscreenerror="fullscreenerror",t=!0;for(var o,a=["webkit","moz","o","ms","khtml"],i=0,u=a.length;i<u;++i){var s=a[i];o=s+"RequestFullscreen","function"==typeof r[o]?(n.requestFullscreen=o,t=!0):(o=s+"RequestFullScreen","function"==typeof r[o]&&(n.requestFullscreen=o,t=!0)),o=s+"ExitFullscreen","function"==typeof document[o]?n.exitFullscreen=o:(o=s+"CancelFullScreen","function"==typeof document[o]&&(n.exitFullscreen=o)),o=s+"FullscreenEnabled",void 0!==document[o]?n.fullscreenEnabled=o:(o=s+"FullScreenEnabled",void 0!==document[o]&&(n.fullscreenEnabled=o)),o=s+"FullscreenElement",void 0!==document[o]?n.fullscreenElement=o:(o=s+"FullScreenElement",void 0!==document[o]&&(n.fullscreenElement=o)),o=s+"fullscreenchange",void 0!==document["on"+o]&&("ms"===s&&(o="MSFullscreenChange"),n.fullscreenchange=o),o=s+"fullscreenerror",void 0!==document["on"+o]&&("ms"===s&&(o="MSFullscreenError"),n.fullscreenerror=o)}return t},o.requestFullscreen=function(e,r){o.supportsFullscreen()&&e[n.requestFullscreen]({vrDisplay:r})},o.exitFullscreen=function(){o.supportsFullscreen()&&document[n.exitFullscreen]()},o}),define("Core/FeatureDetection",["./defaultValue","./defined","./Fullscreen"],function(e,r,t){"use strict";function n(e){for(var r=e.split("."),t=0,n=r.length;t<n;++t)r[t]=parseInt(r[t],10);return r}function o(){if(!r(A)){A=!1;var e=/ Chrome\/([\.0-9]+)/.exec(R.userAgent);null!==e&&(A=!0,_=n(e[1]))}return A}function a(){return o()&&_}function i(){if(!r(y)&&(y=!1,!o()&&/ Safari\/[\.0-9]+/.test(R.userAgent))){var e=/ Version\/([\.0-9]+)/.exec(R.userAgent);null!==e&&(y=!0,S=n(e[1]))}return y}function u(){return i()&&S}function s(){if(!r(N)){N=!1;var e=/ AppleWebKit\/([\.0-9]+)(\+?)/.exec(R.userAgent);null!==e&&(N=!0,C=n(e[1]),C.isNightly=!!e[2])}return N}function c(){return s()&&C}function l(){if(!r(v)){v=!1;var e;"Microsoft Internet Explorer"===R.appName?(e=/MSIE ([0-9]{1,}[\.0-9]{0,})/.exec(R.userAgent),null!==e&&(v=!0,g=n(e[1]))):"Netscape"===R.appName&&(e=/Trident\/.*rv:([0-9]{1,}[\.0-9]{0,})/.exec(R.userAgent),null!==e&&(v=!0,g=n(e[1])))}return v}function E(){return l()&&g}function f(){if(!r(I)){I=!1;var e=/Firefox\/([\.0-9]+)/.exec(R.userAgent);null!==e&&(I=!0,M=n(e[1]))}return I}function m(){return r(O)||(O=/Windows/i.test(R.appVersion)),O}function h(){return f()&&M}function d(){return r(L)||(L="undefined"!=typeof PointerEvent&&(!r(R.pointerEnabled)||R.pointerEnabled)),L}function p(){if(!r(P)){var e=document.createElement("canvas");e.setAttribute("style","image-rendering: -moz-crisp-edges;image-rendering: pixelated;");var t=e.style.imageRendering;P=r(t)&&""!==t,P&&(F=t)}return P}function T(){return p()?F:void 0}var R;R="undefined"!=typeof navigator?navigator:{};var A,_,y,S,N,C,v,g,I,M,O,L,F,P,w={isChrome:o,chromeVersion:a,isSafari:i,safariVersion:u,isWebkit:s,webkitVersion:c,isInternetExplorer:l,internetExplorerVersion:E,isFirefox:f,firefoxVersion:h,isWindows:m,hardwareConcurrency:e(R.hardwareConcurrency,3),supportsPointerEvents:d,supportsImageRenderingPixelated:p,imageRenderingValue:T};return w.supportsFullscreen=function(){return t.supportsFullscreen()},w.supportsTypedArrays=function(){return"undefined"!=typeof ArrayBuffer},w.supportsWebWorkers=function(){return"undefined"!=typeof Worker},w}),define("Core/Color",["./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject","./Math"],function(e,r,t,n,o,a){"use strict";function i(e,r,t){return t<0&&(t+=1),t>1&&(t-=1),6*t<1?e+6*(r-e)*t:2*t<1?r:3*t<2?e+(r-e)*(2/3-t)*6:e}function u(r,t,n,o){this.red=e(r,1),this.green=e(t,1),this.blue=e(n,1),this.alpha=e(o,1)}u.fromCartesian4=function(e,t){return r(t)?(t.red=e.x,t.green=e.y,t.blue=e.z,t.alpha=e.w,t):new u(e.x,e.y,e.z,e.w)},u.fromBytes=function(t,n,o,a,i){return t=u.byteToFloat(e(t,255)),n=u.byteToFloat(e(n,255)),o=u.byteToFloat(e(o,255)),a=u.byteToFloat(e(a,255)),r(i)?(i.red=t,i.green=n,i.blue=o,i.alpha=a,i):new u(t,n,o,a)},u.fromAlpha=function(e,t,n){return r(n)?(n.red=e.red,n.green=e.green,n.blue=e.blue,n.alpha=t,n):new u(e.red,e.green,e.blue,t)};var s,c,l;n.supportsTypedArrays()&&(s=new ArrayBuffer(4),c=new Uint32Array(s),l=new Uint8Array(s)),u.fromRgba=function(e,r){return c[0]=e,u.fromBytes(l[0],l[1],l[2],l[3],r)},u.fromHsl=function(t,n,o,a,s){t=e(t,0)%1,n=e(n,0),o=e(o,0),a=e(a,1);var c=o,l=o,E=o;if(0!==n){var f;f=o<.5?o*(1+n):o+n-o*n;
var m=2*o-f;c=i(m,f,t+1/3),l=i(m,f,t),E=i(m,f,t-1/3)}return r(s)?(s.red=c,s.green=l,s.blue=E,s.alpha=a,s):new u(c,l,E,a)},u.fromRandom=function(t,n){t=e(t,e.EMPTY_OBJECT);var o=t.red;if(!r(o)){var i=e(t.minimumRed,0),s=e(t.maximumRed,1);o=i+a.nextRandomNumber()*(s-i)}var c=t.green;if(!r(c)){var l=e(t.minimumGreen,0),E=e(t.maximumGreen,1);c=l+a.nextRandomNumber()*(E-l)}var f=t.blue;if(!r(f)){var m=e(t.minimumBlue,0),h=e(t.maximumBlue,1);f=m+a.nextRandomNumber()*(h-m)}var d=t.alpha;if(!r(d)){var p=e(t.minimumAlpha,0),T=e(t.maximumAlpha,1);d=p+a.nextRandomNumber()*(T-p)}return r(n)?(n.red=o,n.green=c,n.blue=f,n.alpha=d,n):new u(o,c,f,d)};var E=/^#([0-9a-f])([0-9a-f])([0-9a-f])$/i,f=/^#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/i,m=/^rgba?\(\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)(?:\s*,\s*([0-9.]+))?\s*\)$/i,h=/^hsla?\(\s*([0-9.]+)\s*,\s*([0-9.]+%)\s*,\s*([0-9.]+%)(?:\s*,\s*([0-9.]+))?\s*\)$/i;return u.fromCssColorString=function(t,n){r(n)||(n=new u);var o=u[t.toUpperCase()];if(r(o))return u.clone(o,n),n;var a=E.exec(t);return null!==a?(n.red=parseInt(a[1],16)/15,n.green=parseInt(a[2],16)/15,n.blue=parseInt(a[3],16)/15,n.alpha=1,n):(a=f.exec(t),null!==a?(n.red=parseInt(a[1],16)/255,n.green=parseInt(a[2],16)/255,n.blue=parseInt(a[3],16)/255,n.alpha=1,n):(a=m.exec(t),null!==a?(n.red=parseFloat(a[1])/("%"===a[1].substr(-1)?100:255),n.green=parseFloat(a[2])/("%"===a[2].substr(-1)?100:255),n.blue=parseFloat(a[3])/("%"===a[3].substr(-1)?100:255),n.alpha=parseFloat(e(a[4],"1.0")),n):(a=h.exec(t),null!==a?u.fromHsl(parseFloat(a[1])/360,parseFloat(a[2])/100,parseFloat(a[3])/100,parseFloat(e(a[4],"1.0")),n):n=void 0)))},u.packedLength=4,u.pack=function(r,t,n){return n=e(n,0),t[n++]=r.red,t[n++]=r.green,t[n++]=r.blue,t[n]=r.alpha,t},u.unpack=function(t,n,o){return n=e(n,0),r(o)||(o=new u),o.red=t[n++],o.green=t[n++],o.blue=t[n++],o.alpha=t[n],o},u.byteToFloat=function(e){return e/255},u.floatToByte=function(e){return 1===e?255:256*e|0},u.clone=function(e,t){if(r(e))return r(t)?(t.red=e.red,t.green=e.green,t.blue=e.blue,t.alpha=e.alpha,t):new u(e.red,e.green,e.blue,e.alpha)},u.equals=function(e,t){return e===t||r(e)&&r(t)&&e.red===t.red&&e.green===t.green&&e.blue===t.blue&&e.alpha===t.alpha},u.equalsArray=function(e,r,t){return e.red===r[t]&&e.green===r[t+1]&&e.blue===r[t+2]&&e.alpha===r[t+3]},u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.prototype.equalsEpsilon=function(e,t){return this===e||r(e)&&Math.abs(this.red-e.red)<=t&&Math.abs(this.green-e.green)<=t&&Math.abs(this.blue-e.blue)<=t&&Math.abs(this.alpha-e.alpha)<=t},u.prototype.toString=function(){return"("+this.red+", "+this.green+", "+this.blue+", "+this.alpha+")"},u.prototype.toCssColorString=function(){var e=u.floatToByte(this.red),r=u.floatToByte(this.green),t=u.floatToByte(this.blue);return 1===this.alpha?"rgb("+e+","+r+","+t+")":"rgba("+e+","+r+","+t+","+this.alpha+")"},u.prototype.toBytes=function(e){var t=u.floatToByte(this.red),n=u.floatToByte(this.green),o=u.floatToByte(this.blue),a=u.floatToByte(this.alpha);return r(e)?(e[0]=t,e[1]=n,e[2]=o,e[3]=a,e):[t,n,o,a]},u.prototype.toRgba=function(){return l[0]=u.floatToByte(this.red),l[1]=u.floatToByte(this.green),l[2]=u.floatToByte(this.blue),l[3]=u.floatToByte(this.alpha),c[0]},u.prototype.brighten=function(e,r){return e=1-e,r.red=1-(1-this.red)*e,r.green=1-(1-this.green)*e,r.blue=1-(1-this.blue)*e,r.alpha=this.alpha,r},u.prototype.darken=function(e,r){return e=1-e,r.red=this.red*e,r.green=this.green*e,r.blue=this.blue*e,r.alpha=this.alpha,r},u.prototype.withAlpha=function(e,r){return u.fromAlpha(this,e,r)},u.add=function(e,r,t){return t.red=e.red+r.red,t.green=e.green+r.green,t.blue=e.blue+r.blue,t.alpha=e.alpha+r.alpha,t},u.subtract=function(e,r,t){return t.red=e.red-r.red,t.green=e.green-r.green,t.blue=e.blue-r.blue,t.alpha=e.alpha-r.alpha,t},u.multiply=function(e,r,t){return t.red=e.red*r.red,t.green=e.green*r.green,t.blue=e.blue*r.blue,t.alpha=e.alpha*r.alpha,t},u.divide=function(e,r,t){return t.red=e.red/r.red,t.green=e.green/r.green,t.blue=e.blue/r.blue,t.alpha=e.alpha/r.alpha,t},u.mod=function(e,r,t){return t.red=e.red%r.red,t.green=e.green%r.green,t.blue=e.blue%r.blue,t.alpha=e.alpha%r.alpha,t},u.multiplyByScalar=function(e,r,t){return t.red=e.red*r,t.green=e.green*r,t.blue=e.blue*r,t.alpha=e.alpha*r,t},u.divideByScalar=function(e,r,t){return t.red=e.red/r,t.green=e.green/r,t.blue=e.blue/r,t.alpha=e.alpha/r,t},u.ALICEBLUE=o(u.fromCssColorString("#F0F8FF")),u.ANTIQUEWHITE=o(u.fromCssColorString("#FAEBD7")),u.AQUA=o(u.fromCssColorString("#00FFFF")),u.AQUAMARINE=o(u.fromCssColorString("#7FFFD4")),u.AZURE=o(u.fromCssColorString("#F0FFFF")),u.BEIGE=o(u.fromCssColorString("#F5F5DC")),u.BISQUE=o(u.fromCssColorString("#FFE4C4")),u.BLACK=o(u.fromCssColorString("#000000")),u.BLANCHEDALMOND=o(u.fromCssColorString("#FFEBCD")),u.BLUE=o(u.fromCssColorString("#0000FF")),u.BLUEVIOLET=o(u.fromCssColorString("#8A2BE2")),u.BROWN=o(u.fromCssColorString("#A52A2A")),u.BURLYWOOD=o(u.fromCssColorString("#DEB887")),u.CADETBLUE=o(u.fromCssColorString("#5F9EA0")),u.CHARTREUSE=o(u.fromCssColorString("#7FFF00")),u.CHOCOLATE=o(u.fromCssColorString("#D2691E")),u.CORAL=o(u.fromCssColorString("#FF7F50")),u.CORNFLOWERBLUE=o(u.fromCssColorString("#6495ED")),u.CORNSILK=o(u.fromCssColorString("#FFF8DC")),u.CRIMSON=o(u.fromCssColorString("#DC143C")),u.CYAN=o(u.fromCssColorString("#00FFFF")),u.DARKBLUE=o(u.fromCssColorString("#00008B")),u.DARKCYAN=o(u.fromCssColorString("#008B8B")),u.DARKGOLDENROD=o(u.fromCssColorString("#B8860B")),u.DARKGRAY=o(u.fromCssColorString("#A9A9A9")),u.DARKGREEN=o(u.fromCssColorString("#006400")),u.DARKGREY=u.DARKGRAY,u.DARKKHAKI=o(u.fromCssColorString("#BDB76B")),u.DARKMAGENTA=o(u.fromCssColorString("#8B008B")),u.DARKOLIVEGREEN=o(u.fromCssColorString("#556B2F")),u.DARKORANGE=o(u.fromCssColorString("#FF8C00")),u.DARKORCHID=o(u.fromCssColorString("#9932CC")),u.DARKRED=o(u.fromCssColorString("#8B0000")),u.DARKSALMON=o(u.fromCssColorString("#E9967A")),u.DARKSEAGREEN=o(u.fromCssColorString("#8FBC8F")),u.DARKSLATEBLUE=o(u.fromCssColorString("#483D8B")),u.DARKSLATEGRAY=o(u.fromCssColorString("#2F4F4F")),u.DARKSLATEGREY=u.DARKSLATEGRAY,u.DARKTURQUOISE=o(u.fromCssColorString("#00CED1")),u.DARKVIOLET=o(u.fromCssColorString("#9400D3")),u.DEEPPINK=o(u.fromCssColorString("#FF1493")),u.DEEPSKYBLUE=o(u.fromCssColorString("#00BFFF")),u.DIMGRAY=o(u.fromCssColorString("#696969")),u.DIMGREY=u.DIMGRAY,u.DODGERBLUE=o(u.fromCssColorString("#1E90FF")),u.FIREBRICK=o(u.fromCssColorString("#B22222")),u.FLORALWHITE=o(u.fromCssColorString("#FFFAF0")),u.FORESTGREEN=o(u.fromCssColorString("#228B22")),u.FUSCHIA=o(u.fromCssColorString("#FF00FF")),u.GAINSBORO=o(u.fromCssColorString("#DCDCDC")),u.GHOSTWHITE=o(u.fromCssColorString("#F8F8FF")),u.GOLD=o(u.fromCssColorString("#FFD700")),u.GOLDENROD=o(u.fromCssColorString("#DAA520")),u.GRAY=o(u.fromCssColorString("#808080")),u.GREEN=o(u.fromCssColorString("#008000")),u.GREENYELLOW=o(u.fromCssColorString("#ADFF2F")),u.GREY=u.GRAY,u.HONEYDEW=o(u.fromCssColorString("#F0FFF0")),u.HOTPINK=o(u.fromCssColorString("#FF69B4")),u.INDIANRED=o(u.fromCssColorString("#CD5C5C")),u.INDIGO=o(u.fromCssColorString("#4B0082")),u.IVORY=o(u.fromCssColorString("#FFFFF0")),u.KHAKI=o(u.fromCssColorString("#F0E68C")),u.LAVENDER=o(u.fromCssColorString("#E6E6FA")),u.LAVENDAR_BLUSH=o(u.fromCssColorString("#FFF0F5")),u.LAWNGREEN=o(u.fromCssColorString("#7CFC00")),u.LEMONCHIFFON=o(u.fromCssColorString("#FFFACD")),u.LIGHTBLUE=o(u.fromCssColorString("#ADD8E6")),u.LIGHTCORAL=o(u.fromCssColorString("#F08080")),u.LIGHTCYAN=o(u.fromCssColorString("#E0FFFF")),u.LIGHTGOLDENRODYELLOW=o(u.fromCssColorString("#FAFAD2")),u.LIGHTGRAY=o(u.fromCssColorString("#D3D3D3")),u.LIGHTGREEN=o(u.fromCssColorString("#90EE90")),u.LIGHTGREY=u.LIGHTGRAY,u.LIGHTPINK=o(u.fromCssColorString("#FFB6C1")),u.LIGHTSEAGREEN=o(u.fromCssColorString("#20B2AA")),u.LIGHTSKYBLUE=o(u.fromCssColorString("#87CEFA")),u.LIGHTSLATEGRAY=o(u.fromCssColorString("#778899")),u.LIGHTSLATEGREY=u.LIGHTSLATEGRAY,u.LIGHTSTEELBLUE=o(u.fromCssColorString("#B0C4DE")),u.LIGHTYELLOW=o(u.fromCssColorString("#FFFFE0")),u.LIME=o(u.fromCssColorString("#00FF00")),u.LIMEGREEN=o(u.fromCssColorString("#32CD32")),u.LINEN=o(u.fromCssColorString("#FAF0E6")),u.MAGENTA=o(u.fromCssColorString("#FF00FF")),u.MAROON=o(u.fromCssColorString("#800000")),u.MEDIUMAQUAMARINE=o(u.fromCssColorString("#66CDAA")),u.MEDIUMBLUE=o(u.fromCssColorString("#0000CD")),u.MEDIUMORCHID=o(u.fromCssColorString("#BA55D3")),u.MEDIUMPURPLE=o(u.fromCssColorString("#9370DB")),u.MEDIUMSEAGREEN=o(u.fromCssColorString("#3CB371")),u.MEDIUMSLATEBLUE=o(u.fromCssColorString("#7B68EE")),u.MEDIUMSPRINGGREEN=o(u.fromCssColorString("#00FA9A")),u.MEDIUMTURQUOISE=o(u.fromCssColorString("#48D1CC")),u.MEDIUMVIOLETRED=o(u.fromCssColorString("#C71585")),u.MIDNIGHTBLUE=o(u.fromCssColorString("#191970")),u.MINTCREAM=o(u.fromCssColorString("#F5FFFA")),u.MISTYROSE=o(u.fromCssColorString("#FFE4E1")),u.MOCCASIN=o(u.fromCssColorString("#FFE4B5")),u.NAVAJOWHITE=o(u.fromCssColorString("#FFDEAD")),u.NAVY=o(u.fromCssColorString("#000080")),u.OLDLACE=o(u.fromCssColorString("#FDF5E6")),u.OLIVE=o(u.fromCssColorString("#808000")),u.OLIVEDRAB=o(u.fromCssColorString("#6B8E23")),u.ORANGE=o(u.fromCssColorString("#FFA500")),u.ORANGERED=o(u.fromCssColorString("#FF4500")),u.ORCHID=o(u.fromCssColorString("#DA70D6")),u.PALEGOLDENROD=o(u.fromCssColorString("#EEE8AA")),u.PALEGREEN=o(u.fromCssColorString("#98FB98")),u.PALETURQUOISE=o(u.fromCssColorString("#AFEEEE")),u.PALEVIOLETRED=o(u.fromCssColorString("#DB7093")),u.PAPAYAWHIP=o(u.fromCssColorString("#FFEFD5")),u.PEACHPUFF=o(u.fromCssColorString("#FFDAB9")),u.PERU=o(u.fromCssColorString("#CD853F")),u.PINK=o(u.fromCssColorString("#FFC0CB")),u.PLUM=o(u.fromCssColorString("#DDA0DD")),u.POWDERBLUE=o(u.fromCssColorString("#B0E0E6")),u.PURPLE=o(u.fromCssColorString("#800080")),u.RED=o(u.fromCssColorString("#FF0000")),u.ROSYBROWN=o(u.fromCssColorString("#BC8F8F")),u.ROYALBLUE=o(u.fromCssColorString("#4169E1")),u.SADDLEBROWN=o(u.fromCssColorString("#8B4513")),u.SALMON=o(u.fromCssColorString("#FA8072")),u.SANDYBROWN=o(u.fromCssColorString("#F4A460")),u.SEAGREEN=o(u.fromCssColorString("#2E8B57")),u.SEASHELL=o(u.fromCssColorString("#FFF5EE")),u.SIENNA=o(u.fromCssColorString("#A0522D")),u.SILVER=o(u.fromCssColorString("#C0C0C0")),u.SKYBLUE=o(u.fromCssColorString("#87CEEB")),u.SLATEBLUE=o(u.fromCssColorString("#6A5ACD")),u.SLATEGRAY=o(u.fromCssColorString("#708090")),u.SLATEGREY=u.SLATEGRAY,u.SNOW=o(u.fromCssColorString("#FFFAFA")),u.SPRINGGREEN=o(u.fromCssColorString("#00FF7F")),u.STEELBLUE=o(u.fromCssColorString("#4682B4")),u.TAN=o(u.fromCssColorString("#D2B48C")),u.TEAL=o(u.fromCssColorString("#008080")),u.THISTLE=o(u.fromCssColorString("#D8BFD8")),u.TOMATO=o(u.fromCssColorString("#FF6347")),u.TURQUOISE=o(u.fromCssColorString("#40E0D0")),u.VIOLET=o(u.fromCssColorString("#EE82EE")),u.WHEAT=o(u.fromCssColorString("#F5DEB3")),u.WHITE=o(u.fromCssColorString("#FFFFFF")),u.WHITESMOKE=o(u.fromCssColorString("#F5F5F5")),u.YELLOW=o(u.fromCssColorString("#FFFF00")),u.YELLOWGREEN=o(u.fromCssColorString("#9ACD32")),u.TRANSPARENT=o(new u(0,0,0,0)),u}),define("Renderer/WebGLConstants",["../Core/freezeObject"],function(e){"use strict";var r={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,FUNC_ADD:32774,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,BLEND_COLOR:32773,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,STREAM_DRAW:35040,STATIC_DRAW:35044,DYNAMIC_DRAW:35048,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,CULL_FACE:2884,BLEND:3042,DITHER:3024,STENCIL_TEST:2960,DEPTH_TEST:2929,SCISSOR_TEST:3089,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CW:2304,CCW:2305,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_UNIFORMS:35718,ACTIVE_ATTRIBUTES:35721,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,NOTEQUAL:517,GEQUAL:518,ALWAYS:519,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,VENDOR:7936,RENDERER:7937,VERSION:7938,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,TEXTURE1:33985,TEXTURE2:33986,TEXTURE3:33987,TEXTURE4:33988,TEXTURE5:33989,TEXTURE6:33990,TEXTURE7:33991,TEXTURE8:33992,TEXTURE9:33993,TEXTURE10:33994,TEXTURE11:33995,TEXTURE12:33996,TEXTURE13:33997,TEXTURE14:33998,TEXTURE15:33999,TEXTURE16:34e3,TEXTURE17:34001,TEXTURE18:34002,TEXTURE19:34003,TEXTURE20:34004,TEXTURE21:34005,TEXTURE22:34006,TEXTURE23:34007,TEXTURE24:34008,TEXTURE25:34009,TEXTURE26:34010,TEXTURE27:34011,TEXTURE28:34012,TEXTURE29:34013,TEXTURE30:34014,TEXTURE31:34015,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,COMPILE_STATUS:35713,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,CONTEXT_LOST_WEBGL:37442,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,BROWSER_DEFAULT_WEBGL:37444,DOUBLE:5130,READ_BUFFER:3074,UNPACK_ROW_LENGTH:3314,UNPACK_SKIP_ROWS:3315,UNPACK_SKIP_PIXELS:3316,PACK_ROW_LENGTH:3330,PACK_SKIP_ROWS:3331,PACK_SKIP_PIXELS:3332,COLOR:6144,DEPTH:6145,STENCIL:6146,RED:6403,RGB8:32849,RGBA8:32856,RGB10_A2:32857,TEXTURE_BINDING_3D:32874,UNPACK_SKIP_IMAGES:32877,UNPACK_IMAGE_HEIGHT:32878,TEXTURE_3D:32879,TEXTURE_WRAP_R:32882,MAX_3D_TEXTURE_SIZE:32883,UNSIGNED_INT_2_10_10_10_REV:33640,MAX_ELEMENTS_VERTICES:33e3,MAX_ELEMENTS_INDICES:33001,TEXTURE_MIN_LOD:33082,TEXTURE_MAX_LOD:33083,TEXTURE_BASE_LEVEL:33084,TEXTURE_MAX_LEVEL:33085,MIN:32775,MAX:32776,DEPTH_COMPONENT24:33190,MAX_TEXTURE_LOD_BIAS:34045,TEXTURE_COMPARE_MODE:34892,TEXTURE_COMPARE_FUNC:34893,CURRENT_QUERY:34917,QUERY_RESULT:34918,QUERY_RESULT_AVAILABLE:34919,STREAM_READ:35041,STREAM_COPY:35042,STATIC_READ:35045,STATIC_COPY:35046,DYNAMIC_READ:35049,DYNAMIC_COPY:35050,MAX_DRAW_BUFFERS:34852,DRAW_BUFFER0:34853,DRAW_BUFFER1:34854,DRAW_BUFFER2:34855,DRAW_BUFFER3:34856,DRAW_BUFFER4:34857,DRAW_BUFFER5:34858,DRAW_BUFFER6:34859,DRAW_BUFFER7:34860,DRAW_BUFFER8:34861,DRAW_BUFFER9:34862,DRAW_BUFFER10:34863,DRAW_BUFFER11:34864,DRAW_BUFFER12:34865,DRAW_BUFFER13:34866,DRAW_BUFFER14:34867,DRAW_BUFFER15:34868,MAX_FRAGMENT_UNIFORM_COMPONENTS:35657,MAX_VERTEX_UNIFORM_COMPONENTS:35658,SAMPLER_3D:35679,SAMPLER_2D_SHADOW:35682,FRAGMENT_SHADER_DERIVATIVE_HINT:35723,PIXEL_PACK_BUFFER:35051,PIXEL_UNPACK_BUFFER:35052,PIXEL_PACK_BUFFER_BINDING:35053,PIXEL_UNPACK_BUFFER_BINDING:35055,FLOAT_MAT2x3:35685,FLOAT_MAT2x4:35686,FLOAT_MAT3x2:35687,FLOAT_MAT3x4:35688,FLOAT_MAT4x2:35689,FLOAT_MAT4x3:35690,SRGB:35904,SRGB8:35905,SRGB8_ALPHA8:35907,COMPARE_REF_TO_TEXTURE:34894,RGBA32F:34836,RGB32F:34837,RGBA16F:34842,RGB16F:34843,VERTEX_ATTRIB_ARRAY_INTEGER:35069,MAX_ARRAY_TEXTURE_LAYERS:35071,MIN_PROGRAM_TEXEL_OFFSET:35076,MAX_PROGRAM_TEXEL_OFFSET:35077,MAX_VARYING_COMPONENTS:35659,TEXTURE_2D_ARRAY:35866,TEXTURE_BINDING_2D_ARRAY:35869,R11F_G11F_B10F:35898,UNSIGNED_INT_10F_11F_11F_REV:35899,RGB9_E5:35901,UNSIGNED_INT_5_9_9_9_REV:35902,TRANSFORM_FEEDBACK_BUFFER_MODE:35967,MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS:35968,TRANSFORM_FEEDBACK_VARYINGS:35971,TRANSFORM_FEEDBACK_BUFFER_START:35972,TRANSFORM_FEEDBACK_BUFFER_SIZE:35973,TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN:35976,RASTERIZER_DISCARD:35977,MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS:35978,MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS:35979,INTERLEAVED_ATTRIBS:35980,SEPARATE_ATTRIBS:35981,TRANSFORM_FEEDBACK_BUFFER:35982,TRANSFORM_FEEDBACK_BUFFER_BINDING:35983,RGBA32UI:36208,RGB32UI:36209,RGBA16UI:36214,RGB16UI:36215,RGBA8UI:36220,RGB8UI:36221,RGBA32I:36226,RGB32I:36227,RGBA16I:36232,RGB16I:36233,RGBA8I:36238,RGB8I:36239,RED_INTEGER:36244,RGB_INTEGER:36248,RGBA_INTEGER:36249,SAMPLER_2D_ARRAY:36289,SAMPLER_2D_ARRAY_SHADOW:36292,SAMPLER_CUBE_SHADOW:36293,UNSIGNED_INT_VEC2:36294,UNSIGNED_INT_VEC3:36295,UNSIGNED_INT_VEC4:36296,INT_SAMPLER_2D:36298,INT_SAMPLER_3D:36299,INT_SAMPLER_CUBE:36300,INT_SAMPLER_2D_ARRAY:36303,UNSIGNED_INT_SAMPLER_2D:36306,UNSIGNED_INT_SAMPLER_3D:36307,UNSIGNED_INT_SAMPLER_CUBE:36308,UNSIGNED_INT_SAMPLER_2D_ARRAY:36311,DEPTH_COMPONENT32F:36012,DEPTH32F_STENCIL8:36013,FLOAT_32_UNSIGNED_INT_24_8_REV:36269,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:33296,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:33297,FRAMEBUFFER_ATTACHMENT_RED_SIZE:33298,FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:33299,FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:33300,FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:33301,FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:33302,FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:33303,FRAMEBUFFER_DEFAULT:33304,UNSIGNED_INT_24_8:34042,DEPTH24_STENCIL8:35056,UNSIGNED_NORMALIZED:35863,DRAW_FRAMEBUFFER_BINDING:36006,READ_FRAMEBUFFER:36008,DRAW_FRAMEBUFFER:36009,READ_FRAMEBUFFER_BINDING:36010,RENDERBUFFER_SAMPLES:36011,FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:36052,MAX_COLOR_ATTACHMENTS:36063,COLOR_ATTACHMENT1:36065,COLOR_ATTACHMENT2:36066,COLOR_ATTACHMENT3:36067,COLOR_ATTACHMENT4:36068,COLOR_ATTACHMENT5:36069,COLOR_ATTACHMENT6:36070,COLOR_ATTACHMENT7:36071,COLOR_ATTACHMENT8:36072,COLOR_ATTACHMENT9:36073,COLOR_ATTACHMENT10:36074,COLOR_ATTACHMENT11:36075,COLOR_ATTACHMENT12:36076,COLOR_ATTACHMENT13:36077,COLOR_ATTACHMENT14:36078,COLOR_ATTACHMENT15:36079,FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:36182,MAX_SAMPLES:36183,HALF_FLOAT:5131,RG:33319,RG_INTEGER:33320,R8:33321,RG8:33323,R16F:33325,R32F:33326,RG16F:33327,RG32F:33328,R8I:33329,R8UI:33330,R16I:33331,R16UI:33332,R32I:33333,R32UI:33334,RG8I:33335,RG8UI:33336,RG16I:33337,RG16UI:33338,RG32I:33339,RG32UI:33340,VERTEX_ARRAY_BINDING:34229,R8_SNORM:36756,RG8_SNORM:36757,RGB8_SNORM:36758,RGBA8_SNORM:36759,SIGNED_NORMALIZED:36764,COPY_READ_BUFFER:36662,COPY_WRITE_BUFFER:36663,COPY_READ_BUFFER_BINDING:36662,COPY_WRITE_BUFFER_BINDING:36663,UNIFORM_BUFFER:35345,UNIFORM_BUFFER_BINDING:35368,UNIFORM_BUFFER_START:35369,UNIFORM_BUFFER_SIZE:35370,MAX_VERTEX_UNIFORM_BLOCKS:35371,MAX_FRAGMENT_UNIFORM_BLOCKS:35373,MAX_COMBINED_UNIFORM_BLOCKS:35374,MAX_UNIFORM_BUFFER_BINDINGS:35375,MAX_UNIFORM_BLOCK_SIZE:35376,MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:35377,MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:35379,UNIFORM_BUFFER_OFFSET_ALIGNMENT:35380,ACTIVE_UNIFORM_BLOCKS:35382,UNIFORM_TYPE:35383,UNIFORM_SIZE:35384,UNIFORM_BLOCK_INDEX:35386,UNIFORM_OFFSET:35387,UNIFORM_ARRAY_STRIDE:35388,UNIFORM_MATRIX_STRIDE:35389,UNIFORM_IS_ROW_MAJOR:35390,UNIFORM_BLOCK_BINDING:35391,UNIFORM_BLOCK_DATA_SIZE:35392,UNIFORM_BLOCK_ACTIVE_UNIFORMS:35394,UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:35395,UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:35396,UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:35398,INVALID_INDEX:4294967295,MAX_VERTEX_OUTPUT_COMPONENTS:37154,MAX_FRAGMENT_INPUT_COMPONENTS:37157,MAX_SERVER_WAIT_TIMEOUT:37137,OBJECT_TYPE:37138,SYNC_CONDITION:37139,SYNC_STATUS:37140,SYNC_FLAGS:37141,SYNC_FENCE:37142,SYNC_GPU_COMMANDS_COMPLETE:37143,UNSIGNALED:37144,SIGNALED:37145,ALREADY_SIGNALED:37146,TIMEOUT_EXPIRED:37147,CONDITION_SATISFIED:37148,WAIT_FAILED:37149,SYNC_FLUSH_COMMANDS_BIT:1,VERTEX_ATTRIB_ARRAY_DIVISOR:35070,ANY_SAMPLES_PASSED:35887,ANY_SAMPLES_PASSED_CONSERVATIVE:36202,SAMPLER_BINDING:35097,RGB10_A2UI:36975,INT_2_10_10_10_REV:36255,TRANSFORM_FEEDBACK:36386,TRANSFORM_FEEDBACK_PAUSED:36387,TRANSFORM_FEEDBACK_ACTIVE:36388,TRANSFORM_FEEDBACK_BINDING:36389,COMPRESSED_R11_EAC:37488,COMPRESSED_SIGNED_R11_EAC:37489,COMPRESSED_RG11_EAC:37490,COMPRESSED_SIGNED_RG11_EAC:37491,COMPRESSED_RGB8_ETC2:37492,COMPRESSED_SRGB8_ETC2:37493,COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:37494,COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:37495,COMPRESSED_RGBA8_ETC2_EAC:37496,COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:37497,TEXTURE_IMMUTABLE_FORMAT:37167,MAX_ELEMENT_INDEX:36203,TEXTURE_IMMUTABLE_LEVELS:33503};return e(r)}),define("Core/ComponentDatatype",["../Renderer/WebGLConstants","./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject"],function(e,r,t,n,o,a){"use strict";if(!o.supportsTypedArrays())return{};var i={BYTE:e.BYTE,UNSIGNED_BYTE:e.UNSIGNED_BYTE,SHORT:e.SHORT,UNSIGNED_SHORT:e.UNSIGNED_SHORT,INT:e.INT,UNSIGNED_INT:e.UNSIGNED_INT,FLOAT:e.FLOAT,DOUBLE:e.DOUBLE};return i.getSizeInBytes=function(e){switch(e){case i.BYTE:return Int8Array.BYTES_PER_ELEMENT;case i.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case i.SHORT:return Int16Array.BYTES_PER_ELEMENT;case i.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case i.INT:return Int32Array.BYTES_PER_ELEMENT;case i.UNSIGNED_INT:return Uint32Array.BYTES_PER_ELEMENT;case i.FLOAT:return Float32Array.BYTES_PER_ELEMENT;case i.DOUBLE:return Float64Array.BYTES_PER_ELEMENT;default:throw new n("componentDatatype is not a valid value.")}},i.fromTypedArray=function(e){return e instanceof Int8Array?i.BYTE:e instanceof Uint8Array?i.UNSIGNED_BYTE:e instanceof Int16Array?i.SHORT:e instanceof Uint16Array?i.UNSIGNED_SHORT:e instanceof Int32Array?i.INT:e instanceof Uint32Array?i.UNSIGNED_INT:e instanceof Float32Array?i.FLOAT:e instanceof Float64Array?i.DOUBLE:void 0},i.validate=function(e){return t(e)&&(e===i.BYTE||e===i.UNSIGNED_BYTE||e===i.SHORT||e===i.UNSIGNED_SHORT||e===i.INT||e===i.UNSIGNED_INT||e===i.FLOAT||e===i.DOUBLE)},i.createTypedArray=function(e,r){switch(e){case i.BYTE:return new Int8Array(r);case i.UNSIGNED_BYTE:return new Uint8Array(r);case i.SHORT:return new Int16Array(r);case i.UNSIGNED_SHORT:return new Uint16Array(r);case i.INT:return new Int32Array(r);case i.UNSIGNED_INT:return new Uint32Array(r);case i.FLOAT:return new Float32Array(r);case i.DOUBLE:return new Float64Array(r);default:throw new n("componentDatatype is not a valid value.")}},i.createArrayBufferView=function(e,t,o,a){switch(o=r(o,0),a=r(a,(t.byteLength-o)/i.getSizeInBytes(e)),e){case i.BYTE:return new Int8Array(t,o,a);case i.UNSIGNED_BYTE:return new Uint8Array(t,o,a);case i.SHORT:return new Int16Array(t,o,a);case i.UNSIGNED_SHORT:return new Uint16Array(t,o,a);case i.INT:return new Int32Array(t,o,a);case i.UNSIGNED_INT:return new Uint32Array(t,o,a);case i.FLOAT:return new Float32Array(t,o,a);case i.DOUBLE:return new Float64Array(t,o,a);default:throw new n("componentDatatype is not a valid value.")}},i.fromName=function(e){switch(e){case"BYTE":return i.BYTE;case"UNSIGNED_BYTE":return i.UNSIGNED_BYTE;case"SHORT":return i.SHORT;case"UNSIGNED_SHORT":return i.UNSIGNED_SHORT;case"INT":return i.INT;case"UNSIGNED_INT":return i.UNSIGNED_INT;case"FLOAT":return i.FLOAT;case"DOUBLE":return i.DOUBLE;default:throw new n("name is not a valid value.")}},a(i)}),define("Core/GeometryType",["./freezeObject"],function(e){"use strict";var r={NONE:0,TRIANGLES:1,LINES:2,POLYLINES:3};return e(r)}),define("Core/PrimitiveType",["../Renderer/WebGLConstants","./freezeObject"],function(e,r){"use strict";var t={POINTS:e.POINTS,LINES:e.LINES,LINE_LOOP:e.LINE_LOOP,LINE_STRIP:e.LINE_STRIP,TRIANGLES:e.TRIANGLES,TRIANGLE_STRIP:e.TRIANGLE_STRIP,TRIANGLE_FAN:e.TRIANGLE_FAN,validate:function(e){return e===t.POINTS||e===t.LINES||e===t.LINE_LOOP||e===t.LINE_STRIP||e===t.TRIANGLES||e===t.TRIANGLE_STRIP||e===t.TRIANGLE_FAN}};return r(t)}),define("Core/Geometry",["./defaultValue","./defined","./DeveloperError","./GeometryType","./PrimitiveType"],function(e,r,t,n,o){"use strict";function a(r){r=e(r,e.EMPTY_OBJECT),this.attributes=r.attributes,this.indices=r.indices,this.primitiveType=e(r.primitiveType,o.TRIANGLES),this.boundingSphere=r.boundingSphere,this.geometryType=e(r.geometryType,n.NONE),this.boundingSphereCV=r.boundingSphereCV}return a.computeNumberOfVertices=function(e){var n=-1;for(var o in e.attributes)if(e.attributes.hasOwnProperty(o)&&r(e.attributes[o])&&r(e.attributes[o].values)){var a=e.attributes[o],i=a.values.length/a.componentsPerAttribute;if(n!==i&&n!==-1)throw new t("All attribute lists must have the same number of attributes.");n=i}return n},a}),define("Core/GeometryAttribute",["./defaultValue","./defined","./DeveloperError"],function(e,r,t){"use strict";function n(r){r=e(r,e.EMPTY_OBJECT),this.componentDatatype=r.componentDatatype,this.componentsPerAttribute=r.componentsPerAttribute,this.normalize=e(r.normalize,!1),this.values=r.values}return n}),define("Core/GeometryAttributes",["./defaultValue"],function(e){"use strict";function r(r){r=e(r,e.EMPTY_OBJECT),this.position=r.position,this.normal=r.normal,this.st=r.st,this.binormal=r.binormal,this.tangent=r.tangent,this.color=r.color}return r}),define("Core/Cartesian2",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,r,t,n,o){"use strict";function a(r,t){this.x=e(r,0),this.y=e(t,0)}a.fromElements=function(e,t,n){return r(n)?(n.x=e,n.y=t,n):new a(e,t)},a.clone=function(e,t){if(r(e))return r(t)?(t.x=e.x,t.y=e.y,t):new a(e.x,e.y)},a.fromCartesian3=a.clone,a.fromCartesian4=a.clone,a.packedLength=2,a.pack=function(r,t,n){return n=e(n,0),t[n++]=r.x,t[n]=r.y,t},a.unpack=function(t,n,o){return n=e(n,0),r(o)||(o=new a),o.x=t[n++],o.y=t[n],o},a.packArray=function(e,t){var n=e.length;r(t)?t.length=2*n:t=new Array(2*n);for(var o=0;o<n;++o)a.pack(e[o],t,2*o);return t},a.unpackArray=function(e,t){var n=e.length;r(t)?t.length=n/2:t=new Array(n/2);for(var o=0;o<n;o+=2){var i=o/2;t[i]=a.unpack(e,o,t[i])}return t},a.fromArray=a.unpack,a.maximumComponent=function(e){return Math.max(e.x,e.y)},a.minimumComponent=function(e){return Math.min(e.x,e.y)},a.minimumByComponent=function(e,r,t){return t.x=Math.min(e.x,r.x),t.y=Math.min(e.y,r.y),t},a.maximumByComponent=function(e,r,t){return t.x=Math.max(e.x,r.x),t.y=Math.max(e.y,r.y),t},a.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y},a.magnitude=function(e){return Math.sqrt(a.magnitudeSquared(e))};var i=new a;a.distance=function(e,r){return a.subtract(e,r,i),a.magnitude(i)},a.distanceSquared=function(e,r){return a.subtract(e,r,i),a.magnitudeSquared(i)},a.normalize=function(e,r){var t=a.magnitude(e);return r.x=e.x/t,r.y=e.y/t,r},a.dot=function(e,r){return e.x*r.x+e.y*r.y},a.multiplyComponents=function(e,r,t){return t.x=e.x*r.x,t.y=e.y*r.y,t},a.add=function(e,r,t){return t.x=e.x+r.x,t.y=e.y+r.y,t},a.subtract=function(e,r,t){return t.x=e.x-r.x,t.y=e.y-r.y,t},a.multiplyByScalar=function(e,r,t){return t.x=e.x*r,t.y=e.y*r,t},a.divideByScalar=function(e,r,t){return t.x=e.x/r,t.y=e.y/r,t},a.negate=function(e,r){return r.x=-e.x,r.y=-e.y,r},a.abs=function(e,r){return r.x=Math.abs(e.x),r.y=Math.abs(e.y),r};var u=new a;a.lerp=function(e,r,t,n){return a.multiplyByScalar(r,t,u),n=a.multiplyByScalar(e,1-t,n),a.add(u,n,n)};var s=new a,c=new a;a.angleBetween=function(e,r){return a.normalize(e,s),a.normalize(r,c),o.acosClamped(a.dot(s,c))};var l=new a;return a.mostOrthogonalAxis=function(e,r){var t=a.normalize(e,l);return a.abs(t,t),r=t.x<=t.y?a.clone(a.UNIT_X,r):a.clone(a.UNIT_Y,r)},a.equals=function(e,t){return e===t||r(e)&&r(t)&&e.x===t.x&&e.y===t.y},a.equalsArray=function(e,r,t){return e.x===r[t]&&e.y===r[t+1]},a.equalsEpsilon=function(e,t,n,a){return e===t||r(e)&&r(t)&&o.equalsEpsilon(e.x,t.x,n,a)&&o.equalsEpsilon(e.y,t.y,n,a)},a.ZERO=n(new a(0,0)),a.UNIT_X=n(new a(1,0)),a.UNIT_Y=n(new a(0,1)),a.prototype.clone=function(e){return a.clone(this,e)},a.prototype.equals=function(e){return a.equals(this,e)},a.prototype.equalsEpsilon=function(e,r,t){return a.equalsEpsilon(this,e,r,t)},a.prototype.toString=function(){return"("+this.x+", "+this.y+")"},a}),define("Core/AttributeCompression",["./Cartesian2","./Cartesian3","./defaultValue","./defined","./DeveloperError","./Math"],function(e,r,t,n,o,a){"use strict";var i={};i.octEncodeInRange=function(e,r,t){if(t.x=e.x/(Math.abs(e.x)+Math.abs(e.y)+Math.abs(e.z)),t.y=e.y/(Math.abs(e.x)+Math.abs(e.y)+Math.abs(e.z)),
e.z<0){var n=t.x,o=t.y;t.x=(1-Math.abs(o))*a.signNotZero(n),t.y=(1-Math.abs(n))*a.signNotZero(o)}return t.x=a.toSNorm(t.x,r),t.y=a.toSNorm(t.y,r),t},i.octEncode=function(e,r){return i.octEncodeInRange(e,255,r)},i.octDecodeInRange=function(e,t,n,o){if(o.x=a.fromSNorm(e,n),o.y=a.fromSNorm(t,n),o.z=1-(Math.abs(o.x)+Math.abs(o.y)),o.z<0){var i=o.x;o.x=(1-Math.abs(o.y))*a.signNotZero(i),o.y=(1-Math.abs(i))*a.signNotZero(o.y)}return r.normalize(o,o)},i.octDecode=function(e,r,t){return i.octDecodeInRange(e,r,255,t)},i.octPackFloat=function(e){return 256*e.x+e.y};var u=new e;return i.octEncodeFloat=function(e){return i.octEncode(e,u),i.octPackFloat(u)},i.octDecodeFloat=function(e,r){var t=e/256,n=Math.floor(t),o=256*(t-n);return i.octDecode(n,o,r)},i.octPack=function(e,r,t,n){var o=i.octEncodeFloat(e),a=i.octEncodeFloat(r),s=i.octEncode(t,u);return n.x=65536*s.x+o,n.y=65536*s.y+a,n},i.octUnpack=function(e,r,t,n){var o=e.x/65536,a=Math.floor(o),u=65536*(o-a);o=e.y/65536;var s=Math.floor(o),c=65536*(o-s);i.octDecodeFloat(u,r),i.octDecodeFloat(c,t),i.octDecode(a,s,n)},i.compressTextureCoordinates=function(e){var r=4095*e.x|0,t=4095*e.y|0;return 4096*r+t},i.decompressTextureCoordinates=function(e,r){var t=e/4096,n=Math.floor(t);return r.x=n/4095,r.y=(e-4096*n)/4095,r},i}),define("Core/barycentricCoordinates",["./Cartesian2","./Cartesian3","./defined","./DeveloperError"],function(e,r,t,n){"use strict";function o(n,o,s,c,l){t(l)||(l=new r);var E,f,m,h,d,p,T,R;t(o.z)?(E=r.subtract(s,o,a),f=r.subtract(c,o,i),m=r.subtract(n,o,u),h=r.dot(E,E),d=r.dot(E,f),p=r.dot(E,m),T=r.dot(f,f),R=r.dot(f,m)):(E=e.subtract(s,o,a),f=e.subtract(c,o,i),m=e.subtract(n,o,u),h=e.dot(E,E),d=e.dot(E,f),p=e.dot(E,m),T=e.dot(f,f),R=e.dot(f,m));var A=1/(h*T-d*d);return l.y=(T*p-d*R)*A,l.z=(h*R-d*p)*A,l.x=1-l.y-l.z,l}var a=new r,i=new r,u=new r;return o}),define("Core/EncodedCartesian3",["./Cartesian3","./defined","./DeveloperError"],function(e,r,t){"use strict";function n(){this.high=e.clone(e.ZERO),this.low=e.clone(e.ZERO)}n.encode=function(e,t){r(t)||(t={high:0,low:0});var n;return e>=0?(n=65536*Math.floor(e/65536),t.high=n,t.low=e-n):(n=65536*Math.floor(-e/65536),t.high=-n,t.low=e+n),t};var o={high:0,low:0};n.fromCartesian=function(e,t){r(t)||(t=new n);var a=t.high,i=t.low;return n.encode(e.x,o),a.x=o.high,i.x=o.low,n.encode(e.y,o),a.y=o.high,i.y=o.low,n.encode(e.z,o),a.z=o.high,i.z=o.low,t};var a=new n;return n.writeElements=function(e,r,t){n.fromCartesian(e,a);var o=a.high,i=a.low;r[t]=o.x,r[t+1]=o.y,r[t+2]=o.z,r[t+3]=i.x,r[t+4]=i.y,r[t+5]=i.z},n}),define("Core/GeometryInstance",["./defaultValue","./defined","./DeveloperError","./Matrix4"],function(e,r,t,n){"use strict";function o(r){r=e(r,e.EMPTY_OBJECT),this.geometry=r.geometry,this.modelMatrix=n.clone(e(r.modelMatrix,n.IDENTITY)),this.id=r.id,this.pickPrimitive=r.pickPrimitive,this.attributes=e(r.attributes,{}),this.westHemisphereGeometry=void 0,this.eastHemisphereGeometry=void 0}return o}),define("Core/IndexDatatype",["../Renderer/WebGLConstants","./defined","./DeveloperError","./freezeObject","./Math"],function(e,r,t,n,o){"use strict";var a={UNSIGNED_BYTE:e.UNSIGNED_BYTE,UNSIGNED_SHORT:e.UNSIGNED_SHORT,UNSIGNED_INT:e.UNSIGNED_INT};return a.getSizeInBytes=function(e){switch(e){case a.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case a.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case a.UNSIGNED_INT:return Uint32Array.BYTES_PER_ELEMENT}},a.validate=function(e){return r(e)&&(e===a.UNSIGNED_BYTE||e===a.UNSIGNED_SHORT||e===a.UNSIGNED_INT)},a.createTypedArray=function(e,r){return e>=o.SIXTY_FOUR_KILOBYTES?new Uint32Array(r):new Uint16Array(r)},a.createTypedArrayFromArrayBuffer=function(e,r,t,n){return e>=o.SIXTY_FOUR_KILOBYTES?new Uint32Array(r,t,n):new Uint16Array(r,t,n)},n(a)}),define("Core/QuadraticRealPolynomial",["./DeveloperError","./Math"],function(e,r){"use strict";function t(e,t,n){var o=e+t;return r.sign(e)!==r.sign(t)&&Math.abs(o/Math.max(Math.abs(e),Math.abs(t)))<n?0:o}var n={};return n.computeDiscriminant=function(e,r,t){var n=r*r-4*e*t;return n},n.computeRealRoots=function(e,n,o){var a;if(0===e)return 0===n?[]:[-o/n];if(0===n){if(0===o)return[0,0];var i=Math.abs(o),u=Math.abs(e);if(i<u&&i/u<r.EPSILON14)return[0,0];if(i>u&&u/i<r.EPSILON14)return[];if(a=-o/e,a<0)return[];var s=Math.sqrt(a);return[-s,s]}if(0===o)return a=-n/e,a<0?[a,0]:[0,a];var c=n*n,l=4*e*o,E=t(c,-l,r.EPSILON14);if(E<0)return[];var f=-.5*t(n,r.sign(n)*Math.sqrt(E),r.EPSILON14);return n>0?[f/e,o/f]:[o/f,f/e]},n}),define("Core/CubicRealPolynomial",["./DeveloperError","./QuadraticRealPolynomial"],function(e,r){"use strict";function t(e,r,t,n){var o,a,i=e,u=r/3,s=t/3,c=n,l=i*s,E=u*c,f=u*u,m=s*s,h=i*s-f,d=i*c-u*s,p=u*c-m,T=4*h*p-d*d;if(T<0){var R,A,_;f*E>=l*m?(R=i,A=h,_=-2*u*h+i*d):(R=c,A=p,_=-c*d+2*s*p);var y=_<0?-1:1,S=-y*Math.abs(R)*Math.sqrt(-T);a=-_+S;var N=a/2,C=N<0?-Math.pow(-N,1/3):Math.pow(N,1/3),v=a===S?-C:-A/C;return o=A<=0?C+v:-_/(C*C+v*v+A),f*E>=l*m?[(o-u)/i]:[-c/(o+s)]}var g=h,I=-2*u*h+i*d,M=p,O=-c*d+2*s*p,L=Math.sqrt(T),F=Math.sqrt(3)/2,P=Math.abs(Math.atan2(i*L,-I)/3);o=2*Math.sqrt(-g);var w=Math.cos(P);a=o*w;var D=o*(-w/2-F*Math.sin(P)),x=a+D>2*u?a-u:D-u,U=i,b=x/U;P=Math.abs(Math.atan2(c*L,-O)/3),o=2*Math.sqrt(-M),w=Math.cos(P),a=o*w,D=o*(-w/2-F*Math.sin(P));var B=-c,G=a+D<2*s?a+s:D+s,z=B/G,V=U*G,H=-x*G-U*B,W=x*B,q=(s*H-u*W)/(-u*H+s*V);return b<=q?b<=z?q<=z?[b,q,z]:[b,z,q]:[z,b,q]:b<=z?[q,b,z]:q<=z?[q,z,b]:[z,q,b]}var n={};return n.computeDiscriminant=function(e,r,t,n){var o=e*e,a=r*r,i=t*t,u=n*n,s=18*e*r*t*n+a*i-27*o*u-4*(e*i*t+a*r*n);return s},n.computeRealRoots=function(e,n,o,a){var i,u;if(0===e)return r.computeRealRoots(n,o,a);if(0===n){if(0===o){if(0===a)return[0,0,0];u=-a/e;var s=u<0?-Math.pow(-u,1/3):Math.pow(u,1/3);return[s,s,s]}return 0===a?(i=r.computeRealRoots(e,0,o),0===i.Length?[0]:[i[0],0,i[1]]):t(e,0,o,a)}return 0===o?0===a?(u=-n/e,u<0?[u,0,0]:[0,0,u]):t(e,n,0,a):0===a?(i=r.computeRealRoots(e,n,o),0===i.length?[0]:i[1]<=0?[i[0],i[1],0]:i[0]>=0?[0,i[0],i[1]]:[i[0],0,i[1]]):t(e,n,o,a)},n}),define("Core/QuarticRealPolynomial",["./CubicRealPolynomial","./DeveloperError","./Math","./QuadraticRealPolynomial"],function(e,r,t,n){"use strict";function o(r,o,a,i){var u=r*r,s=o-3*u/8,c=a-o*r/2+u*r/8,l=i-a*r/4+o*u/16-3*u*u/256,E=e.computeRealRoots(1,2*s,s*s-4*l,-c*c);if(E.length>0){var f=-r/4,m=E[E.length-1];if(Math.abs(m)<t.EPSILON14){var h=n.computeRealRoots(1,s,l);if(2===h.length){var d,p=h[0],T=h[1];if(p>=0&&T>=0){var R=Math.sqrt(p),A=Math.sqrt(T);return[f-A,f-R,f+R,f+A]}if(p>=0&&T<0)return d=Math.sqrt(p),[f-d,f+d];if(p<0&&T>=0)return d=Math.sqrt(T),[f-d,f+d]}return[]}if(m>0){var _=Math.sqrt(m),y=(s+m-c/_)/2,S=(s+m+c/_)/2,N=n.computeRealRoots(1,_,y),C=n.computeRealRoots(1,-_,S);return 0!==N.length?(N[0]+=f,N[1]+=f,0!==C.length?(C[0]+=f,C[1]+=f,N[1]<=C[0]?[N[0],N[1],C[0],C[1]]:C[1]<=N[0]?[C[0],C[1],N[0],N[1]]:N[0]>=C[0]&&N[1]<=C[1]?[C[0],N[0],N[1],C[1]]:C[0]>=N[0]&&C[1]<=N[1]?[N[0],C[0],C[1],N[1]]:N[0]>C[0]&&N[0]<C[1]?[C[0],N[0],C[1],N[1]]:[N[0],C[0],N[1],C[1]]):N):0!==C.length?(C[0]+=f,C[1]+=f,C):[]}}return[]}function a(r,o,a,i){var u=a*a,s=o*o,c=r*r,l=-2*o,E=a*r+s-4*i,f=c*i-a*o*r+u,m=e.computeRealRoots(1,l,E,f);if(m.length>0){var h,d,p=m[0],T=o-p,R=T*T,A=r/2,_=T/2,y=R-4*i,S=R+4*Math.abs(i),N=c-4*p,C=c+4*Math.abs(p);if(p<0||y*C<N*S){var v=Math.sqrt(N);h=v/2,d=0===v?0:(r*_-a)/v}else{var g=Math.sqrt(y);h=0===g?0:(r*_-a)/g,d=g/2}var I,M;0===A&&0===h?(I=0,M=0):t.sign(A)===t.sign(h)?(I=A+h,M=p/I):(M=A-h,I=p/M);var O,L;0===_&&0===d?(O=0,L=0):t.sign(_)===t.sign(d)?(O=_+d,L=i/O):(L=_-d,O=i/L);var F=n.computeRealRoots(1,I,O),P=n.computeRealRoots(1,M,L);if(0!==F.length)return 0!==P.length?F[1]<=P[0]?[F[0],F[1],P[0],P[1]]:P[1]<=F[0]?[P[0],P[1],F[0],F[1]]:F[0]>=P[0]&&F[1]<=P[1]?[P[0],F[0],F[1],P[1]]:P[0]>=F[0]&&P[1]<=F[1]?[F[0],P[0],P[1],F[1]]:F[0]>P[0]&&F[0]<P[1]?[P[0],F[0],P[1],F[1]]:[F[0],P[0],F[1],P[1]]:F;if(0!==P.length)return P}return[]}var i={};return i.computeDiscriminant=function(e,r,t,n,o){var a=e*e,i=a*e,u=r*r,s=u*r,c=t*t,l=c*t,E=n*n,f=E*n,m=o*o,h=m*o,d=u*c*E-4*s*f-4*e*l*E+18*e*r*t*f-27*a*E*E+256*i*h+o*(18*s*t*n-4*u*l+16*e*c*c-80*e*r*c*n-6*e*u*E+144*a*t*E)+m*(144*e*u*t-27*u*u-128*a*c-192*a*r*n);return d},i.computeRealRoots=function(r,n,i,u,s){if(Math.abs(r)<t.EPSILON15)return e.computeRealRoots(n,i,u,s);var c=n/r,l=i/r,E=u/r,f=s/r,m=c<0?1:0;switch(m+=l<0?m+1:m,m+=E<0?m+1:m,m+=f<0?m+1:m){case 0:return o(c,l,E,f);case 1:return a(c,l,E,f);case 2:return a(c,l,E,f);case 3:return o(c,l,E,f);case 4:return o(c,l,E,f);case 5:return a(c,l,E,f);case 6:return o(c,l,E,f);case 7:return o(c,l,E,f);case 8:return a(c,l,E,f);case 9:return o(c,l,E,f);case 10:return o(c,l,E,f);case 11:return a(c,l,E,f);case 12:return o(c,l,E,f);case 13:return o(c,l,E,f);case 14:return o(c,l,E,f);case 15:return o(c,l,E,f);default:return}},i}),define("Core/Ray",["./Cartesian3","./defaultValue","./defined","./DeveloperError"],function(e,r,t,n){"use strict";function o(t,n){n=e.clone(r(n,e.ZERO)),e.equals(n,e.ZERO)||e.normalize(n,n),this.origin=e.clone(r(t,e.ZERO)),this.direction=n}return o.getPoint=function(r,n,o){return t(o)||(o=new e),o=e.multiplyByScalar(r.direction,n,o),e.add(r.origin,o,o)},o}),define("Core/IntersectionTests",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Math","./Matrix3","./QuadraticRealPolynomial","./QuarticRealPolynomial","./Ray"],function(e,r,t,n,o,a,i,u,s,c){"use strict";function l(e,r,t,n){var o=r*r-4*e*t;if(!(o<0)){if(o>0){var a=1/(2*e),i=Math.sqrt(o),u=(-r+i)*a,s=(-r-i)*a;return u<s?(n.root0=u,n.root1=s):(n.root0=s,n.root1=u),n}var c=-r/(2*e);if(0!==c)return n.root0=n.root1=c,n}}function E(r,t,o){n(o)||(o={});var a=r.origin,i=r.direction,u=t.center,s=t.radius*t.radius,c=e.subtract(a,u,T),E=e.dot(i,i),f=2*e.dot(i,c),m=e.magnitudeSquared(c)-s,h=l(E,f,m,y);if(n(h))return o.start=h.root0,o.stop=h.root1,o}function f(e,r,t){var n=e+r;return a.sign(e)!==a.sign(r)&&Math.abs(n/Math.max(Math.abs(e),Math.abs(r)))<t?0:n}function m(r,t,n,o,c){var l,E=o*o,m=c*c,h=(r[i.COLUMN1ROW1]-r[i.COLUMN2ROW2])*m,d=c*(o*f(r[i.COLUMN1ROW0],r[i.COLUMN0ROW1],a.EPSILON15)+t.y),p=r[i.COLUMN0ROW0]*E+r[i.COLUMN2ROW2]*m+o*t.x+n,T=m*f(r[i.COLUMN2ROW1],r[i.COLUMN1ROW2],a.EPSILON15),R=c*(o*f(r[i.COLUMN2ROW0],r[i.COLUMN0ROW2])+t.z),A=[];if(0===R&&0===T){if(l=u.computeRealRoots(h,d,p),0===l.length)return A;var _=l[0],y=Math.sqrt(Math.max(1-_*_,0));if(A.push(new e(o,c*_,c*-y)),A.push(new e(o,c*_,c*y)),2===l.length){var S=l[1],N=Math.sqrt(Math.max(1-S*S,0));A.push(new e(o,c*S,c*-N)),A.push(new e(o,c*S,c*N))}return A}var C=R*R,v=T*T,g=h*h,I=R*T,M=g+v,O=2*(d*h+I),L=2*p*h+d*d-v+C,F=2*(p*d-I),P=p*p-C;if(0===M&&0===O&&0===L&&0===F)return A;l=s.computeRealRoots(M,O,L,F,P);var w=l.length;if(0===w)return A;for(var D=0;D<w;++D){var x,U=l[D],b=U*U,B=Math.max(1-b,0),G=Math.sqrt(B);x=a.sign(h)===a.sign(p)?f(h*b+p,d*U,a.EPSILON12):a.sign(p)===a.sign(d*U)?f(h*b,d*U+p,a.EPSILON12):f(h*b+d*U,p,a.EPSILON12);var z=f(T*U,R,a.EPSILON15),V=x*z;V<0?A.push(new e(o,c*U,c*G)):V>0?A.push(new e(o,c*U,c*-G)):0!==G?(A.push(new e(o,c*U,c*-G)),A.push(new e(o,c*U,c*G)),++D):A.push(new e(o,c*U,c*G))}return A}var h={};h.rayPlane=function(r,t,o){n(o)||(o=new e);var i=r.origin,u=r.direction,s=t.normal,c=e.dot(s,u);if(!(Math.abs(c)<a.EPSILON15)){var l=(-t.distance-e.dot(s,i))/c;if(!(l<0))return o=e.multiplyByScalar(u,l,o),e.add(i,o,o)}};var d=new e,p=new e,T=new e,R=new e,A=new e;h.rayTriangleParametric=function(r,n,o,i,u){u=t(u,!1);var s,c,l,E,f,m=r.origin,h=r.direction,_=e.subtract(o,n,d),y=e.subtract(i,n,p),S=e.cross(h,y,T),N=e.dot(_,S);if(u){if(N<a.EPSILON6)return;if(s=e.subtract(m,n,R),l=e.dot(s,S),l<0||l>N)return;if(c=e.cross(s,_,A),E=e.dot(h,c),E<0||l+E>N)return;f=e.dot(y,c)/N}else{if(Math.abs(N)<a.EPSILON6)return;var C=1/N;if(s=e.subtract(m,n,R),l=e.dot(s,S)*C,l<0||l>1)return;if(c=e.cross(s,_,A),E=e.dot(h,c)*C,E<0||l+E>1)return;f=e.dot(y,c)*C}return f},h.rayTriangle=function(r,t,o,a,i,u){var s=h.rayTriangleParametric(r,t,o,a,i);if(n(s)&&!(s<0))return n(u)||(u=new e),e.multiplyByScalar(r.direction,s,u),e.add(r.origin,u,u)};var _=new c;h.lineSegmentTriangle=function(r,t,o,a,i,u,s){var c=_;e.clone(r,c.origin),e.subtract(t,r,c.direction),e.normalize(c.direction,c.direction);var l=h.rayTriangleParametric(c,o,a,i,u);if(!(!n(l)||l<0||l>e.distance(r,t)))return n(s)||(s=new e),e.multiplyByScalar(c.direction,l,s),e.add(c.origin,s,s)};var y={root0:0,root1:0};h.raySphere=function(e,r,t){if(t=E(e,r,t),n(t)&&!(t.stop<0))return t.start=Math.max(t.start,0),t};var S=new c;h.lineSegmentSphere=function(r,t,o,a){var i=S;e.clone(r,i.origin);var u=e.subtract(t,r,i.direction),s=e.magnitude(u);if(e.normalize(u,u),a=E(i,o,a),!(!n(a)||a.stop<0||a.start>s))return a.start=Math.max(a.start,0),a.stop=Math.min(a.stop,s),a};var N=new e,C=new e;h.rayEllipsoid=function(r,t){var n,o,a,i,u,s=t.oneOverRadii,c=e.multiplyComponents(s,r.origin,N),l=e.multiplyComponents(s,r.direction,C),E=e.magnitudeSquared(c),f=e.dot(c,l);if(E>1){if(f>=0)return;var m=f*f;if(n=E-1,o=e.magnitudeSquared(l),a=o*n,m<a)return;if(m>a){i=f*f-a,u=-f+Math.sqrt(i);var h=u/o,d=n/u;return h<d?{start:h,stop:d}:{start:d,stop:h}}var p=Math.sqrt(n/o);return{start:p,stop:p}}return E<1?(n=E-1,o=e.magnitudeSquared(l),a=o*n,i=f*f-a,u=-f+Math.sqrt(i),{start:0,stop:u/o}):f<0?(o=e.magnitudeSquared(l),{start:0,stop:-f/o}):void 0};var v=new e,g=new e,I=new e,M=new e,O=new e,L=new i,F=new i,P=new i,w=new i,D=new i,x=new i,U=new i,b=new e,B=new e,G=new r;h.grazingAltitudeLocation=function(r,t){var o=r.origin,u=r.direction,s=t.geodeticSurfaceNormal(o,v);if(e.dot(u,s)>=0)return o;var c=n(this.rayEllipsoid(r,t)),l=t.transformPositionToScaledSpace(u,v),E=e.normalize(l,l),f=e.mostOrthogonalAxis(l,M),h=e.normalize(e.cross(f,E,g),g),d=e.normalize(e.cross(E,h,I),I),p=L;p[0]=E.x,p[1]=E.y,p[2]=E.z,p[3]=h.x,p[4]=h.y,p[5]=h.z,p[6]=d.x,p[7]=d.y,p[8]=d.z;var T=i.transpose(p,F),R=i.fromScale(t.radii,P),A=i.fromScale(t.oneOverRadii,w),_=D;_[0]=0,_[1]=-u.z,_[2]=u.y,_[3]=u.z,_[4]=0,_[5]=-u.x,_[6]=-u.y,_[7]=u.x,_[8]=0;var y,S,N=i.multiply(i.multiply(T,A,x),_,x),C=i.multiply(i.multiply(N,R,U),p,U),z=i.multiplyByVector(N,o,O),V=m(C,e.negate(z,v),0,0,1),H=V.length;if(H>0){for(var W=e.clone(e.ZERO,B),q=Number.NEGATIVE_INFINITY,X=0;X<H;++X){y=i.multiplyByVector(R,i.multiplyByVector(p,V[X],b),b);var Y=e.normalize(e.subtract(y,o,M),M),k=e.dot(Y,u);k>q&&(q=k,W=e.clone(y,W))}var K=t.cartesianToCartographic(W,G);return q=a.clamp(q,0,1),S=e.magnitude(e.subtract(W,o,M))*Math.sqrt(1-q*q),S=c?-S:S,K.height=S,t.cartographicToCartesian(K,new e)}};var z=new e;return h.lineSegmentPlane=function(r,t,o,i){n(i)||(i=new e);var u=e.subtract(t,r,z),s=o.normal,c=e.dot(s,u);if(!(Math.abs(c)<a.EPSILON6)){var l=e.dot(s,r),E=-(o.distance+l)/c;if(!(E<0||E>1))return e.multiplyByScalar(u,E,i),e.add(r,i,i),i}},h.trianglePlaneIntersection=function(r,t,n,o){var a=o.normal,i=o.distance,u=e.dot(a,r)+i<0,s=e.dot(a,t)+i<0,c=e.dot(a,n)+i<0,l=0;l+=u?1:0,l+=s?1:0,l+=c?1:0;var E,f;if(1!==l&&2!==l||(E=new e,f=new e),1===l){if(u)return h.lineSegmentPlane(r,t,o,E),h.lineSegmentPlane(r,n,o,f),{positions:[r,t,n,E,f],indices:[0,3,4,1,2,4,1,4,3]};if(s)return h.lineSegmentPlane(t,n,o,E),h.lineSegmentPlane(t,r,o,f),{positions:[r,t,n,E,f],indices:[1,3,4,2,0,4,2,4,3]};if(c)return h.lineSegmentPlane(n,r,o,E),h.lineSegmentPlane(n,t,o,f),{positions:[r,t,n,E,f],indices:[2,3,4,0,1,4,0,4,3]}}else if(2===l){if(!u)return h.lineSegmentPlane(t,r,o,E),h.lineSegmentPlane(n,r,o,f),{positions:[r,t,n,E,f],indices:[1,2,4,1,4,3,0,3,4]};if(!s)return h.lineSegmentPlane(n,t,o,E),h.lineSegmentPlane(r,t,o,f),{positions:[r,t,n,E,f],indices:[2,0,4,2,4,3,1,3,4]};if(!c)return h.lineSegmentPlane(r,n,o,E),h.lineSegmentPlane(t,n,o,f),{positions:[r,t,n,E,f],indices:[0,1,4,0,4,3,2,3,4]}}},h}),define("Core/Tipsify",["./defaultValue","./defined","./DeveloperError"],function(e,r,t){"use strict";var n={};return n.calculateACMR=function(t){t=e(t,e.EMPTY_OBJECT);var n=t.indices,o=t.maximumIndex,a=e(t.cacheSize,24),i=n.length;if(!r(o)){o=0;for(var u=0,s=n[u];u<i;)s>o&&(o=s),++u,s=n[u]}for(var c=[],l=0;l<o+1;l++)c[l]=0;for(var E=a+1,f=0;f<i;++f)E-c[n[f]]>a&&(c[n[f]]=E,++E);return(E-a+1)/(i/3)},n.tipsify=function(t){function n(e,r,t,n){for(;r.length>=1;){var o=r[r.length-1];if(r.splice(r.length-1,1),e[o].numLiveTriangles>0)return o}for(;a<n;){if(e[a].numLiveTriangles>0)return++a,a-1;++a}return-1}function o(e,r,t,o,a,i,u){for(var s,c=-1,l=-1,E=0;E<t.length;){var f=t[E];o[f].numLiveTriangles&&(s=0,a-o[f].timeStamp+2*o[f].numLiveTriangles<=r&&(s=a-o[f].timeStamp),(s>l||l===-1)&&(l=s,c=f)),++E}return c===-1?n(o,i,e,u):c}t=e(t,e.EMPTY_OBJECT);var a,i=t.indices,u=t.maximumIndex,s=e(t.cacheSize,24),c=i.length,l=0,E=0,f=i[E],m=c;if(r(u))l=u+1;else{for(;E<m;)f>l&&(l=f),++E,f=i[E];if(l===-1)return 0;++l}for(var h=[],d=0;d<l;d++)h[d]={numLiveTriangles:0,timeStamp:0,vertexTriangles:[]};E=0;for(var p=0;E<m;)h[i[E]].vertexTriangles.push(p),++h[i[E]].numLiveTriangles,h[i[E+1]].vertexTriangles.push(p),++h[i[E+1]].numLiveTriangles,h[i[E+2]].vertexTriangles.push(p),++h[i[E+2]].numLiveTriangles,++p,E+=3;var T=0,R=s+1;a=1;var A,_,y=[],S=[],N=0,C=[],v=c/3,g=[];for(d=0;d<v;d++)g[d]=!1;for(var I,M;T!==-1;){y=[],_=h[T],M=_.vertexTriangles.length;for(var O=0;O<M;++O)if(p=_.vertexTriangles[O],!g[p]){g[p]=!0,E=p+p+p;for(var L=0;L<3;++L)I=i[E],y.push(I),S.push(I),C[N]=I,++N,A=h[I],--A.numLiveTriangles,R-A.timeStamp>s&&(A.timeStamp=R,++R),++E}T=o(i,s,y,h,R,S,l)}return C},n}),define("Core/GeometryPipeline",["./AttributeCompression","./barycentricCoordinates","./BoundingSphere","./Cartesian2","./Cartesian3","./Cartesian4","./Cartographic","./ComponentDatatype","./defaultValue","./defined","./DeveloperError","./EncodedCartesian3","./GeographicProjection","./Geometry","./GeometryAttribute","./GeometryInstance","./GeometryType","./IndexDatatype","./Intersect","./IntersectionTests","./Math","./Matrix3","./Matrix4","./Plane","./PrimitiveType","./Tipsify"],function(e,r,t,n,o,a,i,u,s,c,l,E,f,m,h,d,p,T,R,A,_,y,S,N,C,v){"use strict";function g(e,r,t,n,o){e[r++]=t,e[r++]=n,e[r++]=n,e[r++]=o,e[r++]=o,e[r]=t}function I(e){for(var r=e.length,t=r/3*6,n=T.createTypedArray(r,t),o=0,a=0;a<r;a+=3,o+=6)g(n,o,e[a],e[a+1],e[a+2]);return n}function M(e){var r=e.length;if(r>=3){var t=6*(r-2),n=T.createTypedArray(r,t);g(n,0,e[0],e[1],e[2]);for(var o=6,a=3;a<r;++a,o+=6)g(n,o,e[a-1],e[a],e[a-2]);return n}return new Uint16Array}function O(e){if(e.length>0){for(var r=e.length-1,t=6*(r-1),n=T.createTypedArray(r,t),o=e[0],a=0,i=1;i<r;++i,a+=6)g(n,a,o,e[i],e[i+1]);return n}return new Uint16Array}function L(e){var r={};for(var t in e)if(e.hasOwnProperty(t)&&c(e[t])&&c(e[t].values)){var n=e[t];r[t]=new h({componentDatatype:n.componentDatatype,componentsPerAttribute:n.componentsPerAttribute,normalize:n.normalize,values:[]})}return r}function F(e,r,t){for(var n in r)if(r.hasOwnProperty(n)&&c(r[n])&&c(r[n].values))for(var o=r[n],a=0;a<o.componentsPerAttribute;++a)e[n].values.push(o.values[t*o.componentsPerAttribute+a])}function P(e,r){if(c(r))for(var t=r.values,n=t.length,a=0;a<n;a+=3)o.unpack(t,a,ie),S.multiplyByPoint(e,ie,ie),o.pack(ie,t,a)}function w(e,r){if(c(r))for(var t=r.values,n=t.length,a=0;a<n;a+=3)o.unpack(t,a,ie),y.multiplyByVector(e,ie,ie),ie=o.normalize(ie,ie),o.pack(ie,t,a)}function D(e,r){var t,n=e.length,o={},a=e[0][r].attributes;for(t in a)if(a.hasOwnProperty(t)&&c(a[t])&&c(a[t].values)){for(var i=a[t],s=i.values.length,l=!0,E=1;E<n;++E){var f=e[E][r].attributes[t];if(!c(f)||i.componentDatatype!==f.componentDatatype||i.componentsPerAttribute!==f.componentsPerAttribute||i.normalize!==f.normalize){l=!1;break}s+=f.values.length}l&&(o[t]=new h({componentDatatype:i.componentDatatype,componentsPerAttribute:i.componentsPerAttribute,normalize:i.normalize,values:u.createTypedArray(i.componentDatatype,s)}))}return o}function x(e,r){var n,a,i,u,s,l,E,f=e.length,h=(e[0].modelMatrix,c(e[0][r].indices)),d=e[0][r].primitiveType,p=D(e,r);for(n in p)if(p.hasOwnProperty(n))for(s=p[n].values,u=0,a=0;a<f;++a)for(l=e[a][r].attributes[n].values,E=l.length,i=0;i<E;++i)s[u++]=l[i];var R;if(h){var A=0;for(a=0;a<f;++a)A+=e[a][r].indices.length;var _=m.computeNumberOfVertices(new m({attributes:p,primitiveType:C.POINTS})),y=T.createTypedArray(_,A),S=0,N=0;for(a=0;a<f;++a){var v=e[a][r].indices,g=v.length;for(u=0;u<g;++u)y[S++]=N+v[u];N+=m.computeNumberOfVertices(e[a][r])}R=y}var I,M=new o,O=0;for(a=0;a<f;++a){if(I=e[a][r].boundingSphere,!c(I)){M=void 0;break}o.add(I.center,M,M)}if(c(M))for(o.divideByScalar(M,f,M),a=0;a<f;++a){I=e[a][r].boundingSphere;var L=o.magnitude(o.subtract(I.center,M,ce))+I.radius;L>O&&(O=L)}return new m({attributes:p,indices:R,primitiveType:d,boundingSphere:c(M)?new t(M,O):void 0})}function U(e){if(c(e.indices))return e;for(var r=m.computeNumberOfVertices(e),t=T.createTypedArray(r,r),n=0;n<r;++n)t[n]=n;return e.indices=t,e}function b(e){var r=m.computeNumberOfVertices(e),t=T.createTypedArray(r,3*(r-2));t[0]=1,t[1]=0,t[2]=2;for(var n=3,o=3;o<r;++o)t[n++]=o-1,t[n++]=0,t[n++]=o;return e.indices=t,e.primitiveType=C.TRIANGLES,e}function B(e){var r=m.computeNumberOfVertices(e),t=T.createTypedArray(r,3*(r-2));t[0]=0,t[1]=1,t[2]=2,r>3&&(t[3]=0,t[4]=2,t[5]=3);for(var n=6,o=3;o<r-1;o+=2)t[n++]=o,t[n++]=o-1,t[n++]=o+1,o+2<r&&(t[n++]=o,t[n++]=o+1,t[n++]=o+2);return e.indices=t,e.primitiveType=C.TRIANGLES,e}function G(e){if(c(e.indices))return e;for(var r=m.computeNumberOfVertices(e),t=T.createTypedArray(r,r),n=0;n<r;++n)t[n]=n;return e.indices=t,e}function z(e){var r=m.computeNumberOfVertices(e),t=T.createTypedArray(r,2*(r-1));t[0]=0,t[1]=1;for(var n=2,o=2;o<r;++o)t[n++]=o-1,t[n++]=o;return e.indices=t,e.primitiveType=C.LINES,e}function V(e){var r=m.computeNumberOfVertices(e),t=T.createTypedArray(r,2*r);t[0]=0,t[1]=1;for(var n=2,o=2;o<r;++o)t[n++]=o-1,t[n++]=o;return t[n++]=r-1,t[n]=0,e.indices=t,e.primitiveType=C.LINES,e}function H(e){switch(e.primitiveType){case C.TRIANGLE_FAN:return b(e);case C.TRIANGLE_STRIP:return B(e);case C.TRIANGLES:return U(e);case C.LINE_STRIP:return z(e);case C.LINE_LOOP:return V(e);case C.LINES:return G(e)}return e}function W(e,r){Math.abs(e.y)<_.EPSILON6&&(r?e.y=-_.EPSILON6:e.y=_.EPSILON6)}function q(e,r,t){if(0!==e.y&&0!==r.y&&0!==t.y)return W(e,e.y<0),W(r,r.y<0),void W(t,t.y<0);var n,o=Math.abs(e.y),a=Math.abs(r.y),i=Math.abs(t.y);n=o>a?o>i?_.sign(e.y):_.sign(t.y):a>i?_.sign(r.y):_.sign(t.y);var u=n<0;W(e,u),W(r,u),W(t,u)}function X(e,r,t,n){o.add(e,o.multiplyByScalar(o.subtract(r,e,ye),e.y/(e.y-r.y),ye),t),o.clone(t,n),W(t,!0),W(n,!1)}function Y(e,r,t){if(!(e.x>=0||r.x>=0||t.x>=0)){q(e,r,t);var n=e.y<0,o=r.y<0,a=t.y<0,i=0;i+=n?1:0,i+=o?1:0,i+=a?1:0;var u=ge.indices;1===i?(u[1]=3,u[2]=4,u[5]=6,u[7]=6,u[8]=5,n?(X(e,r,Se,Ce),X(e,t,Ne,ve),u[0]=0,u[3]=1,u[4]=2,u[6]=1):o?(X(r,t,Se,Ce),X(r,e,Ne,ve),u[0]=1,u[3]=2,u[4]=0,u[6]=2):a&&(X(t,e,Se,Ce),X(t,r,Ne,ve),u[0]=2,u[3]=0,u[4]=1,u[6]=0)):2===i&&(u[2]=4,u[4]=4,u[5]=3,u[7]=5,u[8]=6,n?o?a||(X(t,e,Se,Ce),X(t,r,Ne,ve),u[0]=0,u[1]=1,u[3]=0,u[6]=2):(X(r,t,Se,Ce),X(r,e,Ne,ve),u[0]=2,u[1]=0,u[3]=2,u[6]=1):(X(e,r,Se,Ce),X(e,t,Ne,ve),u[0]=1,u[1]=2,u[3]=1,u[6]=0));var s=ge.positions;return s[0]=e,s[1]=r,s[2]=t,s.length=3,1!==i&&2!==i||(s[3]=Se,s[4]=Ne,s[5]=Ce,s[6]=ve,s.length=7),ge}}function k(e,r){var n=e.attributes;if(0!==n.position.values.length){for(var o in n)if(n.hasOwnProperty(o)&&c(n[o])&&c(n[o].values)){var a=n[o];a.values=u.createTypedArray(a.componentDatatype,a.values)}var i=m.computeNumberOfVertices(e);return e.indices=T.createTypedArray(i,e.indices),r&&(e.boundingSphere=t.fromVertices(n.position.values)),e}}function K(e){var r=e.attributes,t={};for(var n in r)if(r.hasOwnProperty(n)&&c(r[n])&&c(r[n].values)){var o=r[n];t[n]=new h({componentDatatype:o.componentDatatype,componentsPerAttribute:o.componentsPerAttribute,normalize:o.normalize,values:[]})}return new m({attributes:t,indices:[],primitiveType:e.primitiveType})}function Z(e,r,t){var n=c(e.geometry.boundingSphere);r=k(r,n),t=k(t,n),c(t)&&!c(r)?e.geometry=t:!c(t)&&c(r)?e.geometry=r:(e.westHemisphereGeometry=r,e.eastHemisphereGeometry=t,e.geometry=void 0)}function j(e,t,a,i,u,s,l,E,f,m,h){if(c(s)||c(l)||c(E)||c(f)){var d=o.fromArray(u,3*e,Ie),p=o.fromArray(u,3*t,Me),T=o.fromArray(u,3*a,Oe),R=r(i,d,p,T,Le);if(c(s)){var A=o.fromArray(s,3*e,Ie),_=o.fromArray(s,3*t,Me),y=o.fromArray(s,3*a,Oe);o.multiplyByScalar(A,R.x,A),o.multiplyByScalar(_,R.y,_),o.multiplyByScalar(y,R.z,y);var S=o.add(A,_,A);o.add(S,y,S),o.normalize(S,S),o.pack(S,m.normal.values,3*h)}if(c(l)){var N=o.fromArray(l,3*e,Ie),C=o.fromArray(l,3*t,Me),v=o.fromArray(l,3*a,Oe);o.multiplyByScalar(N,R.x,N),o.multiplyByScalar(C,R.y,C),o.multiplyByScalar(v,R.z,v);var g=o.add(N,C,N);o.add(g,v,g),o.normalize(g,g),o.pack(g,m.binormal.values,3*h)}if(c(E)){var I=o.fromArray(E,3*e,Ie),M=o.fromArray(E,3*t,Me),O=o.fromArray(E,3*a,Oe);o.multiplyByScalar(I,R.x,I),o.multiplyByScalar(M,R.y,M),o.multiplyByScalar(O,R.z,O);var L=o.add(I,M,I);o.add(L,O,L),o.normalize(L,L),o.pack(L,m.tangent.values,3*h)}if(c(f)){var F=n.fromArray(f,2*e,Fe),P=n.fromArray(f,2*t,Pe),w=n.fromArray(f,2*a,we);n.multiplyByScalar(F,R.x,F),n.multiplyByScalar(P,R.y,P),n.multiplyByScalar(w,R.z,w);var D=n.add(F,P,F);n.add(D,w,D),n.pack(D,m.st.values,2*h)}}}function Q(e,r,t,n,o,a){var i=e.position.values.length/3;if(o!==-1){var u=n[o],s=t[u];return s===-1?(t[u]=i,e.position.values.push(a.x,a.y,a.z),r.push(i),i):(r.push(s),s)}return e.position.values.push(a.x,a.y,a.z),r.push(i),i}function J(e){var r,t,n,a,i,u=e.geometry,s=u.attributes,l=s.position.values,E=c(s.normal)?s.normal.values:void 0,f=c(s.binormal)?s.binormal.values:void 0,m=c(s.tangent)?s.tangent.values:void 0,h=c(s.st)?s.st.values:void 0,d=u.indices,p=K(u),T=K(u),R=[];R.length=l.length/3;var A=[];for(A.length=l.length/3,i=0;i<R.length;++i)R[i]=-1,A[i]=-1;var _=d.length;for(i=0;i<_;i+=3){var y=d[i],S=d[i+1],N=d[i+2],C=o.fromArray(l,3*y),v=o.fromArray(l,3*S),g=o.fromArray(l,3*N),I=Y(C,v,g);if(c(I)&&I.positions.length>3)for(var M=I.positions,O=I.indices,L=O.length,F=0;F<L;++F){var P=O[F],w=M[P];w.y<0?(r=T.attributes,t=T.indices,n=R):(r=p.attributes,t=p.indices,n=A),a=Q(r,t,n,d,P<3?i+P:-1,w),j(y,S,N,w,l,E,f,m,h,r,a)}else c(I)&&(C=I.positions[0],v=I.positions[1],g=I.positions[2]),C.y<0?(r=T.attributes,t=T.indices,n=R):(r=p.attributes,t=p.indices,n=A),a=Q(r,t,n,d,i,C),j(y,S,N,C,l,E,f,m,h,r,a),a=Q(r,t,n,d,i+1,v),j(y,S,N,v,l,E,f,m,h,r,a),a=Q(r,t,n,d,i+2,g),j(y,S,N,g,l,E,f,m,h,r,a)}Z(e,T,p)}function $(e){var r,t=e.geometry,n=t.attributes,a=n.position.values,i=t.indices,u=K(t),s=K(t),l=i.length,E=[];E.length=a.length/3;var f=[];for(f.length=a.length/3,r=0;r<E.length;++r)E[r]=-1,f[r]=-1;for(r=0;r<l;r+=2){var m=i[r],h=i[r+1],d=o.fromArray(a,3*m,Ie),p=o.fromArray(a,3*h,Me);Math.abs(d.y)<_.EPSILON6&&(d.y<0?d.y=-_.EPSILON6:d.y=_.EPSILON6),Math.abs(p.y)<_.EPSILON6&&(p.y<0?p.y=-_.EPSILON6:p.y=_.EPSILON6);var T=u.attributes,R=u.indices,y=f,S=s.attributes,N=s.indices,C=E,v=A.lineSegmentPlane(d,p,De,Oe);if(c(v)){var g=o.multiplyByScalar(o.UNIT_Y,5*_.EPSILON9,xe);d.y<0&&(o.negate(g,g),T=s.attributes,R=s.indices,y=E,S=u.attributes,N=u.indices,C=f);var I=o.add(v,g,Ue);Q(T,R,y,i,r,d),Q(T,R,y,i,-1,I),o.negate(g,g),o.add(v,g,I),Q(S,N,C,i,-1,I),Q(S,N,C,i,r+1,p)}else{var M,O,L;d.y<0?(M=s.attributes,O=s.indices,L=E):(M=u.attributes,O=u.indices,L=f),Q(M,O,L,i,r,d),Q(M,O,L,i,r+1,p)}}Z(e,s,u)}function ee(e){for(var r=e.attributes,t=r.position.values,n=r.prevPosition.values,a=r.nextPosition.values,i=t.length,u=0;u<i;u+=3){var s=o.unpack(t,u,Ge);if(!(s.x>0)){var c=o.unpack(n,u,ze);(s.y<0&&c.y>0||s.y>0&&c.y<0)&&(u-3>0?(n[u]=t[u-3],n[u+1]=t[u-2],n[u+2]=t[u-1]):o.pack(s,n,u));var l=o.unpack(a,u,Ve);(s.y<0&&l.y>0||s.y>0&&l.y<0)&&(u+3<i?(a[u]=t[u+3],a[u+1]=t[u+4],a[u+2]=t[u+5]):o.pack(s,a,u))}}}function re(e){var r,t,i,u=e.geometry,s=u.attributes,l=s.position.values,E=s.prevPosition.values,f=s.nextPosition.values,m=s.expandAndWidth.values,h=c(s.st)?s.st.values:void 0,d=c(s.color)?s.color.values:void 0,p=K(u),T=K(u),R=!1,y=l.length/3;for(r=0;r<y;r+=4){var S=r,N=r+2,C=o.fromArray(l,3*S,Ge),v=o.fromArray(l,3*N,ze);if(Math.abs(C.y)<ke)for(C.y=ke*(v.y<0?-1:1),l[3*r+1]=C.y,l[3*(r+1)+1]=C.y,t=3*S;t<3*S+12;t+=3)E[t]=l[3*r],E[t+1]=l[3*r+1],E[t+2]=l[3*r+2];if(Math.abs(v.y)<ke)for(v.y=ke*(C.y<0?-1:1),l[3*(r+2)+1]=v.y,l[3*(r+3)+1]=v.y,t=3*S;t<3*S+12;t+=3)f[t]=l[3*(r+2)],f[t+1]=l[3*(r+2)+1],f[t+2]=l[3*(r+2)+2];var g=p.attributes,I=p.indices,M=T.attributes,O=T.indices,L=A.lineSegmentPlane(C,v,De,He);if(c(L)){R=!0;var F=o.multiplyByScalar(o.UNIT_Y,Ye,We);C.y<0&&(o.negate(F,F),g=T.attributes,I=T.indices,M=p.attributes,O=p.indices);var P=o.add(L,F,qe);g.position.values.push(C.x,C.y,C.z,C.x,C.y,C.z),g.position.values.push(P.x,P.y,P.z),g.position.values.push(P.x,P.y,P.z),g.prevPosition.values.push(E[3*S],E[3*S+1],E[3*S+2]),g.prevPosition.values.push(E[3*S+3],E[3*S+4],E[3*S+5]),g.prevPosition.values.push(C.x,C.y,C.z,C.x,C.y,C.z),g.nextPosition.values.push(P.x,P.y,P.z),g.nextPosition.values.push(P.x,P.y,P.z),g.nextPosition.values.push(P.x,P.y,P.z),g.nextPosition.values.push(P.x,P.y,P.z),o.negate(F,F),o.add(L,F,P),M.position.values.push(P.x,P.y,P.z),M.position.values.push(P.x,P.y,P.z),M.position.values.push(v.x,v.y,v.z,v.x,v.y,v.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.nextPosition.values.push(v.x,v.y,v.z,v.x,v.y,v.z),M.nextPosition.values.push(f[3*N],f[3*N+1],f[3*N+2]),M.nextPosition.values.push(f[3*N+3],f[3*N+4],f[3*N+5]);var w=n.fromArray(m,2*S,be),D=Math.abs(w.y);g.expandAndWidth.values.push(-1,D,1,D),g.expandAndWidth.values.push(-1,-D,1,-D),M.expandAndWidth.values.push(-1,D,1,D),M.expandAndWidth.values.push(-1,-D,1,-D);var x=o.magnitudeSquared(o.subtract(L,C,Ve));if(x/=o.magnitudeSquared(o.subtract(v,C,Ve)),c(d)){var U=a.fromArray(d,4*S,Xe),b=a.fromArray(d,4*N,Xe),B=_.lerp(U.x,b.x,x),G=_.lerp(U.y,b.y,x),z=_.lerp(U.z,b.z,x),V=_.lerp(U.w,b.w,x);for(t=4*S;t<4*S+8;++t)g.color.values.push(d[t]);for(g.color.values.push(B,G,z,V),g.color.values.push(B,G,z,V),M.color.values.push(B,G,z,V),M.color.values.push(B,G,z,V),t=4*N;t<4*N+8;++t)M.color.values.push(d[t])}if(c(h)){var H=n.fromArray(h,2*S,be),W=n.fromArray(h,2*(r+3),Be),q=_.lerp(H.x,W.x,x);for(t=2*S;t<2*S+4;++t)g.st.values.push(h[t]);for(g.st.values.push(q,H.y),g.st.values.push(q,W.y),M.st.values.push(q,H.y),M.st.values.push(q,W.y),t=2*N;t<2*N+4;++t)M.st.values.push(h[t])}i=g.position.values.length/3-4,I.push(i,i+2,i+1),I.push(i+1,i+2,i+3),i=M.position.values.length/3-4,O.push(i,i+2,i+1),O.push(i+1,i+2,i+3)}else{var X,Y;for(C.y<0?(X=T.attributes,Y=T.indices):(X=p.attributes,Y=p.indices),X.position.values.push(C.x,C.y,C.z),X.position.values.push(C.x,C.y,C.z),X.position.values.push(v.x,v.y,v.z),X.position.values.push(v.x,v.y,v.z),t=3*r;t<3*r+12;++t)X.prevPosition.values.push(E[t]),X.nextPosition.values.push(f[t]);for(t=2*r;t<2*r+8;++t)X.expandAndWidth.values.push(m[t]),c(h)&&X.st.values.push(h[t]);if(c(d))for(t=4*r;t<4*r+16;++t)X.color.values.push(d[t]);i=X.position.values.length/3-4,Y.push(i,i+2,i+1),Y.push(i+1,i+2,i+3)}}R&&(ee(T),ee(p)),Z(e,T,p)}var te={};te.toWireframe=function(e){var r=e.indices;if(c(r)){switch(e.primitiveType){case C.TRIANGLES:e.indices=I(r);break;case C.TRIANGLE_STRIP:e.indices=M(r);break;case C.TRIANGLE_FAN:e.indices=O(r);break;default:throw new l("geometry.primitiveType must be TRIANGLES, TRIANGLE_STRIP, or TRIANGLE_FAN.")}e.primitiveType=C.LINES}return e},te.createLineSegmentsForVectors=function(e,r,n){r=s(r,"normal"),n=s(n,1e4);for(var o=e.attributes.position.values,a=e.attributes[r].values,i=o.length,l=new Float64Array(2*i),E=0,f=0;f<i;f+=3)l[E++]=o[f],l[E++]=o[f+1],l[E++]=o[f+2],l[E++]=o[f]+a[f]*n,l[E++]=o[f+1]+a[f+1]*n,l[E++]=o[f+2]+a[f+2]*n;var d,p=e.boundingSphere;return c(p)&&(d=new t(p.center,p.radius+n)),new m({attributes:{position:new h({componentDatatype:u.DOUBLE,componentsPerAttribute:3,values:l})},primitiveType:C.LINES,boundingSphere:d})},te.createAttributeLocations=function(e){var r,t=["position","positionHigh","positionLow","position3DHigh","position3DLow","position2DHigh","position2DLow","pickColor","normal","st","binormal","tangent","compressedAttributes"],n=e.attributes,o={},a=0,i=t.length;
for(r=0;r<i;++r){var u=t[r];c(n[u])&&(o[u]=a++)}for(var s in n)n.hasOwnProperty(s)&&!c(o[s])&&(o[s]=a++);return o},te.reorderForPreVertexCache=function(e){var r=m.computeNumberOfVertices(e),t=e.indices;if(c(t)){for(var n=new Int32Array(r),o=0;o<r;o++)n[o]=-1;for(var a,i=t,s=i.length,l=T.createTypedArray(r,s),E=0,f=0,h=0;E<s;)a=n[i[E]],a!==-1?l[f]=a:(a=i[E],n[a]=h,l[f]=h,++h),++E,++f;e.indices=l;var d=e.attributes;for(var p in d)if(d.hasOwnProperty(p)&&c(d[p])&&c(d[p].values)){for(var R=d[p],A=R.values,_=0,y=R.componentsPerAttribute,S=u.createTypedArray(R.componentDatatype,h*y);_<r;){var N=n[_];if(N!==-1)for(o=0;o<y;o++)S[y*N+o]=A[y*_+o];++_}R.values=S}}return e},te.reorderForPostVertexCache=function(e,r){var t=e.indices;if(e.primitiveType===C.TRIANGLES&&c(t)){for(var n=t.length,o=0,a=0;a<n;a++)t[a]>o&&(o=t[a]);e.indices=v.tipsify({indices:t,maximumIndex:o,cacheSize:r})}return e},te.fitToUnsignedShortIndices=function(e){var r=[],t=m.computeNumberOfVertices(e);if(c(e.indices)&&t>=_.SIXTY_FOUR_KILOBYTES){var n,o=[],a=[],i=0,u=L(e.attributes),s=e.indices,l=s.length;e.primitiveType===C.TRIANGLES?n=3:e.primitiveType===C.LINES?n=2:e.primitiveType===C.POINTS&&(n=1);for(var E=0;E<l;E+=n){for(var f=0;f<n;++f){var h=s[E+f],d=o[h];c(d)||(d=i++,o[h]=d,F(u,e.attributes,h)),a.push(d)}i+n>=_.SIXTY_FOUR_KILOBYTES&&(r.push(new m({attributes:u,indices:a,primitiveType:e.primitiveType,boundingSphere:e.boundingSphere,boundingSphereCV:e.boundingSphereCV})),o=[],a=[],i=0,u=L(e.attributes))}0!==a.length&&r.push(new m({attributes:u,indices:a,primitiveType:e.primitiveType,boundingSphere:e.boundingSphere,boundingSphereCV:e.boundingSphereCV}))}else r.push(e);return r};var ne=new o,oe=new i;te.projectTo2D=function(e,r,t,n,a){var i=e.attributes[r];a=c(a)?a:new f;for(var s=a.ellipsoid,E=i.values,m=new Float64Array(E.length),d=0,p=0;p<E.length;p+=3){var T=o.fromArray(E,p,ne),R=s.cartesianToCartographic(T,oe);if(!c(R))throw new l("Could not project point ("+T.x+", "+T.y+", "+T.z+") to 2D.");var A=a.project(R,ne);m[d++]=A.x,m[d++]=A.y,m[d++]=A.z}return e.attributes[t]=i,e.attributes[n]=new h({componentDatatype:u.DOUBLE,componentsPerAttribute:3,values:m}),delete e.attributes[r],e};var ae={high:0,low:0};te.encodeAttribute=function(e,r,t,n){for(var o=e.attributes[r],a=o.values,i=a.length,s=new Float32Array(i),c=new Float32Array(i),l=0;l<i;++l)E.encode(a[l],ae),s[l]=ae.high,c[l]=ae.low;var f=o.componentsPerAttribute;return e.attributes[t]=new h({componentDatatype:u.FLOAT,componentsPerAttribute:f,values:s}),e.attributes[n]=new h({componentDatatype:u.FLOAT,componentsPerAttribute:f,values:c}),delete e.attributes[r],e};var ie=new o,ue=new S,se=new y;te.transformToWorldCoordinates=function(e){var r=e.modelMatrix;if(S.equals(r,S.IDENTITY))return e;var n=e.geometry.attributes;P(r,n.position),P(r,n.prevPosition),P(r,n.nextPosition),(c(n.normal)||c(n.binormal)||c(n.tangent))&&(S.inverse(r,ue),S.transpose(ue,ue),S.getRotation(ue,se),w(se,n.normal),w(se,n.binormal),w(se,n.tangent));var o=e.geometry.boundingSphere;return c(o)&&(e.geometry.boundingSphere=t.transform(o,r,o)),e.modelMatrix=S.clone(S.IDENTITY),e};var ce=new o;te.combineInstances=function(e){for(var r=[],t=[],n=e.length,o=0;o<n;++o){var a=e[o];c(a.geometry)?r.push(a):c(a.westHemisphereGeometry)&&c(a.eastHemisphereGeometry)&&t.push(a)}var i=[];return r.length>0&&i.push(x(r,"geometry")),t.length>0&&(i.push(x(t,"westHemisphereGeometry")),i.push(x(t,"eastHemisphereGeometry"))),i};var le=new o,Ee=new o,fe=new o,me=new o;te.computeNormal=function(e){for(var r=e.indices,t=e.attributes,n=t.position.values,a=t.position.values.length/3,i=r.length,s=new Array(a),c=new Array(i/3),l=new Array(i),E=0;E<a;E++)s[E]={indexOffset:0,count:0,currentCount:0};var f=0;for(E=0;E<i;E+=3){var m=r[E],d=r[E+1],p=r[E+2],T=3*m,R=3*d,A=3*p;Ee.x=n[T],Ee.y=n[T+1],Ee.z=n[T+2],fe.x=n[R],fe.y=n[R+1],fe.z=n[R+2],me.x=n[A],me.y=n[A+1],me.z=n[A+2],s[m].count++,s[d].count++,s[p].count++,o.subtract(fe,Ee,fe),o.subtract(me,Ee,me),c[f]=o.cross(fe,me,new o),f++}var _=0;for(E=0;E<a;E++)s[E].indexOffset+=_,_+=s[E].count;f=0;var y;for(E=0;E<i;E+=3){y=s[r[E]];var S=y.indexOffset+y.currentCount;l[S]=f,y.currentCount++,y=s[r[E+1]],S=y.indexOffset+y.currentCount,l[S]=f,y.currentCount++,y=s[r[E+2]],S=y.indexOffset+y.currentCount,l[S]=f,y.currentCount++,f++}var N=new Float32Array(3*a);for(E=0;E<a;E++){var C=3*E;if(y=s[E],y.count>0){for(o.clone(o.ZERO,le),f=0;f<y.count;f++)o.add(le,c[l[y.indexOffset+f]],le);o.normalize(le,le),N[C]=le.x,N[C+1]=le.y,N[C+2]=le.z}else N[C]=0,N[C+1]=0,N[C+2]=1}return e.attributes.normal=new h({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:N}),e};var he=new o,de=new o,pe=new o;te.computeBinormalAndTangent=function(e){for(var r=(e.attributes,e.indices),t=e.attributes.position.values,n=e.attributes.normal.values,a=e.attributes.st.values,i=e.attributes.position.values.length/3,s=r.length,c=new Array(3*i),l=0;l<c.length;l++)c[l]=0;var E,f,m;for(l=0;l<s;l+=3){var d=r[l],p=r[l+1],T=r[l+2];E=3*d,f=3*p,m=3*T;var R=2*d,A=2*p,_=2*T,y=t[E],S=t[E+1],N=t[E+2],C=a[R],v=a[R+1],g=a[A+1]-v,I=a[_+1]-v,M=1/((a[A]-C)*I-(a[_]-C)*g),O=(I*(t[f]-y)-g*(t[m]-y))*M,L=(I*(t[f+1]-S)-g*(t[m+1]-S))*M,F=(I*(t[f+2]-N)-g*(t[m+2]-N))*M;c[E]+=O,c[E+1]+=L,c[E+2]+=F,c[f]+=O,c[f+1]+=L,c[f+2]+=F,c[m]+=O,c[m+1]+=L,c[m+2]+=F}var P=new Float32Array(3*i),w=new Float32Array(3*i);for(l=0;l<i;l++){E=3*l,f=E+1,m=E+2;var D=o.fromArray(n,E,he),x=o.fromArray(c,E,pe),U=o.dot(D,x);o.multiplyByScalar(D,U,de),o.normalize(o.subtract(x,de,x),x),w[E]=x.x,w[f]=x.y,w[m]=x.z,o.normalize(o.cross(D,x,x),x),P[E]=x.x,P[f]=x.y,P[m]=x.z}return e.attributes.tangent=new h({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:w}),e.attributes.binormal=new h({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:P}),e};var Te=new n,Re=new o,Ae=new o,_e=new o;te.compressVertices=function(r){var t=r.attributes.normal,a=r.attributes.st;if(!c(t)&&!c(a))return r;var i,s,l,E,f=r.attributes.tangent,m=r.attributes.binormal;c(t)&&(i=t.values),c(a)&&(s=a.values),c(f)&&(l=f.values),m&&(E=m.values);var d=c(i)?i.length:s.length,p=c(i)?3:2,T=d/p,R=T,A=c(s)&&c(i)?2:1;A+=c(l)||c(E)?1:0,R*=A;for(var _=new Float32Array(R),y=0,S=0;S<T;++S){c(s)&&(n.fromArray(s,2*S,Te),_[y++]=e.compressTextureCoordinates(Te));var N=3*S;c(i)&&c(l)&&c(E)?(o.fromArray(i,N,Re),o.fromArray(l,N,Ae),o.fromArray(E,N,_e),e.octPack(Re,Ae,_e,Te),_[y++]=Te.x,_[y++]=Te.y):(c(i)&&(o.fromArray(i,N,Re),_[y++]=e.octEncodeFloat(Re)),c(l)&&(o.fromArray(l,N,Re),_[y++]=e.octEncodeFloat(Re)),c(E)&&(o.fromArray(E,N,Re),_[y++]=e.octEncodeFloat(Re)))}return r.attributes.compressedAttributes=new h({componentDatatype:u.FLOAT,componentsPerAttribute:A,values:_}),c(i)&&delete r.attributes.normal,c(s)&&delete r.attributes.st,c(l)&&delete r.attributes.tangent,c(E)&&delete r.attributes.binormal,r};var ye=new o,Se=new o,Ne=new o,Ce=new o,ve=new o,ge={positions:new Array(7),indices:new Array(9)},Ie=new o,Me=new o,Oe=new o,Le=new o,Fe=new n,Pe=new n,we=new n,De=N.fromPointNormal(o.ZERO,o.UNIT_Y),xe=new o,Ue=new o,be=new n,Be=new n,Ge=new o,ze=new o,Ve=new o,He=new o,We=new o,qe=new o,Xe=new a,Ye=5*_.EPSILON9,ke=_.EPSILON6;return te.splitLongitude=function(e){var r=e.geometry,n=r.boundingSphere;if(c(n)){var o=n.center.x-n.radius;if(o>0||t.intersectPlane(n,N.ORIGIN_ZX_PLANE)!==R.INTERSECTING)return e}if(r.geometryType!==p.NONE)switch(r.geometryType){case p.POLYLINES:re(e);break;case p.TRIANGLES:J(e);break;case p.LINES:$(e)}else H(r),r.primitiveType===C.TRIANGLES?J(e):r.primitiveType===C.LINES&&$(e);return e},te}),define("Core/WebMercatorProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./Math"],function(e,r,t,n,o,a,i,u){"use strict";function s(e){this._ellipsoid=t(e,i.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}return o(s.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),s.mercatorAngleToGeodeticLatitude=function(e){return u.PI_OVER_TWO-2*Math.atan(Math.exp(-e))},s.geodeticLatitudeToMercatorAngle=function(e){e>s.MaximumLatitude?e=s.MaximumLatitude:e<-s.MaximumLatitude&&(e=-s.MaximumLatitude);var r=Math.sin(e);return.5*Math.log((1+r)/(1-r))},s.MaximumLatitude=s.mercatorAngleToGeodeticLatitude(Math.PI),s.prototype.project=function(r,t){var o=this._semimajorAxis,a=r.longitude*o,i=s.geodeticLatitudeToMercatorAngle(r.latitude)*o,u=r.height;return n(t)?(t.x=a,t.y=i,t.z=u,t):new e(a,i,u)},s.prototype.unproject=function(e,t){var o=this._oneOverSemimajorAxis,a=e.x*o,i=s.mercatorAngleToGeodeticLatitude(e.y*o),u=e.z;return n(t)?(t.longitude=a,t.latitude=i,t.height=u,t):new r(a,i,u)},s}),define("Scene/PrimitivePipeline",["../Core/BoundingSphere","../Core/Color","../Core/ComponentDatatype","../Core/defaultValue","../Core/defined","../Core/DeveloperError","../Core/Ellipsoid","../Core/FeatureDetection","../Core/GeographicProjection","../Core/Geometry","../Core/GeometryAttribute","../Core/GeometryAttributes","../Core/GeometryPipeline","../Core/IndexDatatype","../Core/Matrix4","../Core/WebMercatorProjection"],function(e,r,t,n,o,a,i,u,s,c,l,E,f,m,h,d){"use strict";function p(e,r,t){var n,a=!t,i=e.length;if(!a&&i>1){var u=e[0].modelMatrix;for(n=1;n<i;++n)if(!h.equals(u,e[n].modelMatrix)){a=!0;break}}if(a)for(n=0;n<i;++n)o(e[n].geometry)&&f.transformToWorldCoordinates(e[n]);else h.multiplyTransformation(r,e[0].modelMatrix,r)}function T(e,r){var n=e.attributes,o=n.position,a=o.values.length/o.componentsPerAttribute;n.batchId=new l({componentDatatype:t.FLOAT,componentsPerAttribute:1,values:new Float32Array(a)});for(var i=n.batchId.values,u=0;u<a;++u)i[u]=r}function R(e){for(var r=e.length,t=0;t<r;++t){var n=e[t];o(n.geometry)?T(n.geometry,t):o(n.westHemisphereGeometry)&&o(n.eastHemisphereGeometry)&&(T(n.westHemisphereGeometry,t),T(n.eastHemisphereGeometry,t))}}function A(r){var n,a,i,u=r.instances,s=r.projection,c=r.elementIndexUintSupported,l=r.scene3DOnly,E=r.vertexCacheOptimize,m=r.compressVertices,h=r.modelMatrix,d=u.length;for(n=0;n<d;++n)if(o(u[n].geometry)){i=u[n].geometry.primitiveType;break}if(p(u,h,l),!l)for(n=0;n<d;++n)o(u[n].geometry)&&f.splitLongitude(u[n]);if(R(u),E)for(n=0;n<d;++n){var T=u[n];o(T.geometry)?(f.reorderForPostVertexCache(T.geometry),f.reorderForPreVertexCache(T.geometry)):o(T.westHemisphereGeometry)&&o(T.eastHemisphereGeometry)&&(f.reorderForPostVertexCache(T.westHemisphereGeometry),f.reorderForPreVertexCache(T.westHemisphereGeometry),f.reorderForPostVertexCache(T.eastHemisphereGeometry),f.reorderForPreVertexCache(T.eastHemisphereGeometry))}var A=f.combineInstances(u);for(d=A.length,n=0;n<d;++n){a=A[n];var _,y=a.attributes;if(l)for(_ in y)y.hasOwnProperty(_)&&y[_].componentDatatype===t.DOUBLE&&f.encodeAttribute(a,_,_+"3DHigh",_+"3DLow");else for(_ in y)if(y.hasOwnProperty(_)&&y[_].componentDatatype===t.DOUBLE){var S=_+"3D",N=_+"2D";f.projectTo2D(a,_,S,N,s),o(a.boundingSphere)&&"position"===_&&(a.boundingSphereCV=e.fromVertices(a.attributes.position2D.values)),f.encodeAttribute(a,S,S+"High",S+"Low"),f.encodeAttribute(a,N,N+"High",N+"Low")}m&&f.compressVertices(a)}if(!c){var C=[];for(d=A.length,n=0;n<d;++n)a=A[n],C=C.concat(f.fitToUnsignedShortIndices(a));A=C}return A}function _(e,r,t,n){var a,i,u,s=n.length-1;if(s>=0){var c=n[s];a=c.offset+c.count,u=c.index,i=t[u].indices.length}else a=0,u=0,i=t[u].indices.length;for(var l=e.length,E=0;E<l;++E){var f=e[E],m=f[r];if(o(m)){var h=m.indices.length;a+h>i&&(a=0,i=t[++u].indices.length),n.push({index:u,offset:a,count:h}),a+=h}}}function y(e,r){var t=[];return _(e,"geometry",r,t),_(e,"westHemisphereGeometry",r,t),_(e,"eastHemisphereGeometry",r,t),t}function S(e,r){var t=e.attributes;for(var n in t)if(t.hasOwnProperty(n)){var a=t[n];o(a)&&o(a.values)&&r.push(a.values.buffer)}o(e.indices)&&r.push(e.indices.buffer)}function N(e,r){for(var t=e.length,n=0;n<t;++n)S(e[n],r)}function C(r){for(var t=1,n=r.length,a=0;a<n;a++){var i=r[a];if(++t,o(i)){var u=i.attributes;t+=6+2*e.packedLength+(o(i.indices)?i.indices.length:0);for(var s in u)if(u.hasOwnProperty(s)&&o(u[s])){var c=u[s];t+=5+c.values.length}}}return t}function v(e,r){var t=e.length,n=new Float64Array(1+16*t),o=0;n[o++]=t;for(var a=0;a<t;a++){var i=e[a];h.pack(i.modelMatrix,n,o),o+=h.packedLength}return r.push(n.buffer),n}function g(e){for(var r=e,t=new Array(r[0]),n=0,o=1;o<r.length;){var a=h.unpack(r,o);o+=h.packedLength,t[n++]={modelMatrix:a}}return t}function I(r){var t=r.length,n=1+(e.packedLength+1)*t,a=new Float32Array(n),i=0;a[i++]=t;for(var u=0;u<t;++u){var s=r[u];o(s)?(a[i++]=1,e.pack(r[u],a,i)):a[i++]=0,i+=e.packedLength}return a}function M(r){for(var t=new Array(r[0]),n=0,o=1;o<r.length;)1===r[o++]&&(t[n++]=e.unpack(r,o)),o+=e.packedLength;return t}if(!u.supportsTypedArrays())return{};var O={};return O.combineGeometry=function(r){var t,n,a=r.instances,i=a.length;i>0&&(t=A(r),t.length>0&&(n=f.createAttributeLocations(t[0])));var u;r.createPickOffsets&&t.length>0&&(u=y(a,t));for(var s=new Array(i),c=new Array(i),l=0;l<i;++l){var E=a[l],m=E.geometry;o(m)&&(s[l]=m.boundingSphere,c[l]=m.boundingSphereCV);var h=E.eastHemisphereGeometry,d=E.westHemisphereGeometry;o(h)&&o(d)&&(o(h.boundingSphere)&&o(d.boundingSphere)&&(s[l]=e.union(h.boundingSphere,d.boundingSphere)),o(h.boundingSphereCV)&&o(d.boundingSphereCV)&&(c[l]=e.union(h.boundingSphereCV,d.boundingSphereCV)))}return{geometries:t,modelMatrix:r.modelMatrix,attributeLocations:n,pickOffsets:u,boundingSpheres:s,boundingSpheresCV:c}},O.packCreateGeometryResults=function(r,t){var n=new Float64Array(C(r)),a=[],i={},u=r.length,s=0;n[s++]=u;for(var c=0;c<u;c++){var l=r[c],E=o(l);if(n[s++]=E?1:0,E){n[s++]=l.primitiveType,n[s++]=l.geometryType;var f=o(l.boundingSphere)?1:0;n[s++]=f,f&&e.pack(l.boundingSphere,n,s),s+=e.packedLength;var m=o(l.boundingSphereCV)?1:0;n[s++]=m,m&&e.pack(l.boundingSphereCV,n,s),s+=e.packedLength;var h=l.attributes,d=[];for(var p in h)h.hasOwnProperty(p)&&o(h[p])&&(d.push(p),o(i[p])||(i[p]=a.length,a.push(p)));n[s++]=d.length;for(var T=0;T<d.length;T++){var R=d[T],A=h[R];n[s++]=i[R],n[s++]=A.componentDatatype,n[s++]=A.componentsPerAttribute,n[s++]=A.normalize?1:0,n[s++]=A.values.length,n.set(A.values,s),s+=A.values.length}var _=o(l.indices)?l.indices.length:0;n[s++]=_,_>0&&(n.set(l.indices,s),s+=_)}}return t.push(n.buffer),{stringTable:a,packedData:n}},O.unpackCreateGeometryResults=function(r){for(var n,o=r.stringTable,a=r.packedData,i=new Array(a[0]),u=0,s=1;s<a.length;){var f=1===a[s++];if(f){var h,d,p=a[s++],T=a[s++],R=1===a[s++];R&&(h=e.unpack(a,s)),s+=e.packedLength;var A=1===a[s++];A&&(d=e.unpack(a,s)),s+=e.packedLength;var _,y,S,N=new E,C=a[s++];for(n=0;n<C;n++){var v=o[a[s++]],g=a[s++];S=a[s++];var I=0!==a[s++];_=a[s++],y=t.createTypedArray(g,_);for(var M=0;M<_;M++)y[M]=a[s++];N[v]=new l({componentDatatype:g,componentsPerAttribute:S,normalize:I,values:y})}var O;if(_=a[s++],_>0){var L=y.length/S;for(O=m.createTypedArray(L,_),n=0;n<_;n++)O[n]=a[s++]}i[u++]=new c({primitiveType:p,geometryType:T,boundingSphere:h,boundingSphereCV:d,indices:O,attributes:N})}else i[u++]=void 0}return i},O.packCombineGeometryParameters=function(e,r){for(var t=e.createGeometryResults,n=t.length,o=0;o<n;o++)r.push(t[o].packedData.buffer);return{createGeometryResults:e.createGeometryResults,packedInstances:v(e.instances,r),ellipsoid:e.ellipsoid,isGeographic:e.projection instanceof s,elementIndexUintSupported:e.elementIndexUintSupported,scene3DOnly:e.scene3DOnly,vertexCacheOptimize:e.vertexCacheOptimize,compressVertices:e.compressVertices,modelMatrix:e.modelMatrix,createPickOffsets:e.createPickOffsets}},O.unpackCombineGeometryParameters=function(e){for(var r=g(e.packedInstances),t=e.createGeometryResults,n=t.length,o=0,a=0;a<n;a++)for(var u=O.unpackCreateGeometryResults(t[a]),c=u.length,l=0;l<c;l++){var E=u[l],f=r[o];f.geometry=E,++o}var m=i.clone(e.ellipsoid),p=e.isGeographic?new s(m):new d(m);return{instances:r,ellipsoid:m,projection:p,elementIndexUintSupported:e.elementIndexUintSupported,scene3DOnly:e.scene3DOnly,vertexCacheOptimize:e.vertexCacheOptimize,compressVertices:e.compressVertices,modelMatrix:h.clone(e.modelMatrix),createPickOffsets:e.createPickOffsets}},O.packCombineGeometryResults=function(e,r){o(e.geometries)&&N(e.geometries,r);var t=I(e.boundingSpheres),n=I(e.boundingSpheresCV);return r.push(t.buffer,n.buffer),{geometries:e.geometries,attributeLocations:e.attributeLocations,modelMatrix:e.modelMatrix,pickOffsets:e.pickOffsets,boundingSpheres:t,boundingSpheresCV:n}},O.unpackCombineGeometryResults=function(e){return{geometries:e.geometries,attributeLocations:e.attributeLocations,modelMatrix:e.modelMatrix,pickOffsets:e.pickOffsets,boundingSpheres:M(e.boundingSpheres),boundingSpheresCV:M(e.boundingSpheresCV)}},O}),define("Core/formatError",["./defined"],function(e){"use strict";function r(r){var t,n=r.name,o=r.message;t=e(n)&&e(o)?n+": "+o:r.toString();var a=r.stack;return e(a)&&(t+="\n"+a),t}return r}),define("Workers/createTaskProcessorWorker",["../Core/defaultValue","../Core/defined","../Core/formatError"],function(e,r,t){"use strict";function n(n){var o,a=[],i={id:void 0,result:void 0,error:void 0};return function(u){var s=u.data;a.length=0,i.id=s.id,i.error=void 0,i.result=void 0;try{i.result=n(s.parameters,a)}catch(e){e instanceof Error?i.error={name:e.name,message:e.message,stack:e.stack}:i.error=e}r(o)||(o=e(self.webkitPostMessage,self.postMessage)),s.canTransferArrayBuffer||(a.length=0);try{o(i,a)}catch(e){i.result=void 0,i.error="postMessage failed with error: "+t(e)+"\n  with responseMessage: "+JSON.stringify(i),o(i)}}}return n}),define("Workers/combineGeometry",["../Scene/PrimitivePipeline","./createTaskProcessorWorker"],function(e,r){"use strict";function t(r,t){var n=e.unpackCombineGeometryParameters(r),o=e.combineGeometry(n);return e.packCombineGeometryResults(o,t)}return r(t)})}();